VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Dictionary"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IDictionary
Implements IReadOnlyCollection
Implements IEnumerable
Implements IDirtyKeySupport
Implements ICloneable

Private m_Data As IDictionary

Private Sub Class_Initialize()
    Set m_Data = New InternalDictionary
End Sub

Friend Sub Initialize(ByVal data As IDictionary)
    Set m_Data = data
End Sub

Private Function ICloneable_Clone() As Object
    Dim ICloneable As ICloneable
    
    Set ICloneable = m_Data
    
    Dim Temp As New Dictionary
    
    Call Temp.Initialize(ICloneable.Clone)

    Set ICloneable_Clone = Temp
End Function

Private Function IDictionary_TryGetValue(ByVal Key As Variant, Value As Variant) As Boolean
    IDictionary_TryGetValue = TryGetValue(Key, Value)
End Function

'Private Sub IReadOnlyCollection_Add(Item As Variant)
'    Call Me.Add(vbNullString, Item)
'End Sub
'
'Private Sub IReadOnlyCollection_Clear()
'    Call Me.Clear
'End Sub
'
'Private Property Get IReadOnlyCollection_IsReadOnly() As Boolean
'    IReadOnlyCollection_IsReadOnly = m_Data.IsReadOnly
'End Property
'
'Private Function IReadOnlyCollection_Remove(Value As Variant) As Boolean
'    Call Me.Remove(Value)
'End Function
'
'Private Function IReadOnlyCollection_Contains(Item As Variant) As Boolean
'    IReadOnlyCollection_Contains = Me.ContainsValue(Item)
'End Function

Private Sub IReadOnlyCollection_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call m_Data.CopyTo(arrayTo, index)
End Sub

Private Property Get IReadOnlyCollection_Count() As Long
    IReadOnlyCollection_Count = m_Data.Count
End Property

Private Function IReadOnlyCollection_GetEnumerator() As IEnumerator
    Set IReadOnlyCollection_GetEnumerator = Me.GetEnumerator
End Function

Private Sub IDictionary_Add(ByVal Key As Variant, Value As Variant)
    Call m_Data.Add(Key, Value)
End Sub

Private Sub IDictionary_Clear()
    Call m_Data.Clear
End Sub

Private Function IDictionary_ContainsKey(ByVal Key As Variant) As Boolean
    IDictionary_ContainsKey = m_Data.ContainsKey(Key)
End Function

Private Sub IDictionary_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call m_Data.CopyTo(arrayTo, index)
End Sub

Private Property Get IDictionary_Count() As Long
    IDictionary_Count = m_Data.Count
End Property

Private Function IDictionary_GetEnumerator() As IDictionaryEnumerator
    Dim Enumerator As Enumerator
    
    Set Enumerator = m_Data.GetEnumerator
    
    Enumerator.UseDictionaryEntry = True
    
    Set IDictionary_GetEnumerator = Enumerator
End Function

Private Property Get IDictionary_IsFixedSize() As Boolean
    IDictionary_IsFixedSize = m_Data.IsFixedSize
End Property

Private Property Get IDictionary_IsReadOnly() As Boolean
    IDictionary_IsReadOnly = m_Data.IsReadOnly
End Property

Private Property Set IDictionary_Item(ByVal index As Variant, ByVal RHS As Object)
    Set m_Data.Item(index) = RHS
End Property

Private Property Let IDictionary_Item(ByVal index As Variant, ByVal RHS As Variant)
    m_Data.Item(index) = RHS
End Property

Private Property Get IDictionary_Item(ByVal index As Variant) As Variant
    Call SwapVar(IDictionary_Item, m_Data.Item(index))
End Property

Private Property Get IDictionary_Keys() As IReadOnlyCollection
    Set IDictionary_Keys = m_Data.Keys
End Property

Private Sub IDictionary_Remove(ByVal Key As Variant)
    Call m_Data.Remove(Key)
End Sub

Private Property Get IDictionary_Values() As IReadOnlyCollection
    Set IDictionary_Values = m_Data.Values
End Property

'Public Sub Add(ByVal Key As String, Value As Variant)
'    Call m_Data.Add(Key, Value)
'End Sub
'
'Public Sub Clear()
'    Call m_Data.Clear
'End Sub

'Public Function ContainsValue(Item As Variant) As Boolean
'    Call m_Data.ContainsValue(Item)
'End Function

'Public Function ContainsKey(ByVal Key As String) As Boolean
'    ContainsKey = m_Data.ContainsKey(Key)
'End Function

Public Sub CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call m_Data.CopyTo(arrayTo, index)
End Sub

Public Sub Add(ByVal Key As String, Value As Variant)
    Call m_Data.Add(Key, Value)
End Sub

Public Sub Clear()
    Call m_Data.Clear
End Sub

Public Property Get Count() As Long
    Count = m_Data.Count
End Property

'Public Function GetDictionaryEnumerator() As IDictionaryEnumerator
'    Dim Enumerator As Enumerator
'
'    Set Enumerator = m_Data.GetEnumerator
'
'    Enumerator.UseDictionaryEntry = True
'
'    Set GetEnumerator = Enumerator
'End Function

Public Function GetEnumerator() As IEnumerator
Attribute GetEnumerator.VB_UserMemId = -4
    Dim Enumerable As IEnumerable
    
    Set Enumerable = m_Data
    Set GetEnumerator = Enumerable.GetEnumerator
End Function

Public Function GetEntryEnumerator() As IDictionaryEnumerator
    Dim Enumerable As IDictionary
    
    Set Enumerable = m_Data
    Set GetEntryEnumerator = Enumerable.GetEnumerator
End Function

Public Function ContainsKey(ByVal Key As String) As Boolean
    ContainsKey = m_Data.ContainsKey(Key)
End Function

Public Function ContainsValue(Value As Variant) As Boolean
    Dim Item As Variant
    
    For Each Item In m_Data
        If Item = Value Then
            ContainsValue = True
            
            Exit Function
        End If
    Next
End Function

'Public Property Get IsFixedSize() As Boolean
'    IsFixedSize = m_Data.IsFixedSize
'End Property
'
'Public Property Get IsReadOnly() As Boolean
'    IsReadOnly = m_Data.IsReadOnly
'End Property

Public Property Set Item(ByVal index As Variant, ByVal RHS As Object)
    Set m_Data.Item(index) = RHS
End Property

Public Property Let Item(ByVal index As Variant, ByVal RHS As Variant)
    m_Data.Item(index) = RHS
End Property

Public Property Get Item(ByVal index As Variant) As Variant
Attribute Item.VB_UserMemId = 0
    Call SwapVar(Item, m_Data.Item(index))
End Property

Public Property Get Keys() As KeyCollection
    Set Keys = New KeyCollection

    Call Keys.Init(m_Data.Keys)
End Property

Public Function Remove(ByVal Key As Variant) As Boolean
    Call m_Data.Remove(Key)
End Function

'Public Sub Fill(ByVal List As IDictionary)
'
'End Sub

'Public Property Get Comparer() As IEqualityComparer
'
'End Property

'Public Function RemoveByKey(ByVal Key As String) As Boolean
'    RemoveByKey = m_Data.RemoveByKey(Key)
'End Function
'
'Public Function RemoveByValue(Item As Variant) As Boolean
'    RemoveByValue = m_Data.RemoveByValue(Item)
'End Function

Public Function TryGetValue(ByVal Key As String, Value As Variant) As Boolean
'    TryGetValue = m_Data.TryGetValue(Key, Value)
    
    If m_Data.ContainsKey(Key) Then
        Call SwapVar(Value, m_Data.Item(Key))
    
        TryGetValue = True
    End If
End Function

Public Property Get Values() As ValueCollection
    Set Values = New ValueCollection

    Call Values.Init(m_Data.Values)
End Property

Private Sub IDirtyKeySupport_Clean()
    Dim DirtyKeyDictionary As IDirtyKeySupport
    
    Set DirtyKeyDictionary = m_Data
    
    Call DirtyKeyDictionary.Clean
End Sub

Private Property Get IDirtyKeySupport_DirtyKeys() As KeyCollection
    Dim DirtyKeyDictionary As IDirtyKeySupport
    
    Set DirtyKeyDictionary = m_Data
    
    Set IDirtyKeySupport_DirtyKeys = DirtyKeyDictionary.DirtyKeys
End Property

Private Property Get IDirtyKeySupport_DirtyValues() As ValueCollection
    Dim DirtyKeyDictionary As IDirtyKeySupport
    
    Set DirtyKeyDictionary = m_Data
    
    Set IDirtyKeySupport_DirtyValues = DirtyKeyDictionary.DirtyValues
End Property

Private Function IDirtyKeySupport_GetEnumerator() As IDictionaryEnumerator
    Dim DirtyKeyDictionary As IDirtyKeySupport
    
    Set DirtyKeyDictionary = m_Data
    
    Set IDirtyKeySupport_GetEnumerator = DirtyKeyDictionary.GetEnumerator
End Function

Private Function IDirtyKeySupport_IsDirty(Optional ByVal Key As Variant) As Boolean
    Dim DirtyKeyDictionary As IDirtyKeySupport
    
    Set DirtyKeyDictionary = m_Data
    
    IDirtyKeySupport_IsDirty = DirtyKeyDictionary.IsDirty(Key)
End Function

Private Function IEnumerable_GetEnumerator() As IEnumerator
    Set IEnumerable_GetEnumerator = Me.GetEnumerator
End Function
