VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "List"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IList
Implements IEnumerable
Implements IReadOnlyCollection
Implements ICollection
Implements ICloneable

Private m_Data As IDictionary

Private Sub Class_Initialize()
    Set m_Data = New InternalDictionary
End Sub

Friend Sub Initialize(ByVal data As IDictionary)
    Set m_Data = data
End Sub

Private Function ICloneable_Clone() As Object
    Dim ICloneable As ICloneable
    
    Set ICloneable = m_Data
    
    Dim Temp As New List
    
    Call Temp.Initialize(ICloneable.Clone)

    Set ICloneable_Clone = Temp
End Function

Private Function IEnumerable_GetEnumerator() As IEnumerator
    Set IEnumerable_GetEnumerator = Me.GetEnumerator
End Function

Private Function IList_Add(Item As Variant) As Long
    IList_Add = Me.Add(Item)
End Function

Private Sub IList_Clear()
    Call Me.Clear
End Sub

Private Function IList_Contains(Item As Variant) As Boolean
    IList_Contains = Me.Contains(Item)
End Function

Private Sub IList_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get IList_Count() As Long
    IList_Count = Me.Count
End Property

Private Function IList_GetEnumerator() As IEnumerator
    Set IList_GetEnumerator = Me.GetEnumerator
End Function

Private Function IList_IndexOf(Item As Variant) As Long
    IList_IndexOf = Me.IndexOf(Item)
End Function

Private Sub IList_Insert(ByVal index As Long, Item As Variant)
    Call Me.Insert(index, Item)
End Sub

Private Property Get IList_IsFixedSize() As Boolean
    IList_IsFixedSize = Me.IsFixedSize
End Property

Private Property Get IList_IsReadOnly() As Boolean
    IList_IsReadOnly = Me.IsReadOnly
End Property

Private Property Set IList_Item(ByVal index As Long, RHS As Object)
    Set Me.Item(index) = RHS
End Property

Private Property Let IList_Item(ByVal index As Long, RHS As Variant)
    Me.Item(index) = RHS
End Property

Private Property Get IList_Item(ByVal index As Long) As Variant
    Call SwapVar(IList_Item, Me.Item(index))
End Property

Private Sub IList_Remove(Item As Variant)
    Call Me.Remove(Item)
End Sub

Private Sub IList_RemoveAt(ByVal index As Long)
    Call Me.RemoveAt(index)
End Sub

Public Function Add(Item As Variant) As Long
    Call m_Data.Add(vbNullString, Item)
End Function

Public Sub Clear()
    Call m_Data.Clear
End Sub

Public Function Contains(Item As Variant) As Boolean
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data

    Contains = IntDic.ContainsValue(Item)
End Function

Public Sub CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call m_Data.CopyTo(arrayTo, index)
End Sub

Public Property Get Count() As Long
    Count = m_Data.Count
End Property

Public Function GetEnumerator() As IEnumerator
Attribute GetEnumerator.VB_UserMemId = -4
    Dim Enumerable As IEnumerable
    Set Enumerable = m_Data
    Set GetEnumerator = Enumerable.GetEnumerator
End Function

Public Function IndexOf(Item As Variant) As Long
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data

    IndexOf = IntDic.IndexOf(Item)
End Function

Public Sub Insert(ByVal index As Long, Item As Variant)
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data
    
    Call IntDic.Add(Item, , AddBeforePosition, index)
End Sub

Public Property Get IsFixedSize() As Boolean
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data

    IsFixedSize = IntDic.AddingAllowed = False
End Property

Public Property Get IsReadOnly() As Boolean
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data

    IsReadOnly = IntDic.AssigningAllowed = False
End Property

Public Property Set Item(ByVal index As Long, RHS As Object)
    Set m_Data.Item(index) = RHS
End Property

Public Property Let Item(ByVal index As Long, RHS As Variant)
    m_Data.Item(index) = RHS
End Property

Public Property Get Item(ByVal index As Long) As Variant
Attribute Item.VB_UserMemId = 0
    Call SwapVar(Item, m_Data.Item(index))
End Property

Public Sub Remove(Item As Variant)
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data

    Call IntDic.RemoveByValue(Item)
End Sub

Public Sub RemoveAt(ByVal index As Long)
    Dim IntDic As InternalDictionary
    
    Set IntDic = m_Data

    Call IntDic.Remove(index)
End Sub

Private Sub ICollection_Add(Item As Variant)
    Call Me.Add(Item)
End Sub

Private Sub ICollection_Clear()
    Call Me.Clear
End Sub

Private Property Set ICollection_Item(ByVal index As Long, ByVal RHS As Object)
    Set Me.Item(index) = RHS
End Property

Private Property Let ICollection_Item(ByVal index As Long, ByVal RHS As Variant)
    Me.Item(index) = RHS
End Property

Private Property Get ICollection_Item(ByVal index As Long) As Variant
    Call SwapVar(ICollection_Item, Me.Item(index))
End Property

Private Property Get ICollection_IsReadOnly() As Boolean
    ICollection_IsReadOnly = Me.IsReadOnly
End Property

Private Function ICollection_Remove(Value As Variant) As Boolean
    Call Me.Remove(Value)
End Function

Private Function ICollection_Contains(Item As Variant) As Boolean
    ICollection_Contains = Me.Contains(Item)
End Function

Private Sub ICollection_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get ICollection_Count() As Long
    ICollection_Count = Me.Count
End Property

Private Function ICollection_GetEnumerator() As IEnumerator
    Set ICollection_GetEnumerator = Me.GetEnumerator
End Function

Private Sub IReadOnlyCollection_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get IReadOnlyCollection_Count() As Long
    IReadOnlyCollection_Count = Me.Count
End Property

Private Function IReadOnlyCollection_GetEnumerator() As IEnumerator
    Set IReadOnlyCollection_GetEnumerator = Me.GetEnumerator
End Function

