VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Arrays"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GlobalAlloc Lib "kernel32.dll" ( _
     ByVal wFlags As Long, _
     ByVal dwBytes As Long) As Long

Public Enum QuicksortFlags
    Descending = 1
    Unsigned = 2
    ReferenceArray = 4
    Standard = 0
    Lexical = 8
    Ascii = 16
    UserDefinedCharMap = 24
End Enum

Public Type SAFE_ARRAY_BOUNDS ' 8 bytes
    Count As Long
    LBound   As Long
End Type

Public Type SAFE_ARRAY
    Dimensions As Integer
    Flags As Integer
    ItemSize As Long
    LockCounter As Long
    DataPtr As Long
    Bounds() As SAFE_ARRAY_BOUNDS
End Type

Private Type SAFE_ARRAY_1D
    Dimensions As Integer
    Flags As Integer
    ItemSize As Long
    LockCounter As Long
    DataPtr As Long
    Count As Long
    LBound   As Long
End Type

Private Declare Function SafeArrayCreateVector Lib "oleaut32.dll" ( _
     ByVal vt As Integer, _
     ByVal lLbound As Long, _
     ByVal cElements As Long) As Long

Public Enum SafeArrayFlags
    FADF_AUTO = &H1 '1
    FADF_STATIC = &H2 '2
    FADF_EMBEDDED = &H4 '4
    FADF_FIXEDSIZE = &H10 '16
    FADF_RECORD = &H20 '32
    FADF_HAVEIID = &H40 '64
    FADF_HAVEVARTYPE = &H80 '128
    FADF_BSTR = &H100 '256
    FADF_UNKNOWN = &H200 '512
    FADF_DISPATCH = &H400 '1024
    FADF_VARIANT = &H800 '2048
    FADF_RESERVED = &HF008 '&!!!!
End Enum

Public Function GetParamArrayElements(Args() As Variant) As Variant()
    Call SwapArrayPtr(GetParamArrayElements, mdlArray.GetParamArrayElements(Args))
End Function

Public Function ArrayContains(Values As Variant, ByVal Match As Variant) As Boolean '2012-12-28
    Dim i As Long
    
    For i = 0 To UBound(Values)
        If Values(i) = Match Then
            ArrayContains = True
            
            Exit For
        End If
    Next
End Function

Public Function StringArrayContains(Values() As String, ByVal Match As String) As Boolean '2012-12-28
    StringArrayContains = mdlString.StringArrayContains(Values, Match)
End Function

Public Sub MappArrayToString(ByRef ArrayTo As Variant, ByRef VarStr As Variant)
    Dim SA As SAFE_ARRAY_1D
    Dim pSa As Long
    
    If VarType(VarStr) <> vbString Then Error 0
    
    pSa = GetSafeArrayPtr(ArrayTo)
    
    If pSa = 0 Then
        pSa = SafeArrayCreateVector(VarType(ArrayTo) And Not vbArray, 0, LenB(VarStr) \ GetVarByteSize(VarType(ArrayTo)))

        Call RtlMoveMemory(ByVal DeRefPointer(VarPtr(ArrayTo) + 8), pSa)
    End If
    
    Call RtlMoveMemory(SA, ByVal pSa, Len(SA))
    
    With SA
        .DataPtr = StrPtr(VarStr)
        .Flags = FADF_HAVEVARTYPE Or FADF_AUTO Or FADF_FIXEDSIZE
        If .Count = 0 Then .Count = LenB(VarStr) \ .ItemSize
    End With
    
    Call RtlMoveMemory(ByVal pSa, SA, Len(SA))
End Sub

Public Function GetMappedArrayOfString(ByRef VarStr As Variant, Optional ByVal ArrayVarType As VbVarType = vbByte) As Variant
    Dim SA As SAFE_ARRAY_1D
    Dim pSa As Long
    
    If VarType(VarStr) <> vbString Then Error 0
    
    pSa = SafeArrayCreateVector(ArrayVarType, 0, LenB(VarStr) \ GetVarByteSize(ArrayVarType))
    
    Call RtlMoveMemory(SA, ByVal pSa, Len(SA))
    
    With SA
        .DataPtr = StrPtr(VarStr)
        .Flags = FADF_HAVEVARTYPE Or FADF_AUTO Or FADF_FIXEDSIZE
    End With
    
    Call RtlMoveMemory(ByVal pSa, SA, Len(SA))
    Call RtlMoveMemory(ByVal VarPtr(GetMappedArrayOfString) + 8, pSa)
    
    Call RtlMoveMemory(GetMappedArrayOfString, ArrayVarType Or vbArray, 2)
End Function

Public Function GetMappedIntegerArrayFromString(ByRef VarStr As Variant) As Integer()
    Dim SA As SAFE_ARRAY
    
    If VarType(VarStr) <> vbString Then Error 0
    
    ReDim GetMappedIntegerArrayFromString(0)
    
    SA = GetSafeArrayStruct(GetMappedIntegerArrayFromString)
    
    SA.DataPtr = StrPtr(VarStr)
    SA.Bounds(0).Count = Len(VarStr)
    
    Call SetSafeArrayStruct(GetMappedIntegerArrayFromString, SA)
End Function

Public Function GetMappedByteArrayFromString(ByRef VarStr As Variant) As Byte()
    Dim SA As SAFE_ARRAY
    
    If VarType(VarStr) <> vbString Then Error 0
    
    ReDim GetMappedByteArrayFromString(0)
    
    SA = GetSafeArrayStruct(GetMappedByteArrayFromString)
    
    SA.DataPtr = StrPtr(VarStr)
    SA.Bounds(0).Count = LenB(VarStr)
    
    Call SetSafeArrayStruct(GetMappedByteArrayFromString, SA)
End Function

Public Function ArrayExists(Arr As Variant, Value As Variant) As Boolean
    Dim i As Long
    
    For i = LBound(Arr) To UBound(Arr)
        If Arr(i) = Value Then
            ArrayExists = True
            
            Exit Function
        End If
    Next
End Function

Public Function ArrayIndexOf(Arr As Variant, Value As Variant) As Long
    Dim i As Long
    
    For i = LBound(Arr) To UBound(Arr)
        If Arr(i) = Value Then
            ArrayIndexOf = i
            
            Exit Function
        End If
    Next
    
    ArrayIndexOf = -1
End Function

Public Sub ArrayReverse(Arr As Variant, Optional ByVal index As Long = -1, Optional ByVal Length As Long)
    Dim i As Long
    Dim Upper As Long
    
    If index = -1 Then
        index = LBound(Arr)
    ElseIf index > UBound(Arr) Then
        Call Err.Raise(vbObjectError, "ArrayReverse", "index is higher than Ubound.")
    End If
    
    If Length < 1 Then
        Upper = UBound(Arr)
        Length = Upper - index + 1
    Else
        Upper = index + Length - 1
        
        If Upper > UBound(Arr) Then
            Call Err.Raise(vbObjectError, "ArrayReverse", "length is higher than index + length could be.")
        End If
    End If
    
    Dim Temp() As Variant
    
    ReDim Temp(Length - 1)
    
    For i = index To Upper
        Temp(i - index) = Arr(i)
    Next
    
    Dim SourceIndex As Long
    
    For i = index To Upper
        SourceIndex = (Length - 1) - (i - index)
    
        Arr(i) = Temp(SourceIndex)
    Next
End Sub

Public Sub ArraySort(Arr As Variant, _
        Optional ByVal index As Long, _
        Optional ByVal Length As Long, _
        Optional ByVal comparer As IComparer)
        If Length = 0 Then
            Length = -1
        Else
            Length = index + Length - 1
        End If
        
    Call mdlArray.ApiQuickSort(Arr, index, Length, , comparer)
End Sub

Public Sub ArraySortComparer(Arr As Variant, _
        ByVal comparer As IComparer)
    Call mdlArray.ApiQuickSort(Arr, , , , comparer)
End Sub

Public Sub ArrayClear(Arr As Variant, ByVal index As Long, Optional ByVal Length As Long)
    Dim i As Long
    Dim Upper As Long
    
    If Length < 1 Then
        Upper = UBound(Arr)
    Else
        Upper = index + Length - 1
    End If
    
    For i = index To Upper
        Arr(i) = Empty
    Next
End Sub

Public Function ArrayLastIndexOf(Arr As Variant, Value As Variant) As Long
    Dim i As Long
    
    For i = UBound(Arr) To LBound(Arr) Step -1
        If Arr(i) = Value Then
            ArrayLastIndexOf = i
            
            Exit Function
        End If
    Next
    
    ArrayLastIndexOf = -1
End Function

Public Sub ArrayCopy(SourceArray As Variant, _
        DestinationArray As Variant, _
        Optional ByVal SourceIndex As Long = -1, _
        Optional ByVal DestinationIndex As Long = -1, _
        Optional ByVal Length As Long)
    If SourceIndex = -1 Then
        SourceIndex = LBound(SourceArray)
    End If
    
    If DestinationIndex = -1 Then
        DestinationIndex = LBound(DestinationArray)
    End If
    
    If Length < 1 Then
        Length = UBound(SourceArray) - SourceIndex + 1
    End If
    
    Dim i As Long
    
    For i = 0 To Length - 1
        DestinationArray(DestinationIndex + i) = SourceArray(SourceIndex + i)
    Next
End Sub

Public Sub AssignSafeArrayPtr(ByRef ArrayTo As Variant, ByVal pSa As Long, Optional ByVal VType As VbVarType)
    Dim FlagFrom As Integer
    Dim FlagTo As Integer
    Dim MemVarFrom As Long
    Dim MemVarTo As Long
    
    MemVarFrom = VarPtr(pSa)
    
    Call RtlMoveMemory(FlagTo, ArrayTo, 2)
    
    If VType = 0 And pSa <> 0 Then
        Call RtlMoveMemory(FlagFrom, ByVal pSa + 2, 2)
        
        If (FlagFrom And FADF_HAVEVARTYPE) > 0 Then
            Call RtlMoveMemory(FlagFrom, ByVal pSa - 4, 2)
        ElseIf (FlagFrom And FADF_RECORD) > 0 Then
            FlagFrom = vbArray Or VarEnum.VT_RECORD
        ElseIf (FlagFrom And FADF_HAVEIID) > 0 Then
            FlagFrom = vbArray Or VarEnum.VT_DISPATCH
        End If
    End If
    
    If (FlagTo And vbArray) = 0 And FlagTo <> vbEmpty And (FlagTo And VT_BYREF) > 0 Then
        Call MsgBox("ArrayTo points to a existing non-array " & TypeName(ArrayTo) & " variable " _
            & " and therefore it should not be swapped", vbInformation, "This should not be done")
    Else
        If (FlagTo And VT_BYREF) = 0 Then
            MemVarTo = VarPtr(ArrayTo) + 8
        Else
            Call RtlMoveMemory(MemVarTo, ByVal VarPtr(ArrayTo) + 8, 4)
        End If
        
        Call RtlMoveMemory(ByVal MemVarTo, ByVal MemVarFrom, 4)
        
        If VType <> VBA.VarType(ArrayTo) Then
            If (FlagTo And VT_BYREF) = 0 Then
                Call RtlMoveMemory(ArrayTo, VType, 1)
            End If
        End If
    End If
End Sub

Public Sub SwapArrayPtr(ByRef ArrayTo As Variant, ByRef ArrayFrom As Variant)
Attribute SwapArrayPtr.VB_Description = "Obsolete, use SwapArray instead"
Attribute SwapArrayPtr.VB_MemberFlags = "40"
    Call mdlArray.SwapArrayPtr(ArrayTo, ArrayFrom)
End Sub

Public Sub SwapArray(ByRef ArrayTo As Variant, ByRef ArrayFrom As Variant)
    Call mdlArray.SwapArrayPtr(ArrayTo, ArrayFrom)
End Sub

Private Function DeRefPointer(ByVal Pointer As Long) As Long
    Call RtlMoveMemoryPtr(DeRefPointer, ByVal Pointer, 4)
End Function

Private Function GetVariantInfo(ByRef var As Variant) As VariantInfo
    Call RtlMoveMemory(GetVariantInfo, var, 16)
End Function

Private Sub SetVariantVarType(ByRef var As Variant, ByVal VarType As VbVarType)
    Call RtlMoveMemory(var, VarType, 1)
End Sub

Private Sub SetVariantInfo(ByRef var As Variant, ByRef VariantInfo As VariantInfo)
    Call RtlMoveMemory(var, VariantInfo, 16)
End Sub

Public Function GetSafeArrayPtr(ByRef SAFE_ARRAY As Variant) As Long
    Dim varinfo As VariantInfo
    
    Call RtlMoveMemory(varinfo, SAFE_ARRAY, 16)
    
    If varinfo.DWord1OrRefPtr <> 0 Then
        If (varinfo.VarTypeAndFlags And VT_BYREF) > 0 Then
            GetSafeArrayPtr = DeRefPointer(varinfo.DWord1OrRefPtr)
        ElseIf (varinfo.VarTypeAndFlags And VT_ARRAY) > 0 Then
            GetSafeArrayPtr = varinfo.DWord1OrRefPtr
        End If
    End If
End Function

Public Sub AssignSafeArray(ByRef ArrayTo As Variant, ByRef ArrayFrom As Variant)
    Dim FlagFrom As Integer
    Dim FlagTo As Integer
    
    Dim MemVarFrom As Long
    Dim MemVarTo As Long
    
    If IsArray(ArrayFrom) = False Then
        Error 0
    End If
  
    Call RtlMoveMemory(FlagTo, ArrayTo, 2)
    Call RtlMoveMemory(FlagFrom, ArrayFrom, 2)
    
    If (FlagTo And vbArray) = 0 And FlagTo <> vbEmpty And (FlagTo And VT_BYREF) > 0 Then
        Call MsgBox("ArrayTo points to a existing non-array " & TypeName(ArrayTo) & " variable " _
            & " and therefore it should not be swapped", vbInformation, "This should not be done")
    Else
        If (FlagFrom And VT_BYREF) = 0 Then
            MemVarFrom = VarPtr(ArrayFrom) + 8
        Else
            Call RtlMoveMemory(MemVarFrom, ByVal VarPtr(ArrayFrom) + 8, 4)
        End If
        
        If (FlagTo And VT_BYREF) = 0 Then
            MemVarTo = VarPtr(ArrayTo) + 8
        Else
            Call RtlMoveMemory(MemVarTo, ByVal VarPtr(ArrayTo) + 8, 4)
        End If
        
        Call RtlMoveMemory(ByVal MemVarTo, ByVal MemVarFrom, 4)
        
        If VarType(ArrayFrom) <> VarType(ArrayTo) Then
            If (FlagTo And VT_BYREF) = 0 Then
                Call RtlMoveMemory(ArrayTo, ArrayFrom, 1)
            End If
        End If
    End If
End Sub

Public Function Create2DimArray(ByVal FieldCount As Long, ByVal Count As Long) As Variant()
    ReDim Create2DimArray(FieldCount - 1, Count - 1)
End Function

Public Function CombineArrays(ParamArray Arrays() As Variant) As Variant
    Dim u As Long
    Dim i As Long
    Dim j As Long
    Dim tmpArray As Variant
    Dim u2 As Long
    
    For j = 0 To UBound(Arrays)
        If j = 0 Then
            tmpArray = Arrays(j)
            u2 = SafeUBound(tmpArray)
        Else
            u = SafeUBound(Arrays(j))
            
            If u > -1 Then
                ReDim Preserve tmpArray(u + u2 + 1)
                
                For i = 0 To u
                    tmpArray(i + u2 + 1) = Arrays(j)(i)
                Next i
                
                u2 = u
            End If
        End If
    Next j

    Call SwapArrayPtr(CombineArrays, tmpArray)
End Function

'Public Sub CombineArrays(ByRef TargetArray As Variant, ByRef sourceArray As Variant)
'    Dim u As Long
'    Dim i As Long
'    Dim l As Long
'
'    If SafeUBound(sourceArray) = -1 Then
'        Exit Sub
'    End If
'
'    l = SafeUBound(TargetArray)
'
'    If l > -1 Then
'        ReDim Preserve TargetArray(l + UBound(sourceArray) + 1)
'    Else
'        ReDim TargetArray(UBound(sourceArray))
'    End If
'
'    For i = 0 To UBound(sourceArray)
'        TargetArray(i + l) = sourceArray(i)
'    Next i
'End Sub

Public Function ValidateArray(ByRef Arr As Variant) As Boolean
    ValidateArray = mdlArray.InitArray(Arr)
End Function

Public Sub InvalidateArray(ByRef Arr As Variant)
    Call mdlArray.InitArray(Arr, True)
End Sub

Public Sub SetSafeArrayStructByPtr(ByVal ArrayPtr As Long, ByRef SAFE_ARRAY As SAFE_ARRAY)
    Call mdlArray.SetSafeArrayStructByPtr(ArrayPtr, SAFE_ARRAY)
End Sub

Public Sub SetSafeArrayStruct(ByRef var As Variant, ByRef SAFE_ARRAY As SAFE_ARRAY)
    Call mdlArray.SetSafeArrayStruct(var, SAFE_ARRAY)
End Sub

Public Function IsValidSafeArrayPointer(ByVal Ptr As Long) As Boolean
    IsValidSafeArrayPointer = mdlArray.IsValidSafeArrayPointer(Ptr)
End Function

Public Function GetSafeArrayStructByPtr(ByVal ArrayPointer As Long) As SAFE_ARRAY
    GetSafeArrayStructByPtr = mdlArray.GetSafeArrayStructByPtr(ArrayPointer)
End Function

Public Function GetSafeArrayDataPtr(ByRef Data As Variant) As Long
    If (VarType(Data) And vbArray) = vbArray Then
        With GetSafeArrayStruct(Data)
            GetSafeArrayDataPtr = .DataPtr
           
            If GetSafeArrayDataPtr = 0 Then
                Exit Function
            End If

'            If .Dimensions = 0 Then
'                Call Err.Raise(vbObjectError + 3004, "GetVariantDataPtr", "Could not Read SAFE_ARRAY structure.")
'            End If
        End With
    End If
End Function

Public Function GetSafeArraySize(ByRef Data As Variant) As Long
    Dim i As Long
    
    If (VarType(Data) And vbArray) = vbArray Then
        Select Case (VarType(Data) And Not vbArray)
            Case vbObject, vbVariant, vbString, vbDataObject
                Call Err.Raise(vbObjectError + 3001, "GetSafeArraySize", "Invalid Datatype: " & TypeName(Data))
            Case Else
                With GetSafeArrayStruct(Data)
                    GetSafeArraySize = .ItemSize
                   
                    For i = 0 To UBound(.Bounds)
                        GetSafeArraySize = GetSafeArraySize * .Bounds(i).Count
                    Next i
                End With
        End Select
    End If
End Function

Public Function GetSafeArrayStruct(ByRef var As Variant, Optional ByRef pSa As Long) As SAFE_ARRAY
    GetSafeArrayStruct = mdlArray.GetSafeArrayStruct(var, pSa)
End Function

Public Function Elements(ByRef Arr As Variant, Optional ByVal Dimension As Long = 1) As Long
    Elements = mdlArray.ApiBound(Arr, Dimension)
End Function

Public Function DimensionByPtr(ByVal Ptr As Long) As Long
    DimensionByPtr = ApiDimensionP(Ptr)
End Function

Public Function Dimension(ByRef Arr As Variant) As Long
    Dimension = mdlArray.ApiDimension(Arr)
End Function

Public Function SafeUBound(ByRef Arr As Variant, Optional ByVal Dimension As Long = 1) As Long
    SafeUBound = mdlArray.SafeUBound(Arr, Dimension)
End Function

'Public Function SafeUBound(ByRef Arr As Variant, Optional ByVal Dimension As Long = 1) As Long
'    SafeUBound = mdlArray.SafeUBound(Arr, Dimension)
'End Function

Public Function UBoundByPtr(ByVal Ptr As Long, Optional ByVal Dimension As Long = 1) As Long
    UBoundByPtr = ApiUBoundP(Ptr, Dimension)
End Function

Public Function ElementsByPtr(ByVal Ptr As Long, Optional ByVal Dimension As Long = 1) As Long
    ElementsByPtr = ApiBoundP(Ptr, Dimension)
End Function

Public Function LBoundByPtr(ByVal Ptr As Long, Optional ByVal Dimension As Long = 1) As Long
    LBoundByPtr = ApiLBoundP(Ptr, Dimension)
End Function

Public Sub QuickSortEx(ByRef Values As Variant, _
        Optional ByVal IndexToSort As Long, _
        Optional ByVal Descending As Boolean, _
        Optional ByVal comparer As IComparer)
    Call mdlArray.SortArray(Values, IndexToSort, Descending, comparer)
End Sub

Public Sub QuickSort( _
        ByRef Values As Variant, Optional ByVal Descending As Boolean, Optional ByVal comparer As IComparer)
    Call ApiQuickSort(Values, , , Descending, comparer)
End Sub

Public Function ASMQuickSort( _
        ByRef Arr As Variant, _
        Optional ByRef Ref As Variant, _
        Optional ByVal Flags As QuicksortFlags = Standard, _
        Optional ByVal TblPtr As Long) As Long
    Call arrSRT(Arr, Ref, Flags, TblPtr)
End Function
