VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DateTime"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Enum LCIDEnum
    System_Default = 0
    User_Default = 1
End Enum
    
Private Declare Function GetLocaleInfo Lib "kernel32" _
        Alias "GetLocaleInfoA" _
        (ByVal Locale As Long, _
         ByVal LCType As Long, _
         ByVal lpLCData As String, _
         ByVal cchData As Long) As Long
         
Private Const LOCALE_IFIRSTWEEKOFYEAR As Long = &H100D

Public Function GetElapsedTime(ByVal DateTimeStart As Date) As String
'*************************************************************
' Function ElapsedTime(dateTimeStart As Date) As String
' Returns the time elapsed from today in a display string like,
' "In 12 hours, 41 minutes"
'*************************************************************
    On Error GoTo ElapsedTime_Error
    Dim Result As String
    Dim years As Double
    Dim month As Double
    Dim Days As Double
    Dim weeks As Double
    Dim hours As Double
    Dim minutes As Double

    If IsNull(DateTimeStart) = True Then Exit Function

    years = DateDiff("yyyy", Now(), DateTimeStart)
    month = DateDiff("m", Now(), DateTimeStart)
    Days = DateDiff("d", Now(), DateTimeStart)
    weeks = DateDiff("ww", Now(), DateTimeStart)
    hours = DateDiff("h", Now(), DateTimeStart)
    minutes = DateDiff("n", Now(), DateTimeStart)
  
    Select Case years
        Case Is = 1
            Result = "Next year"
        Case Is > 1
            Result = "In " & years & " years"
        Case Is = -1
            Result = "Last Year"
        Case Is < -1
            Result = Abs(years) & " years ago"
    End Select
   
    Select Case month
        Case 2 To 11
            Result = "In " & month & " months"
        Case Is = 1
            Result = "This month"
        Case Is = -1
            Result = "Last month"
        Case -11 To -2
            Result = Abs(month) & " months ago"
    End Select

    Select Case Days
        Case 2 To 6
            Result = "In " & Days & " days"
        Case Is = 1
            Result = "Tomorrow"
        Case Is = -1
            Result = "Yesterday"
        Case -6 To -2
            Result = Abs(Days) & " days ago"
    End Select
   
    Select Case weeks
        Case 2 To 5
            Result = "In " & weeks & " weeks"
        Case Is = 1
            Result = "Next week"
        Case Is = -1
            Result = "Last week"
        Case -5 To -2
            Result = Abs(weeks) & " weeks ago"
    End Select

    Select Case hours
        Case Is = 1
            Select Case minutes - (Int(minutes / 60) * 60)
                Case Is = 0
                    Result = "In an hour"
                Case Is = 1
                    Result = "In an hour and one minute"
                Case Is = -1
                    Result = "In an hour and one minute"
                Case 2 To 59
                    Result = "In an hour and " & _
                        minutes - (Int(minutes / 60) * 60) & " minutes"
                Case 60
                    Result = "In an hour"
                Case -59 To -2
                    Result = "In an hour and " & _
                        minutes - (Int(minutes / 60) * 60) & " minutes"
                Case -60
                    Result = "In an hour"
            End Select
        Case 2 To 23
            Select Case minutes - (Int(minutes / 60) * 60)
                Case Is = 1
                    Result = "In " & Int(minutes / 60) & _
                        " hours and one minute"
                Case Is = 0
                    Result = "In " & Int(minutes / 60) & " hours"
                Case 2 To 59
                    Result = "In " & Int(minutes / 60) & " hours, " & _
                        minutes - (Int(minutes / 60) * 60) & " minutes"
                Case Is = -1
                    Result = "In " & Int(minutes / 60) & _
                        " hours and one minute"
                Case -59 To -2
                    Result = "In " & Int(minutes / 60) & " hours, " & _
                        minutes - (Int(minutes / 60) * 60) & " minutes"
                Case Is = 60
                    Result = "In " & Int(minutes / 60) & " hours"
                Case Is = -60
                    Result = "In " & Int(minutes / 60) & " hours"
            End Select
        Case Is = -1
            Select Case (Int(minutes / 60) * 60) - minutes + 60
                Case Is = 0
                    Result = "An hour ago"
                Case Is = 1
                    Result = "An hour and 1 minute ago"
                Case 2 To 59
                    Result = "An hour ago and " & _
                        (Int(minutes / 60) * 60) - minutes + 60 & _
                        " minutes ago"
                Case 60
                    Result = "An hour ago"
                Case Is = -1
                    Result = "An hour and 1 minute ago"
                Case -59 To -2
                    Result = "An hour ago and " & _
                        (Int(minutes / 60) * 60) - minutes + 60 & _
                        " minutes ago"
                Case -60
                    Result = "An hour ago"
            End Select
        Case -23 To -2
            Select Case (Int(minutes / 60) * 60) - minutes + 60
                Case Is = 0
                    Result = Abs(Int(minutes / 60) + 1) & " hours ago"
                Case Is = 1
                    Result = Abs(Int(minutes / 60) + 1) & _
                        " hours and one minute ago"
                Case 2 To 59
                    Result = Abs(Int(minutes / 60) + 1) & " hours, " _
                    & (Int(minutes / 60) * 60) - minutes + 60 & _
                    " minutes ago"
                Case 60
                    Result = Abs(Int(minutes / 60)) & " hours ago"
                Case Is = -1
                    Result = Abs(Int(minutes / 60) + 1) & _
                        " hours and one minute ago"
                Case -59 To -2
                    Result = Abs(Int(minutes / 60) + 1) & _
                        " hours, " & _
                        (Int(minutes / 60) * 60) - minutes + 60 & _
                        " minutes ago"
                Case -60
                    Result = Abs(Int(minutes / 60) + 1) & " hours ago"
            End Select
    End Select
   
    Select Case minutes
        Case 2 To 59
            Result = "In " & minutes & " minutes "
        Case Is = 1
            Result = "In 1 minute"
        Case Is = 0
            Result = "Now"
        Case Is = -1
            Result = "A minute ago"
        Case -59 To -2
            Result = Abs(minutes) & " minutes ago"
    End Select
 
    GetElapsedTime = Result

ElapsedTime_Exit:
    Exit Function
    
ElapsedTime_Error:
    MsgBox "Error " & Err.Number & ": " & Err.Description, _
        vbCritical, "ElapsedTime"
    Resume ElapsedTime_Exit

End Function

Private Function GetInfo(ByVal InfoID As Long, Optional ByVal LCID As LCIDEnum) As String
    Const LOCALE_SYSTEM_DEFAULT As Long = &H800
    Const LOCALE_USER_DEFAULT As Long = &H400
    
    Dim lngRet As Long
    Dim strBuffer As String
    Dim lngLocale As Long
    
    Select Case LCID
        Case LCIDEnum.System_Default
            lngLocale = LOCALE_SYSTEM_DEFAULT
        Case LCIDEnum.User_Default
            lngLocale = LOCALE_USER_DEFAULT
        Case Else
            lngLocale = LCID
    End Select
    
    lngRet = GetLocaleInfo(lngLocale, InfoID, vbNullString, 0)
    
    If lngRet > 0 Then
        strBuffer = String$(lngRet, 0)
        lngRet = GetLocaleInfo(lngLocale, InfoID, strBuffer, Len(strBuffer))
        
        If lngRet <> 0 Then
            GetInfo = Left$(strBuffer, lngRet - 1)
        End If
    End If
End Function

Public Function GetWeekNumber(ByVal InDate As Date, Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek, _
        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem) As Integer
    Dim DayNo As Integer
    Dim StartDays As Integer
    Dim StopDays As Integer
    Dim StartDay As Integer
    Dim StopDay As Integer
    Dim VNumber As Integer
    Dim ThurFlag As Boolean
    
    If FirstWeekOfYear = vbUseSystem Then
        If CLng(GetInfo(LOCALE_IFIRSTWEEKOFYEAR)) = VbFirstWeekOfYear.vbFirstFourDays Then
FirstFourDays:
            DayNo = Days(InDate)
            StartDay = Weekday(DateSerial(Year(InDate), 1, 1)) - 1
            StopDay = Weekday(DateSerial(Year(InDate), 12, 31)) - 1
        
            ' Number of days belonging to first calendar week
            StartDays = 7 - (StartDay - 1)
            
            ' Number of days belonging to last calendar week
            StopDays = 7 - (StopDay - 1)
            
            ' Test to see if the year will have 53 weeks or not
            If StartDay = 4 Or StopDay = 4 Then
                ThurFlag = True
            Else
                ThurFlag = False
            End If
            
            VNumber = (DayNo - StartDays - 4) / 7
            
            ' If first week has 4 or more days, it will be calendar week 1
            ' If first week has less than 4 days, it will belong to last year's
            ' last calendar week
            If StartDays >= 4 Then
                GetWeekNumber = Fix(VNumber) + 2
            Else
                GetWeekNumber = Fix(VNumber) + 1
            End If
            
            ' Handle years whose last days will belong to coming year's first
            ' calendar week
            If GetWeekNumber > 52 And ThurFlag = False Then
                GetWeekNumber = 1
            End If
            
            ' Handle years whose first days will belong to the last year's
            ' last calendar week
            If GetWeekNumber = 0 Then
                GetWeekNumber = GetWeekNumber(DateSerial(Year(InDate) - 1, 12, 31))
            End If
        Else
            GetWeekNumber = DatePart("ww", InDate, FirstDayOfweek, FirstWeekOfYear)
        End If
    ElseIf FirstWeekOfYear = vbFirstFourDays Then
        GoTo FirstFourDays
    Else
        GetWeekNumber = DatePart("ww", InDate, FirstDayOfweek, FirstWeekOfYear)
    End If
End Function

Public Function FormatWeekdays(ByRef Weekdays As Variant, Optional ByVal Abbreviate As Boolean) As String
    Dim i As Long
    
    For i = 0 To UBound(Weekdays)
        If i = 0 Then
            FormatWeekdays = WeekdayName(Weekdays(i), Abbreviate)
        ElseIf i = UBound(Weekdays) Then
            FormatWeekdays = FormatWeekdays & " und " & WeekdayName(Weekdays(i), Abbreviate)
        Else
            FormatWeekdays = FormatWeekdays & ", " & WeekdayName(Weekdays(i), Abbreviate)
        End If
    Next i
End Function

Public Function FormatMonths(ByRef Months As Variant, Optional ByVal Abbreviate As Boolean) As String
    Dim i As Long
    
    For i = 0 To UBound(Months)
        If i = 0 Then
            FormatMonths = MonthName(Months(i), Abbreviate)
        ElseIf i = UBound(Months) Then
            FormatMonths = FormatMonths & " und " & MonthName(Months(i), Abbreviate)
        Else
            FormatMonths = FormatMonths & ", " & MonthName(Months(i), Abbreviate)
        End If
    Next i
End Function

Public Function GetPersonAge(ByVal Birthday As Date, Optional ByVal TargetDate As Date) As Integer
    If TargetDate = Empty Then
        TargetDate = Date
    End If

    GetPersonAge = DateDiff("yyyy", Birthday, TargetDate) + CInt(Format$(TargetDate, "mmdd") < Format$(Birthday, "mmdd"))
End Function

Public Function ConvertToMinutes(ByVal Text As String) As Long
    Dim CF As New Conversion
    
    If InStr(1, Text, "Jahr", vbTextCompare) > 0 Then
        ConvertToMinutes = CF.CVal(Text) * 60 * 24 * 365
    ElseIf InStr(1, Text, "Monat", vbTextCompare) > 0 Then
        ConvertToMinutes = CF.CVal(Text) * 60 * 24 * 30
    ElseIf InStr(1, Text, "Woche", vbTextCompare) > 0 Then
        ConvertToMinutes = CF.CVal(Text) * 60 * 24 * 7
    ElseIf InStr(1, Text, "Tag", vbTextCompare) > 0 Then
        ConvertToMinutes = CF.CVal(Text) * 60 * 24
    ElseIf InStr(1, Text, "Stunde", vbTextCompare) > 0 Then
        ConvertToMinutes = CF.CVal(Text) * 60
    ElseIf InStr(1, Text, "Minute", vbTextCompare) > 0 Then
        ConvertToMinutes = CF.CVal(Text)
    End If
End Function

Public Function TruncSeconds( _
        ByVal Value As Date, _
        Optional ByVal WithoutDateValue As Boolean, _
        Optional ByVal TwoDigitYear As Boolean _
        ) As String
    If Year(Value) > 0 Then
        If WithoutDateValue Or Int(Value) = #12:00:00 AM# Then
            TruncSeconds = Format$(Value, "hh:nn")
        Else
            If TwoDigitYear Then
                TruncSeconds = Format$(Value, "dd.mm.yy hh:nn")
            Else
                TruncSeconds = Format$(Value, "dd.mm.yyyy hh:nn")
            End If
        End If
    Else
        If Value <> Empty Then
            TruncSeconds = Format$(Value, "hh:nn")
        End If
    End If
End Function

Public Function ZeroSeconds( _
        ByVal Value As Date, _
        Optional ByVal WithoutDateValue As Boolean _
        ) As Date
    If Year(Value) > 0 Then
        If WithoutDateValue Then
            ZeroSeconds = Format$(Value, "hh:nn")
        Else
            ZeroSeconds = Format$(Value, "dd.mm.yyyy hh:nn")
        End If
    Else
        If Value <> Empty Then
            ZeroSeconds = Format$(Value, "hh:nn")
        End If
    End If
End Function

Public Function FormatMinutes(ByVal minutes As Long) As String
    If (minutes Mod 1440 * 365) = 0 Then
        If minutes = 1440 * 365 Then
            FormatMinutes = "1 Jahr"
        Else
            FormatMinutes = CStr(Round(minutes / (1440 * 365), 1)) & " Jahre"
        End If
    ElseIf (minutes Mod 1440 * 15) = 0 Then
        If minutes = 1440 * 30 Then
            FormatMinutes = "1 Monat"
        Else
            FormatMinutes = CStr(Round(minutes / (1440 * 30), 1)) & " Monate"
        End If
    ElseIf (minutes Mod 1440 * 7) = 0 Then
        If minutes = 1440 * 7 Then
            FormatMinutes = "1 Woche"
        Else
            FormatMinutes = CStr(Round(minutes \ (1440 * 7), 1)) & " Wochen"
        End If
    ElseIf (minutes Mod (1440 / 2)) = 0 Then
        If minutes = 1440 Then
            FormatMinutes = "1 Tag"
        Else
            FormatMinutes = CStr(Round(minutes / 1440, 1)) & " Tage"
        End If
    ElseIf (minutes Mod 15) = 0 Then
        If minutes = 60 Then
            FormatMinutes = "1 Stunde"
        Else
            FormatMinutes = CStr(Round((minutes / 60), 1)) & " Stunden"
        End If
    End If
End Function

Public Function GetEasterDate(Optional ByVal Year As Integer) As Date
    Dim A As Long, b As Long, C As Long, D As Long, e As Long, f As Long
  
    If Year = 0 Then
        Year = VBA.Year(Date)
    End If
    
    A = Year Mod 19
    b = Year \ 100
    C = (8 * b + 13) \ 25 - 2
    D = b - (Year \ 400) - 2
    e = (19 * (Year Mod 19) + ((15 - C + D) Mod 30)) Mod 30
    
    If e = 28 Then
        If A > 10 Then
            e = 27
        End If
    ElseIf e = 29 Then
        e = 28
    End If
    
    f = (D + 6 * e + 2 * (Year Mod 4) + 4 * (Year Mod 7) + 6) Mod 7

    GetEasterDate = DateSerial(Year, 3, e + f + 22)
End Function

Public Function GetWeekday(ByVal Value As Date, Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek) As VbDayOfWeek
    GetWeekday = Weekday(Value, FirstDayOfweek)
End Function

Public Function GetWeekdayInstanceDate( _
        ByVal DateValue As Date, _
        ByVal Weekday As Long, _
        ByVal Instance As Long, _
        Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek _
        ) As Date
    Dim dteTempDate As Date

    If Instance > 4 Then
        dteTempDate = DateSerial(Year(DateValue), month(DateValue) + 1, 0)
        
        Do Until VBA.Weekday(dteTempDate, FirstDayOfweek) = Weekday
            dteTempDate = DateAdd("d", -1, dteTempDate)
        Loop
        
        GetWeekdayInstanceDate = dteTempDate
    Else
        dteTempDate = DateSerial(Year(DateValue), month(DateValue), 1)
    
        Do Until VBA.Weekday(dteTempDate, FirstDayOfweek) = Weekday
            dteTempDate = DateAdd("d", 1, dteTempDate)
        Loop
    
        GetWeekdayInstanceDate = DateAdd("ww", Instance - 1, dteTempDate)
    End If
End Function

Public Function GetDayOfWeek(ByVal lWeek As Long, ByVal lYear As Long, _
        Optional ByVal FirstDay As VbDayOfWeek = vbMonday, _
        Optional ByVal FirstWeek As VbFirstWeekOfYear = vbFirstFourDays) As Date
    
    Dim d1 As Date
    Dim N1 As Long
    
    d1 = DateSerial(lYear, 1, 1)
    N1 = Weekday(d1, FirstDay)
    
    If DatePart("ww", d1, FirstDay, FirstWeek) = 1 Then
        N1 = FirstDay - N1 - 8
    Else
        N1 = ((8 + N1 - FirstDay) Xor 7) - 16
    End If
        
    GetDayOfWeek = d1 + N1 + lWeek * 7
End Function

Public Function GetWeekStart(ByVal Week As Integer, Optional ByVal Year As Long, _
        Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek, _
        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem) As Date
    Dim dteBeginn As Date
    Dim intWeekDay As Integer
    
    If Year = 0 Then Year = VBA.Year(Date)

    dteBeginn = DateSerial(Year, 1, 1)
    intWeekDay = Weekday(dteBeginn, FirstDayOfweek)
    
'    GetWeekStart = dteBeginn _
'        - (intWeekDay - 1) _
'        + ((Week + ((intWeekDay - 1) \ 7) - 1) * 7)
'
'    GetWeekStart = _
'            DateAdd("d", _
'            -(intWeekDay - 1) + ((Week + ((1 * (intWeekDay - 1)) \ 7) - 1) * 7), _
'            dteBeginn)
    
    GetWeekStart = dteBeginn _
              - intWeekDay - 6 _
              + (Week - (DatePart("ww", dteBeginn, FirstDayOfweek, FirstWeekOfYear) <> 1)) * 7
End Function

'Public Function GetWeekStart1(ByVal Week As Integer, ByVal Year As Long, _
'        Optional ByVal FirstDayOfWeek As VbDayOfWeek = vbUseSystemDayOfWeek, _
'        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem) As Date
'    'Entspricht der Kalenderwoche nach DIN 1355
'    'Year als Long so: 2008
'    'Aus Kalenderwoche und Jahr Datum des ersten Tages der Kalenderwoche ermitteln
'    'Beachte das zum Beispiel der Sonntag 2.1.2005 zur 53. Woche 2004 gehrt
'    Dim dteBeginn As Date
'    Dim intWeekDay As Integer
'
'    dteBeginn = DateSerial(Year, 1, 1)
'    intWeekDay = Weekday(dteBeginn, FirstDayOfWeek)
'
'    If Format$(dteBeginn, "ww", 0, FirstWeekOfYear) = "1" Then
'        GetWeekStart = dteBeginn _
'                - CLng(Format$(dteBeginn, "w", 0, FirstWeekOfYear)) + 1 + (Week - 1) * 7
'    Else
'        GetWeekStart = dteBeginn _
'                - CLng(Format$(dteBeginn, "w", 0, FirstWeekOfYear)) + 1 + (Week) * 7
'    End If
'End Function

Public Function GetWeeksOfYear(Optional ByVal Year As Long, Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek, _
        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem) As Integer
    If Year = 0 Then
        Year = VBA.Year(Date)
    End If
    
    GetWeeksOfYear = GetWeekNumber(DateAdd("d", -1, GetWeekStart(1, Year + 1, FirstDayOfweek, FirstWeekOfYear)), FirstDayOfweek, FirstWeekOfYear)
End Function

'Public Function GetWeekNumber2( _
'        ByVal InDate As Date, _
'        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem, _
'        Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek) As Integer
'
'' Attributed to Daniel Maher
'
'    Select Case FirstWeekOfYear
'        Case VbFirstWeekOfYear.vbFirstFourDays
'            Dim d2 As Long
'
'            d2 = DateSerial(Year(InDate - Weekday(InDate - 1) + 4), 1, 3)
'            GetWeekNumber2 = Int((InDate - d2 + Weekday(d2) + 5) / 7)
'        Case VbFirstWeekOfYear.vbFirstFullWeek
'            If FirstDayOfweek = vbMonday Then
'                GetWeekNumber2 = 1 + Int((InDate - (DateSerial(Year(InDate), 1, 2) - Weekday(DateSerial(Year(InDate), 1, 0)))) / 7)
'            ElseIf FirstDayOfweek = vbSunday Then
'                GetWeekNumber2 = 1 + Int((InDate - (DateSerial(Year(InDate), 1, 2) - Weekday(DateSerial(Year(InDate), 1, 1)))) / 7)
'            End If
'        Case VbFirstWeekOfYear.vbFirstJan1
'            GetWeekNumber2 = Int((InDate - DateSerial(Year(InDate), 1, 1)) / 7) + 1
'    End Select
'End Function

Private Function Days(ByVal DayNo As Date) As Integer
    Days = DayNo - DateSerial(Year(DayNo), 1, 0)
End Function

Public Function GetWeekdayInstance(Optional ByVal DateValue As Date, Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek, _
        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem) As Integer
    Dim dteTempDate As Date
    
    If DateValue = Empty Then
        DateValue = Date
    End If
    
    dteTempDate = DateSerial(Year(DateValue), month(DateValue), 1)
    
    Do Until Weekday(dteTempDate) = Weekday(DateValue)
        dteTempDate = DateAdd("d", 1, dteTempDate)
    Loop
    
    GetWeekdayInstance = DateDiff("w", dteTempDate, DateValue, FirstDayOfweek, FirstWeekOfYear) + 1
End Function

Public Function GetExpirationDate( _
        ByVal StartDate As Date, _
        ByVal Duration As Long, _
        ByVal Interval As String, _
        Optional ByVal SearchStartDarte As Date _
        ) As Date
    If SearchStartDarte = Empty Then
        SearchStartDarte = Date
    End If
    
'    GetIntervalDate = StartDate
'
'    Do Until GetIntervalDate >= TargetDate
'        GetIntervalDate = DateAdd(Interval, Duration, GetIntervalDate)
'    Loop
    
    Dim Diff As Long
    
    Diff = DateDiff(Interval, StartDate, SearchStartDarte, vbUseSystemDayOfWeek, vbUseSystem)

    GetExpirationDate = DateAdd(Interval, Diff - (Diff Mod Duration), StartDate)

    If SearchStartDarte >= GetExpirationDate Then
        GetExpirationDate = DateAdd(Interval, Duration, GetExpirationDate)
    End If
End Function

Public Function GetWeekOfMonth(Optional ByVal DateValue As Date, Optional ByVal FirstDayOfweek As VbDayOfWeek = vbUseSystemDayOfWeek, _
        Optional ByVal FirstWeekOfYear As VbFirstWeekOfYear = vbUseSystem) As Integer
    Dim dteTempDate As Date
    
    If DateValue = Empty Then
        DateValue = Date
    End If
    
    dteTempDate = DateSerial(Year(DateValue), month(DateValue), 1)
    
    GetWeekOfMonth = DateDiff("ww", dteTempDate, DateValue, FirstDayOfweek, FirstWeekOfYear) + 1
End Function

Public Function GetDateValue(ByVal DateValue As Date) As Date
    GetDateValue = DateSerial(Year(DateValue), month(DateValue), Day(DateValue))
End Function

Public Function GetTimeValue(ByVal DateValue As Date) As Date
    GetTimeValue = TimeSerial(Hour(DateValue), Minute(DateValue), Second(DateValue))
End Function

Public Function LastMonthDayDate(Optional ByVal Value As Date) As Date
    LastMonthDayDate = mdlDate.LastDay(Value)
End Function

Public Function CheckDateInterval(ByVal CheckDate As Date, ByVal StartDate As Date, ByVal Interval As Long, Optional ByVal EndDate As Date) As Boolean
    CheckDateInterval = mdlDate.CheckDateInterval(CheckDate, StartDate, Interval, EndDate)
End Function

Public Function EuroDate(Optional ByVal AnyDate As Date) As String
    EuroDate = ApiEuroDate(AnyDate)
End Function
