VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Type FILE_VERSION
    FileName As String
    FileType As String
    FileVersion As String
    FilePath As String
    WindowsVersion As String
    StructureVersion As String
    ProductVersion As String
    Flags As String
    DateCreated As Date
    DateChanged As Date
End Type

Public Type FILE_DATE
    DateCreated As Date
    DateChanged As Date
    DateLastAccess As Date
End Type

Public Enum ShellExecuteError
     SE_ERR_FNF = 2&
     SE_ERR_PNF = 3&
     SE_ERR_ACCESSDENIED = 5&
     SE_ERR_OOM = 8&
     SE_ERR_DLLNOTFOUND = 32&
     SE_ERR_SHARE = 26&
     SE_ERR_ASSOCINCOMPLETE = 27&
     SE_ERR_DDETIMEOUT = 28&
     SE_ERR_DDEFAIL = 29&
     SE_ERR_DDEBUSY = 30&
     SE_ERR_NOASSOC = 31&
     ERROR_BAD_FORMAT = 11&
End Enum

Public Function GetFileVersionInfoStrings(ByVal FileName As String, InfoStrings As Variant) As String()
    GetFileVersionInfoStrings = mdlVersion.GetVersionInfoStrings(FileName, InfoStrings)
End Function

Public Function GetFileVersionInformation(ByVal FilePath As String) As FILE_VERSION
    GetFileVersionInformation = mdlVersion.ApiGetFileVersionInformation(FilePath)
End Function

Public Function GetDirectorySize(ByVal DirectoryPath As String, Optional ByVal OnlyTheseExtensions As String) As Currency
    GetDirectorySize = ApiGetDirectorySize(DirectoryPath, OnlyTheseExtensions)
End Function

Public Function RecycleFile(ByRef FilePath As String) As Long
    RecycleFile = mdlIO.RecycleFile(FilePath)
End Function

Public Function SetEof(ByRef FileName As String, ByVal EOF As Currency) As Boolean
    SetEof = mdlIO.SetEof(FileName, EOF)
End Function

Public Function CanDeleteFile(ByVal FilePath As String) As Boolean '2015-04-26
    CanDeleteFile = mdlIO.CanGetExclusiveAccess(FilePath, False, True)
End Function

Public Function CanWriteFile(ByVal FilePath As String) As Boolean '2015-04-26
    CanWriteFile = mdlIO.CanGetExclusiveAccess(FilePath, False)
End Function

Public Function CanReadFile(ByVal FilePath As String) As Boolean '2015-04-26
    CanReadFile = mdlIO.CanGetExclusiveAccess(FilePath, True)
End Function

Public Function GetFileAccess(ByVal FilePath As String, Optional ByVal ReadOnly As Boolean) As Boolean 'Obsolete 2015-04-26
Attribute GetFileAccess.VB_Description = "Obsolete, use CanReadFile,  CanWriteFile or CanDeleteFile instead"
Attribute GetFileAccess.VB_MemberFlags = "40"
    If ReadOnly Then
        GetFileAccess = CanReadFile(FilePath)
    Else
        GetFileAccess = CanWriteFile(FilePath)
    End If
End Function

'Public Sub DeleteFile(ByVal FilePath As String, Optional ByVal AllowedFileExtensions As String, Optional ByVal TheseFilesNot As String)
'    Call mdlIO.ApiKillFile(FilePath, AllowedFileExtensions, TheseFilesNot)
'End Sub

Public Sub DeleteFiles( _
        ByVal FilePath As String, _
        Optional ByVal FileExtensionsPattern As String = "*", _
        Optional ByVal DontDeleteFilesWithTheseExtensions As String _
        )
    Call mdlIO.KillFiles(FilePath, FileExtensionsPattern, DontDeleteFilesWithTheseExtensions)
End Sub

Public Function IsFileOpened(ByVal FilePath As String) As Boolean
    IsFileOpened = ApiIsFileAlreadyOpen(FilePath)
End Function

Public Function CopyFiles( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal FileExtensionsPattern As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    CopyFiles = ApiCopyFileEx(SourcePath, TargetPath, FileExtensionsPattern, OverwriteFiles, , OnlyIfNewer, RaiseError)
End Function

Public Function MoveFiles( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal FileExtensionsPattern As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal IncludeSubDirs As Boolean, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    MoveFiles = ApiCopyFileEx(SourcePath, TargetPath, FileExtensionsPattern, OverwriteFiles, IncludeSubDirs, OnlyIfNewer, RaiseError, True)
End Function

Public Function CopyFile( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal Overwrite As Boolean = True, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    CopyFile = ApiCopyFile(SourcePath, TargetPath, Overwrite, OnlyIfNewer, RaiseError)
End Function

Public Function MoveFile( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    MoveFile = ApiCopyFile(SourcePath, TargetPath, OverwriteFiles, OnlyIfNewer, RaiseError, True)
End Function

Public Function GetFileString(ByVal FilePath As String) As String
    Dim f As Integer
    
    f = FreeFile
    
    Open FilePath For Binary As #f
        GetFileString = Input$(LOF(f), #f)
    Close #f
End Function

Public Sub SetFileString(ByVal FilePath As String, ByRef FileString As String)
    Dim f As Integer
    
    f = FreeFile
    
    Open FilePath For Output As #f
        Print #f, FileString
    Close #f
End Sub

Public Sub SetFileBytes(ByVal FilePath As String, ByRef FileBytes() As Byte)
    Dim f As Integer
    
    f = FreeFile
    
    Open FilePath For Binary As #f
        Put #f, 1, FileBytes
    Close #f
End Sub

Public Function GetFileBytes(ByVal FilePath As String) As Byte()
    GetFileBytes = mdlFunctions.GetFileBytes(FilePath, , True)
End Function

Public Function GetFileBytesEx(ByVal FilePath As String, Optional ByRef Content As String) As Byte()
    GetFileBytesEx = mdlFunctions.GetFileBytes(FilePath, Content)
End Function

Public Function GetFileSize(ByVal FilePath As String) As Currency
    GetFileSize = ApiGetFileSize(FilePath)
End Function

Public Function GetFileTitle(ByVal FilePath As String) As String
    GetFileTitle = ApiFileTitle(FilePath)
End Function

Public Function FileExists(ByVal FilePath As String) As Boolean
    FileExists = mdlIO.SafeFileExists(FilePath)
End Function

Public Function FileExistsEx(ByVal FilePath As String, Optional ByVal AllowedFileExtensions As String) As Boolean
    FileExistsEx = mdlIO.ApiFileExists(FilePath, AllowedFileExtensions)
End Function

Public Function GetFileDate(ByVal FilePath As String) As FILE_DATE
    GetFileDate = mdlVersion.ApiGetFileDate(FilePath)
End Function

