VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Info"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Constants
Private Const MAX_MESSAGE_LENGTH As Long = 1024

Private Const FORMAT_MESSAGE_FROM_SYSTEM    As Long = &H1000&
Private Const FORMAT_MESSAGE_IGNORE_INSERTS As Long = &H200&
Private Const FORMAT_MESSAGE_MAX_WIDTH_MASK As Long = &HFF&
Private Const LANG_USER_DEFAULT             As Long = &H400&

Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type Point
    X As Long
    Y As Long
End Type

'API declarations
Private Declare Function GetLastError Lib "kernel32" () As Long

Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" ( _
        ByVal dwFlags As Long, _
        lpSource As Any, _
        ByVal dwMessageId As Long, _
        ByVal dwLanguageId As Long, _
        ByVal lpBuffer As String, _
        ByVal nSize As Long, _
        Arguments As Long) As Long
        
Private Declare Function SHAppBarMessage Lib "shell32.dll" (ByVal dwMessage As Long, pData As APPBARDATA) As Long

Private Type APPBARDATA
    cbSize As Long
    hwnd As Long
    uCallBackMessage As Long
    uEdge As Long
    rc As Rect
    lParam As Long
End Type

Public Type VariantInfo
    VarTypeAndFlags As VarEnum
    DWord3 As Long
    DWord1OrRefPtr As Long
    DWord2 As Long
End Type

Public Enum SpecialSqlDataType
    NVarChar = 263
    Memo = 1008
    SqlDateTime = 135
    TimeStamp = 128
End Enum

Private Type Struct64
    cur As Currency
End Type

Public Type Version
    Build As Integer
    Revision As Integer
    Minor As Integer
    Major As Integer
End Type

Public Enum VarEnum
    VT_EMPTY = 0
    VT_NULL = 1
    VT_I2 = 2
    VT_I4 = 3
    VT_R4 = 4
    VT_R8 = 5
    VT_CY = 6
    VT_DATE = 7
    VT_BSTR = 8
    VT_DISPATCH = 9
    VT_ERROR = 10
    VT_BOOL = 11
    VT_VARIANT = 12
    VT_UNKNOWN = 13
    VT_DECIMAL = 14
    VT_I1 = 16
    VT_UI1 = 17
    VT_UI2 = 18
    VT_UI4 = 19
    VT_I8 = 20
    VT_UI8 = 21
    VT_INT = 22
    VT_UINT = 23
    VT_VOID = 24
    VT_HRESULT = 25
    VT_PTR = 26
    VT_SAFE_ARRAY = 27
    VT_CARRAY = 28
    VT_USERDEFINED = 29
    VT_LPSTR = 30
    VT_LPWSTR = 31
    VT_RECORD = 36
    VT_FILETIME = 64
    VT_BLOB = 65
    VT_STREAM = 66
    VT_STORAGE = 67
    VT_STREAMED_OBJECT = 68
    VT_STORED_OBJECT = 69
    VT_BLOB_OBJECT = 70
    VT_CF = 71
    VT_CLSID = 72
    VT_VECTOR = &H1000&
    VT_ARRAY = &H2000&
    VT_BYREF = &H4000&
    VT_RESERVED = &H8000&
    VT_ILLEGAL = &HFFFF&
    VT_ILLEGALMASKED = &HFFF&
    VT_TYPEMASK = &HFFF&
End Enum

Public Function IsNotNull(Expression As Variant) As Boolean 'V2
    IsNotNull = IsNull(Expression) = False
End Function

Public Function IsNotNothing(ByVal Object As Object) As Boolean '2015-03-18
    IsNotNothing = Object Is Nothing = False
End Function

Public Function IsEvenNumber(ByVal Value As Long) As Boolean
    IsEvenNumber = (Value And 1&) = 0&
End Function

Public Function CompareByCondition(ByRef LHS As Variant, ByVal Condition As String, ByRef RHS As Variant) As Boolean
    Select Case LCase$(Condition)
        Case ">"
            CompareByCondition = LHS > RHS
        Case "<"
            CompareByCondition = LHS < RHS
        Case "="
            CompareByCondition = LHS = RHS
        Case "<>"
            CompareByCondition = LHS <> RHS
        Case "&", "and"
            If LHS = 0 Then
                CompareByCondition = True
            Else
                CompareByCondition = (LHS And RHS) > 0
            End If
        Case "&~", "and not"
            If LHS = 0 Then
                CompareByCondition = True
            Else
                CompareByCondition = (LHS And Not RHS) > 0
            End If
        Case "^"
            CompareByCondition = LHS ^ RHS
        Case "|", "or"
            CompareByCondition = LHS Or RHS
        Case ">="
            CompareByCondition = LHS >= RHS
        Case "<="
            CompareByCondition = LHS <= RHS
        Case "like"
            CompareByCondition = LHS Like RHS
        Case "not like"
            CompareByCondition = Not (LHS Like RHS)
        Case Else
            Error 0
    End Select
End Function

Public Function IsBadReadPtr(ByVal Ptr As Long, ByVal ByteLength As Long) As Boolean
    IsBadReadPtr = mdlArray.IsBadReadPtr(ByVal Ptr, ByteLength) <> 0
End Function

Public Function DeRefPointer(ByVal Pointer As Long) As Long
    Call RtlMoveMemoryPtr(DeRefPointer, ByVal Pointer, 4)
End Function

Public Function CompareVersionStrings(ByVal Version1 As String, ByVal Version2 As String) As Integer
    Dim T641 As Struct64
    Dim T642 As Struct64
    Dim TV1 As Version
    Dim TV2 As Version
    
    TV1 = GetVersionStruct(Version1)
    TV2 = GetVersionStruct(Version2)
    
    LSet T641 = TV1
    LSet T642 = TV2
    
    If T641.cur < T642.cur Then
        CompareVersionStrings = -1
    ElseIf T641.cur > T642.cur Then
        CompareVersionStrings = 1
    End If
End Function

Public Function GetVersionNumber(ByVal Version As String) As Variant
    Dim TV As Version
    
    TV = GetVersionStruct(Version)
    
    GetVersionNumber = CDec(0)
    
    Call RtlMoveMemory(ByVal VarPtr(GetVersionNumber) + 4, TV.Build, 8)
End Function

Public Function GetVersionStruct(ByVal Version As String) As Version
    Dim Count As Long
    Dim Arr() As String
    
    Arr = Split(Version, ".")
    
    GetVersionStruct.Major = Arr(0)
    GetVersionStruct.Minor = Arr(1)
    
    Count = UBound(Arr) + 1
    
    If Count > 2 Then
        GetVersionStruct.Revision = Arr(2)
        
        If Count = 4 Then
            GetVersionStruct.Build = Arr(3)
        End If
    End If
End Function

Public Function GetTypeDefault(ByVal VarType As VbVarType, Optional ByVal Value As Variant, Optional ByVal DontConvert As Boolean) As Variant
    Dim arrB() As Byte
        
    If IsEmpty(Value) Or IsNull(Value) Or IsMissing(Value) Then
        Select Case VarType
            Case vbBoolean
                GetTypeDefault = False
            Case vbCurrency
                GetTypeDefault = 0@
            Case vbByte Or vbArray, vbArray, vbObject, 205, TimeStamp
                Call InitArray(arrB)
            
                GetTypeDefault = arrB()
            Case vbDate, SqlDateTime
                GetTypeDefault = #12:00:00 AM#
            Case vbDouble
                GetTypeDefault = 0#
            Case vbLong
                GetTypeDefault = 0&
            Case vbNull
                GetTypeDefault = Null
            Case 72
                GetTypeDefault = "{00000000-0000-0000-0000-000000000000}"
            Case vbString, NVarChar, Memo, -1, 202, 203
                GetTypeDefault = vbNullString
            Case vbByte
                GetTypeDefault = CByte(0)
            Case vbInteger
                GetTypeDefault = 0
            Case vbSingle
                GetTypeDefault = 0!
            Case vbDecimal, 131
                GetTypeDefault = CDec(0)
            Case Else
                Error 0
        End Select
    Else
        If DontConvert Then
            If VarType = 72 Then
                If Len(Value) > 0 Then
                    GetTypeDefault = Value
                Else
                    GetTypeDefault = "{00000000-0000-0000-0000-000000000000}"
                End If
            Else
                GetTypeDefault = Value
            End If
        ElseIf VarType = VBA.VarType(Value) Then
            GetTypeDefault = Value
        Else
            Select Case VarType
                Case vbBoolean
                    If IsNumeric(Value) Then
                        GetTypeDefault = CBool(Value)
                    Else
                        GetTypeDefault = IIf(Value = "Yes", True, False)
                    End If
                Case vbCurrency
                    GetTypeDefault = CCur(Replace(Value, """", ""))
                Case vbByte Or vbArray, vbArray, vbObject, 205, TimeStamp
                    If VarType = 205 And VBA.VarType(Value) = (vbArray Or vbByte) Then
                        GetTypeDefault = Value
                    Else
                        Call InitArray(arrB)
                    
                        GetTypeDefault = arrB()
                    End If
                Case vbDate, SqlDateTime
                    If IsDate(Value) Then
                        GetTypeDefault = CDate(Value)
                    ElseIf InStr(1, Value, "()") Then
                        GetTypeDefault = Date
                    Else
                        GetTypeDefault = Empty
                    End If
                Case vbDouble
                    GetTypeDefault = CDbl(Value)
                Case vbLong
                    GetTypeDefault = CLng(Value)
                Case vbNull
                    GetTypeDefault = Null
                Case 72
                    If Len(Value) > 0 Then
                        GetTypeDefault = Value
                    Else
                        GetTypeDefault = "{00000000-0000-0000-0000-000000000000}"
                    End If
                Case vbString, NVarChar, Memo, -1, 202, 203
                    GetTypeDefault = CStr(Replace(Replace(Value, """", vbNullString), "=", vbNullString))
                Case vbByte
                    GetTypeDefault = CByte(Value)
                Case vbInteger
                    GetTypeDefault = CInt(Value)
                Case vbSingle
                    GetTypeDefault = CSng(Value)
                Case vbDecimal, 131
                    GetTypeDefault = CDec(Value)
                Case vbObject
                    Set GetTypeDefault = Value
                Case Else
                    Error 0
            End Select
        End If
    End If
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Exit Function
    Resume
End Function

Public Function MemoryEquals(ByVal Ptr1 As Long, ByVal Ptr2 As Long, ByVal Length As Long) As Boolean
    MemoryEquals = mdlArray.MemoryEquals(Ptr1, Ptr2, Length)
End Function

Public Function VariantEquals(ByRef Var1 As Variant, ByRef Var2 As Variant, Optional ByVal AllowDifferentTypes As Boolean = True) As Boolean
    VariantEquals = mdlArray.VariantEquals(Var1, Var2, AllowDifferentTypes)
End Function

Public Function NZ(ByVal Value As Variant, Optional ByVal NullValue As Variant) As Variant
    If IsNull(Value) Then
        NZ = NullValue
    Else
        NZ = Value
    End If
End Function

Public Function GetFuncAddress(ByVal Address As Long) As Long
    GetFuncAddress = Address
End Function

Public Function IIf2(ByRef TrueValue As Variant, Optional ByRef FalseValue As Variant) As Variant
    IIf2 = ApiUIf(TrueValue, FalseValue)
End Function

Public Function GetVariantReferencePtr(ByRef var As Variant) As Long
    Dim T As VariantInfo
    
    Call RtlMoveMemory(T, var, 16)
     
    If (T.VarTypeAndFlags And (VT_BYREF Or VT_ARRAY)) > 0 Then
        GetVariantReferencePtr = T.DWord1OrRefPtr
        
        If (T.VarTypeAndFlags And (VT_BYREF Or VT_ARRAY)) = (VT_BYREF Or VT_ARRAY) Then
            GetVariantReferencePtr = DeRefPointer(T.DWord1OrRefPtr)
        End If
    Else
        Select Case T.VarTypeAndFlags And Not &HFF00
            Case vbUserDefinedType, vbObject, vbDataObject, vbString
                GetVariantReferencePtr = T.DWord1OrRefPtr
        End Select
    End If
End Function

Public Function IsMissingNullOrEmpty(ByRef var As Variant) As Boolean
    IsMissingNullOrEmpty = mdlInfo.IsMissingNullOrEmpty(var)
End Function

Public Function SafeIsMissing(ByRef var As Variant) As Boolean
    SafeIsMissing = mdlMissing.SafeIsMissing(var)
End Function

Public Function TaskbarHeight() As Long
    Dim abdTaskBarPos As APPBARDATA
    Const ABM_GETTASKBARPOS As Long = &H5&
    
    Call SHAppBarMessage(ABM_GETTASKBARPOS, abdTaskBarPos)
    
    TaskbarHeight = (abdTaskBarPos.rc.Bottom - abdTaskBarPos.rc.Top)
End Function

Public Function GetApiErrorDesc(Optional ByVal ErrNumber As Long) As String
    Dim sBuffer    As String * MAX_MESSAGE_LENGTH 'declare message buffer
    Dim lBufferLen As Long    ' Lnge des reservierten Strings
    
    If ErrNumber = 0 Then
        ErrNumber = GetLastError
    End If
    
    ' Stringbuffer fr die Rckgabe reservieren
    ' Fehlernummer in einen Fehlertext wandeln
    lBufferLen = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM _
            Or FORMAT_MESSAGE_MAX_WIDTH_MASK _
            Or FORMAT_MESSAGE_IGNORE_INSERTS, _
            ByVal 0&, ErrNumber, _
            LANG_USER_DEFAULT, _
            sBuffer, Len(sBuffer), 0)
            
    If lBufferLen > 0 Then
        ' ErrHandler wurde identifiziert, der Fehlertext liegt vor
        GetApiErrorDesc = Left$(sBuffer, lBufferLen)
    Else
        ' Der Fehlertext konnte nicht ermittelt werden
        GetApiErrorDesc = "Unbekannter ErrHandler: &H" & Hex$(ErrNumber)
    End If
End Function

Public Function IsIdeRunning() As Boolean
    IsIdeRunning = boolVBIDE
End Function

Public Function SizeOf(ByRef var As Variant) As Long
    SizeOf = mdlFunctions.SizeOf(var)
End Function

'Public Function GetTextMeasures(ByVal hDC As Long, ByRef Text As String, Optional ByVal GetHeight As Boolean) As Long
'    GetTextMeasures = ApiGetTextMeasures(hDC, Text, GetHeight)
'End Function

Public Function ScreenWidth() As Long
    ScreenWidth = Screen.Width \ Screen.TwipsPerPixelX
End Function

Public Function ScreenHeight() As Long
    ScreenHeight = Screen.Height \ Screen.TwipsPerPixelY
End Function


