VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Strings"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function lstrlenA Lib "kernel32.dll" ( _
     ByVal Pointer As Long) As Long
     
Private Declare Function lstrlenW Lib "kernel32.dll" ( _
     ByVal Pointer As Long) As Long

Private Declare Function lstrcpyA Lib "kernel32.dll" ( _
     ByVal DestinationString As String, _
     ByVal SourcePointer As Long) As Long

Private Declare Function lstrcpyW Lib "kernel32.dll" ( _
     ByVal DestinationPointer As String, _
     ByVal SourcePointer As Long) As Long
     
Private Declare Function IsTextPointerUnicode Lib "advapi32" Alias "IsTextUnicode" (ByVal lpBuffer As Long, ByVal cb As Long, lpi As Long) As Long

Private Const IS_TEXT_UNICODE_ASCII16 As Long = &H1
Private Const IS_TEXT_UNICODE_CONTROLS As Long = &H4
Private Const IS_TEXT_UNICODE_DBCS_LEADBYTE As Long = &H400
Private Const IS_TEXT_UNICODE_ILLEGAL_CHARS As Long = &H100
Private Const IS_TEXT_UNICODE_NOT_ASCII_MASK As Long = &HF000
Private Const IS_TEXT_UNICODE_NOT_UNICODE_MASK As Long = &HF00
Private Const IS_TEXT_UNICODE_NULL_BYTES As Long = &H1000
Private Const IS_TEXT_UNICODE_ODD_LENGTH As Long = &H200
Private Const IS_TEXT_UNICODE_REVERSE_ASCII16 As Long = &H10
Private Const IS_TEXT_UNICODE_REVERSE_CONTROLS As Long = &H40
Private Const IS_TEXT_UNICODE_REVERSE_MASK As Long = &HF0
Private Const IS_TEXT_UNICODE_REVERSE_SIGNATURE As Long = &H80
Private Const IS_TEXT_UNICODE_REVERSE_STATISTICS As Long = &H20
Private Const IS_TEXT_UNICODE_SIGNATURE As Long = &H8
Private Const IS_TEXT_UNICODE_STATISTICS As Long = &H2
Private Const IS_TEXT_UNICODE_UNICODE_MASK As Long = &HF
'Private Declare Function WideCharToMultiByte Lib "kernel32" _
'    (ByVal codepage As Long, ByVal dwFlags As Long, _
'    lpWideCharStr As Any, ByVal cchWideChar As Long, _
'    lpMultiByteStr As Any, ByVal cchMultiByte As Long, _
'    ByVal lpDefaultChar As String, _
'    ByVal lpUsedDefaultChar As Long) As Long

Private Function StringArrayContains(ByRef Values() As String, ByRef Match As String) As Boolean '2012-12-28
    Dim i As Long
    
    For i = 0 To UBound(Values)
        If Values(i) = Match Then
            StringArrayContains = True
            
            Exit Function
        End If
    Next
End Function

Public Function StringTrimEnd(ByVal Text As String, ParamArray charsToTrim() As Variant) As String '2012-12-28
    Dim charsToTrimStrings() As String
        
    If UBound(charsToTrim) > -1 Then
        Dim i As Long
        Dim j As Long
        
        ReDim charsToTrimStrings(UBound(charsToTrim))
        
        For i = 0 To UBound(charsToTrim)
            charsToTrimStrings(i) = charsToTrim(i)
        Next
        
        For i = Len(Text) To 1 Step -1
'            If UBound(Filter(charsToTrim, Right$(Text, 1), False, vbTextCompare)) > -1 Then
'
'            End If
            
'            Dim Match As String
'            Dim Found As Boolean
'
'            Match = Right$(Text, 1)
'            Found = False
'
'            For j = 0 To UBound(charsToTrim)
'                If charsToTrim(j) = Match Then
'                    Found = True
'
'                    Exit For
'                End If
'            Next
            
            If StringArrayContains(charsToTrimStrings, Right$(Text, 1)) = False Then
'            If Found = False Then
                StringTrimEnd = Left$(Text, i)

                Exit For
            End If
        Next
    Else
        StringTrimEnd = Text
    End If
End Function

Public Function StringTrimStart(ByVal Text As String, ParamArray charsToTrim() As Variant) As String '2012-12-28
    Dim charsToTrimStrings() As String
    
    If UBound(charsToTrim) > -1 Then
        Dim i As Long
        
        ReDim charsToTrimStrings(UBound(charsToTrim))
        
        For i = 0 To UBound(charsToTrim)
            charsToTrimStrings(i) = charsToTrim(i)
        Next
        
        For i = 1 To Len(Text)
'            If UBound(Filter(charsToTrim, Right$(Text, 1), False, vbTextCompare)) > -1 Then
'
'            End If
            
            If StringArrayContains(charsToTrimStrings, Right$(Text, 1)) = False Then
                StringTrimStart = Mid$(Text, i)

                Exit For
            End If
        Next
    Else
        StringTrimStart = Text
    End If
End Function

Public Function StartsWith(ByVal Text As String, ByVal Value As String, Optional ByVal ignoreCase As Boolean) As Boolean 'V2
    StartsWith = StrComp(Left$(Text, Len(Value)), Value, IIf(ignoreCase, vbTextCompare, vbBinaryCompare))
End Function

Public Function EndsWith(ByVal Text As String, ByVal Value As String, Optional ByVal ignoreCase As Boolean) As Boolean 'V2
    EndsWith = StrComp(Right$(Text, Len(Value)), Value, IIf(ignoreCase, vbTextCompare, vbBinaryCompare))
End Function

Public Function StringFormat(ByVal Expression As String, ParamArray Args() As Variant) As String
    Dim i As Long
    Dim HasDoubleBrackets As Boolean
    Dim Arguments() As Variant
    
    Call SwapArrayPtr(Arguments, GetParamArrayElements(Args))
    HasDoubleBrackets = InStrB(Expression, "{{") > 0
    
    Const MaxCount As Long = 2147483647
    
    If HasDoubleBrackets Then
        Call ReplaceBin(Expression, Expression, Expression, "{{", "[[", 1, MaxCount)
        Call ReplaceBin(Expression, Expression, Expression, "}}", "]]", 1, MaxCount)
    End If
    
    For i = 0 To UBound(Arguments)
'        Call ReplaceDo(StringFormat, "{" & i & "}", CStr(Args(i)), , , vbTextCompare)
        Call ReplaceBin(Expression, Expression, Expression, "{" & i & "}", CStr(Arguments(i)), 1, MaxCount)
    Next i
    
    If HasDoubleBrackets Then
        Call ReplaceBin(Expression, Expression, Expression, "[[", "{", 1, MaxCount)
        Call ReplaceBin(Expression, Expression, Expression, "]]", "}", 1, MaxCount)
    End If
    
    Call ReplaceBin(Expression, Expression, Expression, "\n", vbNewLine, 1, MaxCount)
    
    Call SwapStringPtr(Expression, StringFormat)
End Function

Public Function GetMappedStrFromVarStr(ByRef VarStr As Variant) As String
    If VarType(VarStr) <> vbString Then Error 0
    
    Call RtlMoveMemory(ByVal VarPtr(GetMappedStrFromVarStr), StrPtr(VarStr))
End Function

Public Function AppendEllipsis(ByVal Text As String, Optional ByVal Length As Long) As String
    If Len(Text) > Length Then
        AppendEllipsis = Left$(Text, Length) & ""
    Else
        AppendEllipsis = Text
    End If
End Function

Public Function FormatVersion(ByVal Major As Byte, ByVal Minor As Byte, Optional ByVal Revision As Integer = -1, Optional ByVal Build As Integer, Optional ByVal ZeroFill As Boolean) As String
    If ZeroFill Then
        FormatVersion = Major & "." & Format$(Minor, "00") & IIf(Revision > -1, "." & Format$(Revision, "0000"), "") & IIf(Build > -1, "." & Format$(Build, "0000"), "")
    Else
        FormatVersion = Major & "." & Minor & IIf(Revision > -1, "." & Revision, "") & IIf(Build > -1, "." & Build, "")
    End If
End Function

Public Function IsUniCode(ByRef Text As String) As Boolean
    Const IS_TEXT_UNICODE_UNICODE_MASK As Long = &HF
    
    If boolIsNT = False Then
        If Len(Text) > 0 Then
            If AscB(MidB(Text, 2, 1)) = 0 Then
                IsUniCode = True
            End If
        End If
    Else
        Dim Flag As Long
        
        Flag = IS_TEXT_UNICODE_UNICODE_MASK
        
        IsUniCode = IsTextPointerUnicode(StrPtr(Text), Len(Text), Flag) <> 0
    End If
End Function

Public Function HtmlEncode(ByVal Text As String, Optional ByVal HardSpaces As Boolean) As String
    Dim i As Long
    Dim ch As String

    For i = 1 To Len(Text)
        ch = Mid$(Text, i, 1)
        
        Select Case ch
            Case " "
                If HardSpaces Then
                    ch = "&nbsp;"
                End If
            Case """"
                ch = "&quot;"
            Case "&"
                ch = "&amp;"
            Case "<"
                ch = "&lt;"
            Case ">"
                ch = "&gt;"
            Case " " To "~"
                ' Not one we already processed but
                ' but in the normal display range
            Case Else
                ch = "&#" & asc(ch) & ";"
        End Select
        
        HtmlEncode = HtmlEncode & ch
    Next i
End Function

Public Function LevenshteinDistance( _
        ByRef String1 As String, _
        ByRef StringCompare As String, _
        Optional ByVal BinaryCompare As Boolean _
        ) As Integer
    Dim D() As Integer ' matrix
    Dim m As Integer ' length of t
    Dim N As Integer ' length of s
    Dim i As Integer ' iterates through s
    Dim j As Integer ' iterates through t
    Dim s_i As String ' ith character of s
    Dim t_j As String ' jth character of t
    Dim cost As Integer ' cost
    Dim Math As New Math
    ' Step 1
  
    N = Len(String1)
    m = Len(StringCompare)
    
    If N = 0 Then
        LevenshteinDistance = m
        
        Exit Function
    End If
    
    If m = 0 Then
        LevenshteinDistance = N
        
        Exit Function
    End If
        
    ReDim D(0 To N, 0 To m)
    
    ' Step 2
    For i = 0 To N
        D(i, 0) = i
    Next i
    
    For j = 0 To m
        D(0, j) = j
    Next j

    ' Step 3

    For i = 1 To N
        s_i = Mid$(String1, i, 1)
    
        ' Step 4
        
        For j = 1 To m
            t_j = Mid$(StringCompare, j, 1)
            
            ' Step 5
            If Not BinaryCompare Then
                If LCase$(s_i) = LCase$(t_j) Then
                    cost = 0
                Else
                    cost = 1
                End If
            Else
                If s_i = t_j Then
                    cost = 0
                Else
                    cost = 1
                End If
            End If
            
            ' Step 6
            
            D(i, j) = Math.Min(D(i - 1, j) + 1, Math.Min(D(i, j - 1) + 1, D(i - 1, j - 1) + cost))
    Next j, i
  
    ' Step 7
    LevenshteinDistance = D(N, m)
End Function

Public Function FormatZeros(ByVal Number As Long, ByVal UpperCount As Long) As String
    FormatZeros = Format$(Number, String$(Len(CStr(UpperCount)), "0"))
End Function

Public Function GetTelNumber(ByRef Value As String, Optional ByVal Delimiter As String = "/") As String
    Dim i As Long
    
    GetTelNumber = TrimEx(RightEx(Value, Delimiter))
    i = 1
    
    Do
        If Not IsNumeric(Mid$(GetTelNumber, i, 1)) Then
            GetTelNumber = Left$(GetTelNumber, i - 1) & Mid$(GetTelNumber, i + 1)
        Else
            i = i + 1
        End If
    Loop Until i > Len(GetTelNumber)
End Function

Public Function GetTelPreselection(ByRef Value As String, Optional ByVal Delimiter As String = "/") As String
    Dim i As Long
    
    GetTelPreselection = TrimEx(LeftEx(Value, Delimiter, True))
    i = 1
    
    Do
        If Not IsNumeric(Mid$(GetTelPreselection, i, 1)) Then
            GetTelPreselection = Left$(GetTelPreselection, i - 1) & Mid$(GetTelPreselection, i + 1)
        Else
            i = i + 1
        End If
    Loop Until i > Len(GetTelPreselection)
End Function

Public Function SeparateString( _
        ByVal Text As String, _
        Optional ByRef SeparateBySeparator As String, _
        Optional ByVal SeparateInTheMiddle As Boolean _
        ) As String
     SeparateString = mdlString.SeparateString(Text, SeparateBySeparator, SeparateInTheMiddle)
End Function

Public Function UrlEncode(ByVal URL As String) As String
    Dim i As Integer
    Dim ch As String

    For i = 1 To Len(URL)
        ch = Mid$(URL, i, 1)
        Select Case ch
            Case " "
                ch = "+"
            Case "+"
                ch = "%2B"
            Case "&"
                ch = "%26"
            Case "/"
                ch = "%2F"
            Case "\"
                ch = "%5C"
            Case ":"
                ch = "%23"
            Case "#"
                ch = "%3A"
            Case "|"
                ch = "%7C"
            Case " " To "~"
                ' Not one we already processed but
                ' but in the normal display range
            Case Else
                ch = "%" & Right$("00" & Hex$(asc(ch)), 2)
        End Select
        
        UrlEncode = UrlEncode & ch
    Next i
End Function

'' String URLEncoden
'Public Function URLEncode(ByVal URL As String) As String
'    Dim strResult As String
'    Dim lngChar As Long
'
'    Do While Len(URL) > 0
'        lngChar = asc(URL)
'        URL = Right$(URL, Len(URL) - 1)
'
'        If (lngChar >= asc("a") And lngChar <= asc("z")) Or _
'                (lngChar >= asc("A") And lngChar <= asc("Z")) Or _
'                (lngChar >= asc("0") And lngChar <= asc("9")) Then
'            strResult = strResult & Chr$(lngChar)
'        ElseIf lngChar = asc(" ") Then
'            strResult = strResult & "+"
'        Else
'            strResult = strResult & "%" & toHex(lngChar, 2)
'        End If
'    Loop
'
'    URLEncode = strResult
'End Function

' String URLDecoden
Public Function UrlDecode(ByVal URL As String) As String
    Dim strResult As String, strChar As String
    Dim i As Long
    
    For i = 1 To Len(URL)
        strChar = Mid$(URL, i, 1)
        
        If strChar = "+" Then
            strResult = strResult & " "
        ElseIf strChar = "%" Then
            strResult = strResult & Chr$(Val("&H" & Mid$(URL, i + 1, 1) & Mid$(URL, i + 2, 1)))
            i = i + 2 'Zwei Zeichen berspringen
        Else
            strResult = strResult & strChar
        End If
    Next i
    
    UrlDecode = strResult
End Function

Public Function CheckUri(ByRef Uri As String) As String
    CheckUri = ApiUrlHttpCheck(Uri)
End Function

Public Function ReduceString(ByRef Text As String, Optional ByVal Characters As Long = 1) As String
    If Characters > Len(Text) Then
        Characters = 0
    End If
    
    ReduceString = Left$(Text, Len(Text) - Characters)
    Text = ReduceString
End Function

Public Function BreakText( _
        ByRef Text As String, _
        Optional ByVal FontSize As Single = 8.25, _
        Optional ByVal FontName As String = "Arial", _
        Optional ByVal Width As Long = 4175 _
        ) As String
    Dim lngAnzahlZeichen As Long
    Dim i As Long
    Dim strTempText As String
    Dim strEndtext As String
    
    If Printers.Count > 0 Then
        Printer.Font.Name = FontName
        Printer.Font.Size = FontSize
        
        If Width < Printer.TextWidth(Text) Then
            lngAnzahlZeichen = 0
        
            Do
                i = 0
                strTempText = vbNullString

            
                Do
                    i = i + 1
                    
                    strTempText = Mid$(Text, lngAnzahlZeichen + 1, i)
                Loop Until (Printer.TextWidth(strTempText) >= Width And Mid$(strTempText, i, 1) = Chr$(32)) Or (lngAnzahlZeichen + i >= Len(Text))
            
                lngAnzahlZeichen = lngAnzahlZeichen + i
                
                strEndtext = strEndtext & strTempText & vbCrLf
            Loop Until lngAnzahlZeichen >= Len(Text)
            
            BreakText = Left$(strEndtext, Len(strEndtext) - 2)
        Else
            BreakText = Text
        End If
    Else
        BreakText = Text
    End If
End Function

Private Function ContainsOnly0(ByRef s As String) As Boolean
    Dim i As Long

    For i = 1 To Len(s)
        If asc(Mid$(s, i, 1)) > 0 Then Exit Function
    Next i
  
    ContainsOnly0 = True
End Function

Public Function ReplaceEx(ByRef Expression As String, _
    ByVal Find As String, ByVal Replace As String, _
    Optional ByVal Start As Long = 1, _
    Optional ByVal Count As Long = 2147483647, _
    Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
  ) As String

  If LenB(Find) = 0 Then

    'Suchstring ist leer:
    ReplaceEx = Expression

  ElseIf ContainsOnly0(Find) Then

    'Unicode-Problem, also kein LenB und co. verwenden:
    Call ReplaceBin0(ReplaceEx, Expression, Expression, Find, Replace, Start, Count)

  ElseIf Compare = vbBinaryCompare Then

    'Gro/Kleinschreibung unterscheiden:
    Call ReplaceBin(ReplaceEx, Expression, Expression, Find, Replace, Start, Count)

  Else

    'Gro/Kleinschreibung ignorieren:
    Call ReplaceBin(ReplaceEx, Expression, LCase$(Expression), LCase$(Find), Replace, Start, Count)

  End If
End Function

Public Sub ReplaceDo(ByRef Expression As String, _
    ByRef Find As String, ByRef Replace As String, _
    Optional ByVal Start As Long = 1, _
    Optional ByVal Count As Long = 2147483647, _
    Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
  )

  If LenB(Find) = 0 Then

    'Suchstring ist leer: Nix machen!

  ElseIf ContainsOnly0(Find) Then

    'Unicode-Problem, also kein LenB und co. verwenden:
    Call ReplaceBin0(Expression, Expression, Expression, Find, Replace, Start, Count)

  ElseIf Compare = vbBinaryCompare Then

    'Gro/Kleinschreibung unterscheiden:
    If InStr(Start, Expression, Find, vbBinaryCompare) > 0 Then
        Call ReplaceBin(Expression, Expression, Expression, Find, Replace, Start, Count)
    End If

  Else

    'Gro/Kleinschreibung ignorieren:
    If InStr(Start, Expression, Find, vbTextCompare) > 0 Then
        Call ReplaceBin(Expression, Expression, LCase$(Expression), LCase$(Find), Replace, Start, Count)
    End If

  End If

End Sub
      
Public Function LimitLength( _
        ByVal Source As String, _
        ByVal MaxLength As Long _
        ) As String
    If Len(Source) <= MaxLength Then
        Call SwapString(LimitLength, Source)
    Else
        Call SwapString(LimitLength, Left$(Source, MaxLength))
    End If
End Function

Public Function LeftEx( _
        ByVal Text As String, _
        ByVal Character As String, _
        Optional ByVal EmptyIfNoOccurrence As Boolean, _
        Optional ByVal IncludeDelimitter As Boolean _
        ) As String
    LeftEx = ApiLeftEx(Text, Character, EmptyIfNoOccurrence, IncludeDelimitter)
End Function

Public Function RightEx( _
        ByVal Text As String, _
        ByVal Character As String, _
        Optional ByVal EmptyIfNoOccurrence As Boolean, _
        Optional ByVal IncludeDelimitter As Boolean _
        ) As String
    RightEx = ApiRightEx(Text, Character, EmptyIfNoOccurrence, IncludeDelimitter)
End Function

Public Function IsInStr(ByVal StringToCheck As String, ByVal StringToSearch As String, Optional ByVal CompareMethod As VbCompareMethod = vbBinaryCompare) As Boolean
    IsInStr = mdlString.ApiIsInstr(StringToCheck, StringToSearch, CompareMethod)
End Function

Public Function IsInstrEx( _
        ByVal StringToCheck As String, _
        Optional ByVal StringToSearch As String = "\", _
        Optional ByVal CompareEachTermSeparately As Boolean, _
        Optional ByRef FoundSearchTerm As String, _
        Optional ByVal CompareMethod As VbCompareMethod = vbTextCompare, _
        Optional ByVal ReturnFalseIfEmptyString As Boolean = True) As Boolean
    IsInstrEx = mdlString.ApiIsInstrEx(StringToCheck, StringToSearch, CompareEachTermSeparately, FoundSearchTerm, CompareMethod, ReturnFalseIfEmptyString)
End Function

Public Function TrimNull(ByRef Text As String) As String
    Dim nNul As Long

    nNul = InStr(1, Text, vbNullChar)
    
    Select Case nNul
        Case Is > 1
            TrimNull = Left$(Text, nNul - 1)
        Case 1
        Case 0
            TrimNull = Text
    End Select
End Function

Public Function TrimEx(ByRef Text As String) As String
    'Deklarationen:
    Dim iStart As Long
    Dim iEnde As Long
    
    'Start suchen:
    For iStart = 1 To Len(Text)
        If asc(Mid$(Text, iStart, 1)) > vbKeySpace Then
            Exit For
        End If
    Next iStart
    
    'Ende suchen:
    For iEnde = Len(Text) To iStart + 1 Step -1
        If asc(Mid$(Text, iEnde, 1)) > vbKeySpace Then
            Exit For
        End If
    Next iEnde
    
    'Fertig:
    TrimEx = Mid$(Text, iStart, iEnde - iStart + 1)
End Function

Public Function StrDup( _
    ByVal Count As Long, _
    ByRef Text As String _
    ) As String

    StrDup = ApiStrRepeat(Count, Text)
End Function

'Private Function GetStrFromANSIBuffer(sBuf As String) As String
'    If InStr(sBuf, &H0) Then
'        GetStrFromANSIBuffer = Left(sBuf, InStr(sBuf, &H0) - 1)
'    Else
'        GetStrFromANSIBuffer = sBuf ' no null, so don't worry about it
'    End If
'End Function

'Public Function GetStrFromPtrW(ByVal lpszW As Long) As String
'    Dim sRV As String
'
'    sRV = String$(lstrlenW(ByVal lpszW) * 2, &H0) ' 2 bytes/char
'
'    ' copy from Unicode string into new buffer
'    Call WideCharToMultiByte(0, &H0, ByVal lpszW, -1, ByVal sRV, Len(sRV), &H0, &H0)
'
'    GetStrFromPtrW = GetStrFromANSIBuffer(sRV)
'End Function

Public Sub SwapStringPtr(ByRef Source As String, ByRef Target As String) 'v2
Attribute SwapStringPtr.VB_Description = "Obsolete, use SwapString instead"
    Call RtlMoveMemory(ByVal VarPtr(Target), StrPtr(Source))
    Call RtlMoveMemory(ByVal VarPtr(Source), 0&)
End Sub

Public Sub SwapString(ByRef Target As String, ByRef Source As String) 'v2
    Call RtlMoveMemory(ByVal VarPtr(Target), StrPtr(Source))
    Call RtlMoveMemory(ByVal VarPtr(Source), 0&)
End Sub

Public Function StringFromPointerAnsi(ByVal lpszA As Long) As String 'v2
    Dim nSize As Long
    
    nSize = lstrlenA(lpszA)
    
    StringFromPointerAnsi = String$(nSize, vbNullChar)
    
    Call RtlMoveMemory(ByVal StringFromPointerAnsi, ByVal lpszA, nSize)
End Function

 Private Function StringFromPointerIntern(pOLESTR As Long) As String
   Dim ByteArray(255) As Byte
   Dim intTemp As Integer
   Dim intCount As Integer
   Dim i As Integer

   intTemp = 1

   'Walk the string and retrieve the first byte of each WORD.
   While intTemp <> 0
      Call RtlMoveMemory(intTemp, ByVal pOLESTR + i, 2)
      ByteArray(intCount) = intTemp
      intCount = intCount + 1
      i = i + 2
   Wend
   
   StringFromPointerIntern = Space$(intCount - 1)

   'Copy the byte array to our string.
   Call RtlMoveMemory(ByVal StringFromPointerIntern, ByteArray(0), intCount - 1)
End Function

Public Function StringFromPointer(ByVal lpStr As Long) As String 'v2
'    Dim nSize As Long
    
    StringFromPointer = StringFromPointerIntern(lpStr)
    
'    Exit Function
'
'    If boolIsNT Then
'        nSize = lstrlenW(lpStr)
'
'        If (nSize > 0) Then
'            StringFromPointer = String$(nSize, vbNullChar)
'
'            Call lstrcpyW(StringFromPointer, lpStr)
'        End If
'    Else
'        nSize = lstrlenA(lpStr)
'
'        If (nSize > 0) Then
'            StringFromPointer = String$(nSize, vbNullChar)
'
'            Call lstrcpyA(StringFromPointer, lpStr)
'        End If
'    End If
End Function

Public Function InStrCount( _
        ByRef Text As String, _
        Optional ByRef Find As String = "\", _
        Optional ByVal Start As Long = 1, _
        Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
        ) As Long
    InStrCount = ApiStrCount(Text, Find, Start, Compare)
End Function

Public Function InStrPositions( _
        ByRef Text As String, _
        Optional ByRef Find As String = "\", _
        Optional ByVal Start As Long = 1, _
        Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
        ) As Long()
        
    InStrPositions = mdlString.StrPositions(Text, Find, Start, Compare)
End Function

Public Function InStrLike( _
    ByVal Text As String, _
    ByVal Pattern As String, _
    Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
  ) As Long
    InStrLike = ApiInStrLike(Text, Pattern, Compare)
End Function


