Attribute VB_Name = "mdlASMSort"
Option Explicit
Option Compare Text

'Public Enum QuicksortFlags
'    srtDescending = 1
'    srtUnsigned = 2
'    srtReferenceArr = 4
'    srtStandard = 0
'    srtLexical = 8
'    srtAscii = 16
'    srtUserDefChrMap = 24
'End Enum
    
Private Declare Function cdByVal _
    Lib "user32" Alias "CallWindowProcA" _
   (ByRef asm As Long, _
    ByVal PA1 As Long, _
    ByVal PA2 As Long, _
    ByVal PA3 As Long, _
    ByVal PA4 As Long) As Long

' arrSRT        Sortiert ein Array
'
' CALL:         arrSRT(arr, [@ref], [flg], [tbl])
'
' IN:           var:arr Array, das sortiert werden soll
'
'               var:@ref Referenzarray, welches dir original
'                        Referenzpositionen im Array speichern
'
'               lng:flg Flags
'                       bit   0: 0=aufsteigend  (Vorgabe)
'                                1=absteigend
'
'                                Nur numerisch
'                       bit   1: 0=Vorzeichen beachten (Vorgabe)
'                                1=Ohne Vorzeichen sortieren
'
'                                Nur bei Texten
'                       bit 2/3: 00=standard
'                                01=lexikalisch
'                                10=ascii
'                                11=benutzerdefiniert
'
'               lng:tbl Pointer auf eine Benutzerdefinierte
'                       Zeichentabelle
'                       (Nur bei Strings)
'
' OUT:          lng      0: okay
'                       -1: Ungltige Dimension (UBound = -1)
'                       -2: Nicht untersttzter Datentyp varType
'                       -3: Kein Datapointer (sollte nicht passieren)
'                       -4: Ungltige Dimention (<> 1)
'                       -5: Keine Dimension (keine SAR-Struktur vorhanden)
'                       -6: Kein Array
'                       -7: Fehlende Sortiertabelle
'                           (ungltige Flags)
'
Public Function arrSRT( _
    ByRef Arr As Variant, _
    Optional ByRef Ref As Variant, _
    Optional ByVal flg As QuicksortFlags = Standard, _
    Optional ByVal tbl As Long) As Long
    
    Static asc(63)  As Long
    Static std(63)  As Long
    Static lex(63)  As Long
    Static asm(206) As Long

    If asm(0) = 0 Then
        asm(0) = &HEC8B5590:  asm(1) = &HE8575653:  asm(2) = &H0
        asm(3) = &H758BFA6A:  asm(4) = &H6B70F08:   asm(5) = &HF20C4F6
        asm(6) = &HB184&:     asm(7) = &HEC45FF00:  asm(8) = &HF608768B
        asm(9) = &H27440C4:   asm(10) = &HF60B368B: asm(11) = &H9C840F
        asm(12) = &H45FF0000: asm(13) = &H3E8366EC: asm(14) = &H8F850F01
        asm(15) = &HFF000000: asm(16) = &H7E8BEC45: asm(17) = &HFFF0B0C
        asm(18) = &H8184&:    asm(19) = &HEC45FF00: asm(20) = &H7A73123C
        asm(21) = &HCFBB&:    asm(22) = &HF05D0300: asm(23) = &H74C00AD7
        asm(24) = &HEC45FF6D: asm(25) = &H3C20538D: asm(26) = &HF70F7305
        asm(27) = &H21445:    asm(28) = &H6740000:  asm(29) = &H4C281
        asm(30) = &HE4320000: asm(31) = &H43448B66: asm(32) = &H53D80310
        asm(33) = &H49104E8B: asm(34) = &H45FF4478: asm(35) = &H513FE3EC
        asm(36) = &H314468B:  asm(37) = &HC758BC1:  asm(38) = &H5EBF60B
        asm(39) = &H488E0489: asm(40) = &H8BF97549: asm(41) = &H144D8BF3
        asm(42) = &H3301E180: asm(43) = &H38A4BC0:  asm(44) = &HE74C00B
        asm(45) = &H4B4BF003: asm(46) = &H8AD7C18A: asm(47) = &H6881004
        asm(48) = &HC033EBEB: asm(49) = &H50E4558B: asm(50) = &H25EE852
        asm(51) = &H458B0000: asm(52) = &HF4658DEC: asm(53) = &H5D5B5E5F
        asm(54) = &H10C2:     asm(55) = &H5030200:  asm(56) = &H7060406
        asm(57) = &H30000:    asm(58) = &H0:        asm(59) = &H5B002F01
        asm(60) = &HB2008D00: asm(61) = &H1E00E500: asm(62) = &H7C017D01
        asm(63) = &H7277727F: asm(64) = &H777277:   asm(65) = &H1070100
        asm(66) = &H1C8A0800: asm(67) = &H3A404839: asm(68) = &HFA7F381C
        asm(69) = &H1C3A4A42: asm(70) = &H3BFA7C3A: asm(71) = &H8A097DC2
        asm(72) = &HC86380C:  asm(73) = &H380C883A: asm(74) = &H1BEE8
        asm(75) = &HE0EB00:   asm(76) = &H1080100:  asm(77) = &H8B660A00
        asm(78) = &H40484F1C: asm(79) = &H471C3B66: asm(80) = &H4A42F97F
        asm(81) = &H571C3B66: asm(82) = &HC23BF97C: asm(83) = &H8B660C73
        asm(84) = &H8766470C: asm(85) = &H8966570C: asm(86) = &H8CE8470C
        asm(87) = &HEB000001: asm(88) = &H10000DB:  asm(89) = &H8000107
        asm(90) = &H488F1C8B: asm(91) = &H871C3B40: asm(92) = &H4A42FA7F
        asm(93) = &H7C971C3B: asm(94) = &H160E8FA:  asm(95) = &HEDEB0000
        asm(96) = &H7030200:  asm(97) = &H3080100:  asm(98) = &H10702
        asm(99) = &HCF748B0D: asm(100) = &HCF1C8B04: asm(101) = &H743B4048
        asm(102) = &HF97F04C7: asm(103) = &H1C3B0775: asm(104) = &H42F277C7
        asm(105) = &HD7743B4A: asm(106) = &H75F97C04: asm(107) = &HD71C3B05
        asm(108) = &HCE8F272:  asm(109) = &HEB000001: asm(110) = &H10000DD
        asm(111) = &H12000111: asm(112) = &H488F1C8B: asm(113) = &H8BF38B40
        asm(114) = &HF185870C: asm(115) = &HF1870279: asm(116) = &HF07FF13B
        asm(117) = &HF38B4A42: asm(118) = &H85970C8B: asm(119) = &H870279F1
        asm(120) = &H7CF13BF1: asm(121) = &HF4E8F0:   asm(122) = &HD9EB0000
        asm(123) = &H8030200:  asm(124) = &H31A0100:  asm(125) = &H10802
        asm(126) = &HCF1C8B25: asm(127) = &H4CF748B:  asm(128) = &H89DC5D89
        asm(129) = &H4048E075: asm(130) = &H8DDC758D: asm(131) = &H4E8BC71C
        asm(132) = &H44B8504:  asm(133) = &HF3870279: asm(134) = &H3B044E8B
        asm(135) = &HE77F044B: asm(136) = &HE8B0875:  asm(137) = &HDF770B3B
        asm(138) = &H758D4A42: asm(139) = &HD71C8DDC: asm(140) = &H85044B8B
        asm(141) = &H279044E:  asm(142) = &H4E8BF387: asm(143) = &H44B3B04
        asm(144) = &H675E77C:  asm(145) = &HB3B0E8B:  asm(146) = &H74E8DF72
        asm(147) = &HEB000000: asm(148) = &H30200B7:  asm(149) = &H1C02030B
        asm(150) = &H8B105D8B: asm(151) = &H75898F34: asm(152) = &H74F60BE0
        asm(153) = &HFC768B03: asm(154) = &H48DC7589: asm(155) = &HE8C88B40
        asm(156) = &H14:       asm(157) = &H4A42F677: asm(158) = &H9E8CA8B
        asm(159) = &H72000000: asm(160) = &H58E8F6:   asm(161) = &HE5EB0000
        asm(162) = &H8B505257: asm(163) = &H3C8BE075: asm(164) = &HE3CF8B8F
        asm(165) = &HFC4F8B03: asm(166) = &H9CDC4D39: asm(167) = &H4D8B0373
        asm(168) = &H74E9D1DC: asm(169) = &H8BC03317: asm(170) = &H8A068AD0
        asm(171) = &H18048A17: asm(172) = &H47474646: asm(173) = &H751A043A
        asm(174) = &HED754905: asm(175) = &H5858509D: asm(176) = &H3BC35F5A
        asm(177) = &H8B247DC2: asm(178) = &H8704C74C: asm(179) = &H8904D74C
        asm(180) = &H8B04C74C: asm(181) = &HC87C70C:  asm(182) = &HC70C89D7
        asm(183) = &HC23B0DEB: asm(184) = &HC8B097D:  asm(185) = &H970C8787
        asm(186) = &H74870C89: asm(187) = &H831B7F16: asm(188) = &H74000C7D
        asm(189) = &H5D8B530E: asm(190) = &H830C8B0C: asm(191) = &H89930C87
        asm(192) = &H405B830C: asm(193) = &H7FC23B4A: asm(194) = &H543BC301
        asm(195) = &H97E0C24:  asm(196) = &HC24448B:  asm(197) = &H13E8
        asm(198) = &H24443B00: asm(199) = &H8B097D08: asm(200) = &HE8082454
        asm(201) = &H4:        asm(202) = &H8C259:    asm(203) = &H51525059
        asm(204) = &H8DE875FF: asm(205) = &HE9D1020C: asm(206) = &HC3

        ' ascii-table
        asc(0) = &H3020100:   asc(1) = &H7060504:   asc(2) = &HB0A0908
        asc(3) = &HF0E0D0C:   asc(4) = &H13121110:  asc(5) = &H17161514
        asc(6) = &H1B1A1918:  asc(7) = &H1F1E1D1C:  asc(8) = &H23222120
        asc(9) = &H27262524:  asc(10) = &H2B2A2928: asc(11) = &H2F2E2D2C
        asc(12) = &H33323130: asc(13) = &H37363534: asc(14) = &H3B3A3938
        asc(15) = &H3F3E3D3C: asc(16) = &H43424140: asc(17) = &H47464544
        asc(18) = &H4B4A4948: asc(19) = &H4F4E4D4C: asc(20) = &H53525150
        asc(21) = &H57565554: asc(22) = &H5B5A5958: asc(23) = &H5F5E5D5C
        asc(24) = &H63626160: asc(25) = &H67666564: asc(26) = &H6B6A6968
        asc(27) = &H6F6E6D6C: asc(28) = &H73727170: asc(29) = &H77767574
        asc(30) = &H7B7A7978: asc(31) = &H7F7E7D7C: asc(32) = &H83828180
        asc(33) = &H87868584: asc(34) = &H8B8A8988: asc(35) = &H8F8E8D8C
        asc(36) = &H93929190: asc(37) = &H97969594: asc(38) = &H9B9A9998
        asc(39) = &H9F9E9D9C: asc(40) = &HA3A2A1A0: asc(41) = &HA7A6A5A4
        asc(42) = &HABAAA9A8: asc(43) = &HAFAEADAC: asc(44) = &HB3B2B1B0
        asc(45) = &HB7B6B5B4: asc(46) = &HBBBAB9B8: asc(47) = &HBFBEBDBC
        asc(48) = &HC3C2C1C0: asc(49) = &HC7C6C5C4: asc(50) = &HCBCAC9C8
        asc(51) = &HCFCECDCC: asc(52) = &HD3D2D1D0: asc(53) = &HD7D6D5D4
        asc(54) = &HDBDAD9D8: asc(55) = &HDFDEDDDC: asc(56) = &HE3E2E1E0
        asc(57) = &HE7E6E5E4: asc(58) = &HEBEAE9E8: asc(59) = &HEFEEEDEC
        asc(60) = &HF3F2F1F0: asc(61) = &HF7F6F5F4: asc(62) = &HFBFAF9F8
        asc(63) = &HFFFEFDFC
       
        ' standard table
        std(0) = &H2010000:   std(1) = &H6050403:   std(2) = &H29282707
        std(3) = &H9082B2A:   std(4) = &HD0C0B0A:   std(5) = &H11100F0E
        std(6) = &H15141312:  std(7) = &H19181716:  std(8) = &H2E2D2C25
        std(9) = &H2031302F:  std(10) = &H57343332: std(11) = &H37362135
        std(12) = &H7B797772: std(13) = &H7F7E7D7C: std(14) = &H39388180
        std(15) = &H3A5A5958: std(16) = &H9694833B: std(17) = &HABA89E9A
        std(18) = &HBBB9AFAD: std(19) = &HC5C1BFBD: std(20) = &HDCDAD8D6
        std(21) = &HF2F0E6E1: std(22) = &H3CFCF6F4: std(23) = &H413F3E3D
        std(24) = &H96948342: std(25) = &HABA89E9A: std(26) = &HBBB9AFAD
        std(27) = &HC5C1BFBD: std(28) = &HDCDAD8D6: std(29) = &HF2F0E6E1
        std(30) = &H43FCF6F4: std(31) = &H1A464544: std(32) = &HA9511B71
        std(33) = &H6D6C6F54: std(34) = &H55DE7040: std(35) = &H1DFE1CD4
        std(36) = &H52504F1E: std(37) = &H24236E53: std(38) = &H56DEE44E
        std(39) = &HFAFE1FD4: std(40) = &H61604726: std(41) = &H64486362
        std(42) = &H5C846549: std(43) = &H4A672266: std(44) = &H7B795B68
        std(45) = &H6B6A694B: std(46) = &H5DC6774C: std(47) = &H4D757473
        std(48) = &H8E8A8688: std(49) = &H98929083: std(50) = &HA6A4A0A2
        std(51) = &HB7B5B1B3: std(52) = &HC8CAC39C: std(53) = &H5EC5D0CC
        std(54) = &HECE8EAD2: std(55) = &HDCE3F8E6: std(56) = &H8E8A8688
        std(57) = &H98929083: std(58) = &HA6A4A0A2: std(59) = &HB7B5B1B3
        std(60) = &HC8CAC39C: std(61) = &H5FC5D0CC: std(62) = &HECE8EAD2
        std(63) = &HFAE3F8E6
        
        ' lexical table
        lex(0) = &H2010000:   lex(1) = &H6050403:   lex(2) = &H29282707
        lex(3) = &H9082B2A:   lex(4) = &HD0C0B0A:   lex(5) = &H11100F0E
        lex(6) = &H15141312:  lex(7) = &H19181716:  lex(8) = &H2E2D2C25
        lex(9) = &H2031302F:  lex(10) = &H57343332: lex(11) = &H37362135
        lex(12) = &H7A787672: lex(13) = &H7F7E7D7C: lex(14) = &H39388180
        lex(15) = &H3A5A5958: lex(16) = &H9593823B: lex(17) = &HAAA79D99
        lex(18) = &HBAB8AEAC: lex(19) = &HC4C0BEBC: lex(20) = &HDBD9D7D5
        lex(21) = &HF1EFE5E0: lex(22) = &H3CFBF5F3: lex(23) = &H413F3E3D
        lex(24) = &H96948342: lex(25) = &HABA89E9A: lex(26) = &HBBB9AFAD
        lex(27) = &HC5C1BFBD: lex(28) = &HDCDAD8D6: lex(29) = &HF2F0E6E1
        lex(30) = &H43FCF6F4: lex(31) = &H1A464544: lex(32) = &HA9511B71
        lex(33) = &H6D6C6F54: lex(34) = &H55DD7040: lex(35) = &H1DFD1CD3
        lex(36) = &H52504F1E: lex(37) = &H24236E53: lex(38) = &H56DEE44E
        lex(39) = &HF9FE1FD4: lex(40) = &H61604726: lex(41) = &H64486362
        lex(42) = &H5C846549: lex(43) = &H4A672266: lex(44) = &H7B795B68
        lex(45) = &H6B6A694B: lex(46) = &H5DC6774C: lex(47) = &H4D757473
        lex(48) = &H8D898587: lex(49) = &H97918F8B: lex(50) = &HA5A39FA1
        lex(51) = &HB6B4B0B2: lex(52) = &HC7C9C29B: lex(53) = &H5ECDCFCB
        lex(54) = &HEBE7E9D1: lex(55) = &HDFE2F7ED: lex(56) = &H8E8A8688
        lex(57) = &H9892908C: lex(58) = &HA6A4A0A2: lex(59) = &HB7B5B1B3
        lex(60) = &HC8CAC39C: lex(61) = &H5FCED0CC: lex(62) = &HECE8EAD2
        lex(63) = &HFAE3F8EE
    End If
    
    ' ******************************************************************
    
    Dim pTBL    As Long
    Dim pREF    As Long
    Dim tmp()   As Long
    Dim cnt     As Long
    
    On Error Resume Next
    
    Select Case (flg And (Lexical Or Ascii)) > 0
        Case 0:                 pTBL = VarPtr(std(0))
        Case Lexical:        pTBL = VarPtr(lex(0))
        Case Ascii:          pTBL = VarPtr(asc(0))
        Case UserDefinedCharMap:  pTBL = tbl
    End Select
    
    cnt = UBound(Arr) - LBound(Arr) + 1
    
    If pTBL = 0 Then
        arrSRT = -7
    
    ElseIf cnt = 0 Then
        arrSRT = -6
        
    Else
        If (flg And ReferenceArray) Then
            ReDim tmp(LBound(Arr) To UBound(Arr))
            pREF = VarPtr(tmp(LBound(tmp)))
        End If
        
        arrSRT = cdByVal( _
            asm(0), _
            VarPtr(Arr), _
            pREF, _
            pTBL, _
            flg And (Descending Or Unsigned))
        
        If (flg And ReferenceArray) Then Ref = tmp
    End If
End Function
