Attribute VB_Name = "mdlArray"
Option Explicit
Option Compare Text

Public Declare Sub RtlMoveMemory Lib "kernel32" (pDest As Any, pSource As Any, Optional ByVal ByteLen As Long = 4)
Public Declare Sub RtlMoveMemoryPtr Lib "kernel32" Alias "RtlMoveMemory" (pDest As Long, pSource As Long, Optional ByVal ByteLen As Long = 4)

Public Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (ByRef Ptr() As Any) As Long

Private Const m_InvalidGuid As String = "{00000000-0000-0000-0000-000000000000}"

Private Declare Function RtlCompareMemory Lib "ntdll.dll" ( _
    ByVal Source1 As Long, _
    ByVal Source2 As Long, _
    ByVal Length As Long) As Long
    
Private Declare Function SafeArrayGetDim Lib "oleaut32.dll" ( _
     ByVal pSa As Long) As Long

Public Declare Function IsBadReadPtr Lib "kernel32.dll" ( _
     ByRef lp As Long, _
     ByVal ucb As Long) As Long

Private Function DeRefPointer(ByVal Pointer As Long) As Long
    Call RtlMoveMemoryPtr(DeRefPointer, ByVal Pointer, 4)
End Function

Public Function GetSafeArrayStruct(ByRef var As Variant, Optional ByRef pSa As Long) As SAFE_ARRAY
    Dim VariantFlags As VarEnum
    
    If Not IsArray(var) Then Exit Function
    
    Call RtlMoveMemory(pSa, ByVal VarPtr(var) + 8)
    Call RtlMoveMemory(VariantFlags, ByVal VarPtr(var), 2)
    
    If (VariantFlags And VT_BYREF) > 0 Then
        Call RtlMoveMemory(pSa, ByVal pSa, 4)
        
        If pSa = 0 Then
            Exit Function
        End If
        
        If Not IsValidSafeArrayPointer(pSa) Then
            Exit Function
        End If
    End If

    GetSafeArrayStruct = mdlArray.GetSafeArrayStructByPtr(pSa)
End Function

Public Function GetParamArrayElements(ByVal Args As Variant) As Variant()
    Dim i As Long
    
    If UBound(Args) > -1 Then
        If UBound(Args) = 0 Then
            Do While IsArray(Args(0))
                Call SwapArrayPtr(Args, Args(0))
                
                If UBound(Args) = -1 Then
                    Exit Do
                End If
            Loop
        End If
    End If
    
    Call SwapArrayPtr(GetParamArrayElements, Args)
End Function

Public Sub SwapArrayPtr(ByRef ArrayTo As Variant, ByRef ArrayFrom As Variant)
    Dim FlagFrom As Integer
    Dim FlagTo As Integer
    
    Dim MemVarFrom As Long
    Dim MemVarTo As Long
  
    Call RtlMoveMemory(FlagTo, ArrayTo, 2)
    Call RtlMoveMemory(FlagFrom, ArrayFrom, 2)
    
    If (FlagTo And vbArray) = 0 And FlagTo <> vbEmpty And (FlagTo And VT_BYREF) > 0 Then
        Call MsgBox("ArrayTo points to a existing non-array " & TypeName(ArrayTo) & " variable " _
            & " and therefore it should not be swapped", vbInformation, "This should not be done")
    ElseIf (FlagFrom And vbArray) = 0 And FlagFrom <> vbEmpty And (FlagFrom And VT_BYREF) > 0 Then
        Call MsgBox("ArrayFrom points to a existing non-array " & TypeName(ArrayFrom) & " variable " _
            & " and therefore it should not be swapped", vbInformation, "This should not be done")
    ElseIf IsEmpty(ArrayTo) Xor IsEmpty(ArrayFrom) Then
        If IsEmpty(ArrayTo) Then
            If (VarType(ArrayFrom) And Not vbArray) = vbUserDefinedType Then
                ArrayTo = ArrayFrom

                Call InitArray(ArrayFrom, True)
     
                Exit Sub
            End If
        
            If (FlagFrom And VT_BYREF) = 0 Then
                MemVarFrom = VarPtr(ArrayFrom) + 8
            Else
                Call RtlMoveMemory(MemVarFrom, ByVal VarPtr(ArrayFrom) + 8, 4)
            End If
 
            Call RtlMoveMemory(ByVal VarPtr(ArrayTo) + 8, ByVal MemVarFrom, 4)
            Call RtlMoveMemory(ArrayTo, VarType(ArrayFrom), 2)

            Call RtlMoveMemory(ByVal MemVarFrom, 0&, 4) 'bei UDT-array absturz
        Else
            Call SwapArrayPtr(ArrayFrom, ArrayTo) 'Rekursion mit vertauschten parametern
        End If

        Exit Sub
    ElseIf IsEmpty(ArrayFrom) And IsEmpty(ArrayFrom) Then
        Exit Sub
    Else
        If (FlagFrom And VT_BYREF) = 0 Then
            MemVarFrom = VarPtr(ArrayFrom) + 8
        Else
            Call RtlMoveMemory(MemVarFrom, ByVal VarPtr(ArrayFrom) + 8, 4)
        End If
        
        If (FlagTo And VT_BYREF) = 0 Then
            MemVarTo = VarPtr(ArrayTo) + 8
        Else
            Call RtlMoveMemory(MemVarTo, ByVal VarPtr(ArrayTo) + 8, 4)
        End If
        
        Dim Temp As Long
        
        Call RtlMoveMemory(Temp, ByVal MemVarFrom, 4)
        Call RtlMoveMemory(ByVal MemVarFrom, ByVal MemVarTo, 4)
        Call RtlMoveMemory(ByVal MemVarTo, Temp, 4)
        
        If VarType(ArrayFrom) <> VarType(ArrayTo) Then
            If (FlagTo And VT_BYREF) = 0 Then
                Call RtlMoveMemory(ArrayTo, ArrayFrom, 1)
            ElseIf (FlagFrom And VT_BYREF) = 0 Then
                Call RtlMoveMemory(ArrayFrom, ArrayTo, 1)
            End If
        End If
    End If
End Sub

Public Function InitArray(ByRef Arr As Variant, Optional ByVal SafeErase As Boolean) As Boolean
    Dim Ptr As Long
    Dim Typ As Integer
    Dim Dimensions As Integer
    Dim Flags As Integer
    Dim boolUninitialised As Boolean
    
    If IsArray(Arr) Then
        
        
        Do
            Call RtlMoveMemory(Typ, ByVal VarPtr(Arr), 2)
            Call RtlMoveMemory(Ptr, ByVal VarPtr(Arr) + 8)
            
            If (Typ And VT_BYREF) <> 0 Then
                Call RtlMoveMemory(Ptr, ByVal Ptr)
            End If
            
            If Ptr = 0 Then
                boolUninitialised = True
                ReDim Arr(0)
            End If
        Loop Until Ptr <> 0
        
        Call RtlMoveMemory(Dimensions, ByVal Ptr, 2)
        Call RtlMoveMemory(Flags, ByVal Ptr + 2, 2)

        If (Flags And FADF_FIXEDSIZE) = 0 And (boolUninitialised Or SafeErase) Then
            If boolUninitialised = False Then
                Select Case Dimensions
                    Case 1
                        ReDim Arr(0)
                    Case 2
                        ReDim Arr(0, 0)
                    Case Else
                        Exit Function
                End Select
                
                Call RtlMoveMemory(Ptr, ByVal VarPtr(Arr) + 8)
                
                If (Typ And VT_BYREF) <> 0 Then
                    Call RtlMoveMemory(Ptr, ByVal Ptr)
                End If
            End If
            
            Call RtlMoveMemory(ByVal Ptr + 16, 0&)
            
            InitArray = UBound(Arr) = -1
        End If
    End If
End Function

Public Function IsValidSafeArrayPointer(ByVal PointerToSafeArray As Long) As Boolean
    Dim T As SAFE_ARRAY
    Dim Bytes As Long
    Dim i As Long

    Call RtlMoveMemory(T, ByVal PointerToSafeArray, 2)
    
    Select Case T.Dimensions
        Case Is < 1, Is > 60
            Exit Function
    End Select
    
    If IsBadReadPtr(ByVal VarPtr(T), 16 + (T.Dimensions * 8&)) <> 0 Then
        Exit Function
    End If
    
    ReDim T.Bounds(T.Dimensions - 1)
    
    Call RtlMoveMemory(ByVal VarPtr(T), ByVal PointerToSafeArray, 16)
    Call RtlMoveMemory(ByVal VarPtr(T.Bounds(0)), ByVal PointerToSafeArray + 16, T.Dimensions * 8)
    
    For i = 0 To T.Dimensions - 1
        Bytes = Bytes * T.Bounds(i).Count
    Next i
    
    If IsBadReadPtr(T.DataPtr, T.ItemSize * Bytes) <> 0 Then
        Exit Function
    End If
    
    IsValidSafeArrayPointer = True
End Function
    
Public Function GetSafeArrayStructByPtr(ByVal PointerToSafeArray As Long) As SAFE_ARRAY
    Dim Dimensions As Integer

    Call RtlMoveMemory(Dimensions, ByVal PointerToSafeArray, 2)
    
    Select Case Dimensions
        Case Is < 1, Is > 60
            Exit Function
    End Select

    ReDim GetSafeArrayStructByPtr.Bounds(Dimensions - 1)
    
    Call RtlMoveMemory(GetSafeArrayStructByPtr, ByVal PointerToSafeArray, 16)
    Call RtlMoveMemory(GetSafeArrayStructByPtr.Bounds(0), ByVal PointerToSafeArray + 16, Dimensions * 8)
End Function

Public Sub SetSafeArrayStruct(ByRef var As Variant, ByRef SAFE_ARRAY As SAFE_ARRAY)
    Dim Ptr As Long
    Dim MemoryBlock() As Byte
    
    If Not IsArray(var) Then Exit Sub
    
    Call RtlMoveMemory(Ptr, ByVal VarPtr(var) + 8)
    Call RtlMoveMemory(Ptr, ByVal Ptr)
    
    If Ptr = 0 Then
        ReDim MemoryBlock(Len(SAFE_ARRAY) - 4 - 1 + (SAFE_ARRAY.Dimensions * 8))
        
        Call RtlMoveMemory(MemoryBlock(0), SAFE_ARRAY, Len(SAFE_ARRAY) - 4)
        Call RtlMoveMemory(ByVal VarPtr(MemoryBlock(0)) + Len(SAFE_ARRAY) - 4, SAFE_ARRAY.Bounds(0).Count, SAFE_ARRAY.Dimensions * 8)

        Call RtlMoveMemory(Ptr, ByVal VarPtr(var) + 8)
        Call RtlMoveMemory(ByVal Ptr, VarPtr(MemoryBlock(0)))
    Else
        Call RtlMoveMemory(ByVal Ptr, SAFE_ARRAY, Len(SAFE_ARRAY) - 4)
        Call RtlMoveMemory(ByVal Ptr + Len(SAFE_ARRAY) - 4, SAFE_ARRAY.Bounds(0).Count, SAFE_ARRAY.Dimensions * 8)
    End If
End Sub

Public Sub SetSafeArrayStructByPtr(ByVal ArrayPtr As Long, ByRef SAFE_ARRAY As SAFE_ARRAY)
    Call RtlMoveMemory(ByVal ArrayPtr, SAFE_ARRAY, Len(SAFE_ARRAY) - 4)
    Call RtlMoveMemory(ByVal ArrayPtr + Len(SAFE_ARRAY) - 4, SAFE_ARRAY.Bounds(0).Count, SAFE_ARRAY.Dimensions * 8)
End Sub
    
Public Sub SortArray(ByRef Values As Variant, ByVal IndexToSort As Long, Optional ByVal Descending As Boolean, Optional ByVal comparer As IComparer)
    Call ApiQuickSort2Dim(Values, IndexToSort, , , Descending, comparer)
End Sub

Public Function MemoryEquals(ByVal UDTPtr As Long, ByVal UDTPtr2 As Long, ByVal Length As Long) As Boolean
    MemoryEquals = RtlCompareMemory(UDTPtr, UDTPtr2, Length) = Length
End Function

Public Function VariantEquals(ByRef Var1 As Variant, ByRef Var2 As Variant, Optional ByVal CompValOfDiffTypes As Boolean = True) As Boolean
    Dim Ptr1 As Long
    Dim Ptr2 As Long
    Dim ptr1temp As Long
    Dim ptr2temp As Long
    Dim Bytes As Long
    Dim i As Long
    Dim SA1 As SAFE_ARRAY
    Dim SA2 As SAFE_ARRAY
    Dim j As Long
    Dim Flags As Byte
    Dim Flags2 As Byte
    Dim str1 As String
    Dim str2 As String
    Dim B1() As Byte
    Dim B2() As Byte
    
    If IsEmpty(Var1) Xor IsEmpty(Var2) Then
        If IsEmpty(Var1) Then
            If VarType(Var2) = vbString Then
                If Len(Var2) > 0 Then
                    VariantEquals = Var2 = m_InvalidGuid
                    
                    Exit Function
                End If
            End If
        Else
            If VarType(Var1) = vbString Then
                If Len(Var1) > 0 Then
                    VariantEquals = Var1 = m_InvalidGuid
                    
                    Exit Function
                End If
            End If
        End If
    End If
   
    If VarType(Var1) <> VarType(Var2) And CompValOfDiffTypes = False Then
        Exit Function
    ElseIf ((VarType(Var1) And vbVariant) = vbVariant) Or (VarType(Var1) = (vbArray Or vbString)) Then
        'StringArrays or 'VariantArrays
        
        Call RtlMoveMemoryPtr(Ptr1, ByVal VarPtr(Var1) + 8)
        Call RtlMoveMemoryPtr(Ptr2, ByVal VarPtr(Var2) + 8)
        
        If Ptr1 = Ptr2 Then
            VariantEquals = True
                
            Exit Function
        ElseIf Ptr1 = 0 Or Ptr2 = 0 Then
            Exit Function
        End If
        
        If VarType(Var1) = (vbArray Or vbVariant) Then 'VariantArrays
            Call RtlMoveMemoryPtr(Ptr1, ByVal Ptr1)
            Call RtlMoveMemoryPtr(Ptr2, ByVal Ptr2)
        End If
        
        SA1 = GetSafeArrayStructByPtr(Ptr1)
        SA2 = GetSafeArrayStructByPtr(Ptr2)
        
        If UBound(Var1, 1) <> UBound(Var2, 1) Then
            Exit Function
        Else
            For j = 1 To SA1.Dimensions
                For i = LBound(Var1, j) To UBound(Var1, j)
                    If Not VariantEquals(Var1(i), Var2(i)) Then
                        Exit Function
                    End If
            Next i, j
        End If
        
        VariantEquals = True
        
        Exit Function
    ElseIf VarType(Var1) = vbString Then   'Strings
        Bytes = LenB(Var1)
        
        If Bytes <> LenB(Var2) Then
            Exit Function
        End If
        
        Call RtlMoveMemoryPtr(Ptr1, ByVal VarPtr(Var1) + 8)
        Call RtlMoveMemoryPtr(Ptr2, ByVal VarPtr(Var2) + 8)
        
        Call RtlMoveMemoryPtr(ByVal VarPtr(Flags), ByVal VarPtr(Var1) + 1, 1)
        
        If (Flags And 64) = 64 Then
            Call RtlMoveMemoryPtr(Ptr1, ByVal Ptr1)
        End If
        
        Call RtlMoveMemoryPtr(ByVal VarPtr(Flags), ByVal VarPtr(Var2) + 1, 1)
        
        If (Flags And 64) = 64 Then
            Call RtlMoveMemoryPtr(Ptr2, ByVal Ptr2)
        End If
    ElseIf (VarType(Var1) And vbArray) = vbArray Then 'brige arrays
        Call RtlMoveMemoryPtr(Ptr1, ByVal VarPtr(Var1) + 8)
        Call RtlMoveMemoryPtr(Ptr2, ByVal VarPtr(Var2) + 8)

        If Ptr1 = Ptr2 Then
            VariantEquals = True
                
            Exit Function
        ElseIf Ptr1 = 0 Or Ptr2 = 0 Then
            Exit Function
        End If

        Call RtlMoveMemoryPtr(ByVal VarPtr(Flags), ByVal VarPtr(Var1) + 1, 1)

        If (Flags And 64) = 64 Then
            Call RtlMoveMemoryPtr(Ptr1, ByVal Ptr1)
        End If
        
        If Ptr1 = 0 Then
            Exit Function
        End If
        
        Call RtlMoveMemoryPtr(ByVal VarPtr(Flags2), ByVal VarPtr(Var2) + 1, 1)
        
        If (Flags2 And 64) = 64 Then
            Call RtlMoveMemoryPtr(Ptr2, ByVal Ptr2)
        End If
        
        If Ptr2 = 0 Then
            Exit Function
        End If
        
        SA1 = GetSafeArrayStructByPtr(Ptr1)
        SA2 = GetSafeArrayStructByPtr(Ptr2)
        
        If SA1.Dimensions <> SA2.Dimensions Then
            Exit Function
        End If
        
        For i = 0 To SA1.Dimensions - 1
            If SA1.Bounds(i).Count = SA2.Bounds(i).Count Then
                Bytes = Bytes * SA1.Bounds(i).Count
            Else
                Exit Function
            End If
        Next i
        
        Bytes = Bytes * SA1.ItemSize
        
        Ptr1 = SA1.DataPtr
        Ptr2 = SA2.DataPtr
    ElseIf IsObject(Var1) Then
        VariantEquals = Var1 Is Var2

        Exit Function
    Else
        If CompValOfDiffTypes Then
            VariantEquals = (Var1 = Var2)
            
            Exit Function
        Else
            Bytes = SizeOf(Var1)
            
            If Bytes <> SizeOf(Var2) Then
                Exit Function
            End If
        
            Ptr1 = VarPtr(Var1) + 8
            Ptr2 = VarPtr(Var2) + 8
        End If
    End If
    
    If boolIsNT Then
        VariantEquals = RtlCompareMemory(ByVal Ptr1, ByVal Ptr2, Bytes) = Bytes
    Else
        Flags = 0
        Flags2 = 0
        ptr1temp = VarPtr(Flags)
        ptr2temp = VarPtr(Flags2)
    
        For i = 0 To Bytes - 1
            Call RtlMoveMemoryPtr(ByVal ptr1temp, ByVal Ptr1 + i, 1)
            Call RtlMoveMemoryPtr(ByVal ptr2temp, ByVal Ptr2 + i, 1)
            
            If Flags <> Flags2 Then
                Exit Function
            End If
        Next i
        
        VariantEquals = True
    End If
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Exit Function
    Resume
End Function
    
Public Function ArrayIndex(ByVal Elem As Variant, ByRef Values As Variant) As Long
    If IsObject(Elem) Then
        'Objekte vergleichen:
        For ArrayIndex = LBound(Values(), 1) To UBound(Values(), 1)
            If IsObject(Values(ArrayIndex)) Then
                If Elem Is Values(ArrayIndex) Then
                    Exit Function
                End If
            End If
        Next ArrayIndex
    Else
        '"Normale" Value vergleichen:
        For ArrayIndex = LBound(Values(), 1) To UBound(Values(), 1)
            If Not IsObject(Values(ArrayIndex)) Then
                If Elem = Values(ArrayIndex) Then
                    Exit Function
                End If
            End If
        Next ArrayIndex
    End If
    
    'Kein Treffer:
    ArrayIndex = LBound(Values(), 1) - 1
End Function
    
Public Function ApiArrayCount(ByRef A As Variant) As Long
    Dim index As Long
    Dim Count As Long
    Dim lngDim As Long
    
    ApiArrayCount = 1
    
    lngDim = ApiDimension(A)
    
    For index = 1 To lngDim
        Count = UBound(A(), index) - LBound(A(), index) + 1
        ApiArrayCount = ApiArrayCount * Count
    Next index
End Function

Public Function ApiUBoundP(ByVal Ptr As Long, Optional ByVal Dimension As Long = 1) As Long
    Dim lngAnzahl As Long
    Dim T As SAFE_ARRAY
    
    Call RtlMoveMemory(Ptr, ByVal Ptr)
    
    If Ptr Then
        T = GetSafeArrayStructByPtr(Ptr)
    End If

    If T.Dimensions > 0 Then
        Select Case T.Bounds(Dimension - 1).LBound
            Case Is < 0
                ApiUBoundP = T.Bounds(Dimension - 1).Count - 1 + T.Bounds(Dimension - 1).LBound
            Case 0
                ApiUBoundP = T.Bounds(Dimension - 1).Count - 1
            Case Is > 0
                ApiUBoundP = T.Bounds(Dimension - 1).Count
        End Select
    Else
        ApiUBoundP = -1
    End If
End Function

Public Function ApiBoundP(ByVal Ptr As Long, Optional ByVal Dimension As Long = 1) As Long
    Dim lngAnzahl As Long
    Dim T As SAFE_ARRAY
    
    Call RtlMoveMemory(Ptr, ByVal Ptr)
    
    If Ptr Then
        T = GetSafeArrayStructByPtr(Ptr)
    End If

    If T.Dimensions Then
        ApiBoundP = T.Bounds(Dimension - 1).Count
    End If
End Function

Public Function ApiLBoundP(ByVal Ptr As Long, Optional ByVal Dimension As Long = 1) As Long
    Dim lngAnzahl As Long
    Dim T As SAFE_ARRAY
    
    Call RtlMoveMemory(Ptr, ByVal Ptr)
    
    If Ptr Then
        T = GetSafeArrayStructByPtr(Ptr)
    End If

    If T.Dimensions Then
        ApiLBoundP = T.Bounds(Dimension - 1).LBound
    Else
        ApiLBoundP = -2
    End If
End Function

Public Function ApiBound(ByRef Arr As Variant, Optional ByVal Dimension As Long = 1) As Long
    Dim arrBytes() As Variant
    
    On Error GoTo ErrHandler
    
    If IsArray(Arr) Then
        If mdlArray.ApiDimension(Arr) Then
            ApiBound = UBound(Arr, Dimension) + 1
        End If
    Else
        Call Err.Raise(vbObjectError, "SafeUBound", "Not an array")
    End If
    
    Exit Function
ErrHandler:
    MsgBox Err.Description
    Debug.Assert 0
    Resume Next
    Resume
End Function

Public Function ApiDimension(ByRef var As Variant) As Long
    Dim Ptr As Long
    Dim lngAnzahl As Long
    Dim lngWert As Long
    Dim lngTyp As Long

    If IsArray(var) Then
        Ptr = VarPtr(var) + 8 'VB-Array
        
        Call RtlMoveMemory(lngTyp, var, 1) 'Datentyp
        Call RtlMoveMemory(lngWert, ByVal VarPtr(var) + 1, 1) '0,32,64,96
        
        '64 = Untertyp
        '32 = Array
        
        Call RtlMoveMemory(Ptr, ByVal Ptr) 'SafeArrayDescriptor
        
        If Ptr Then
            If (lngWert And 64) = 64 Then '(96) hat Untertyp
                Call RtlMoveMemory(Ptr, ByVal Ptr) 'SAFE_ARRAY-Struktur
            End If
            
            If Ptr Then
                Call RtlMoveMemory(lngAnzahl, ByVal Ptr, 2)
            End If
        End If
    Else
        Call Err.Raise(vbObjectError, "Dimension", "Not an array")
    End If
    
    ApiDimension = lngAnzahl
End Function

Public Function ApiDimensionP(ByVal Ptr As Long) As Long
    Call RtlMoveMemory(Ptr, ByVal Ptr)
    
    If Ptr Then
        Call RtlMoveMemory(ApiDimensionP, ByVal Ptr, 2)
    End If
End Function

Public Function SafeUBound(ByRef Arr As Variant, Optional ByVal Dimension As Long = 1) As Long
    If IsArray(Arr) Then
        If mdlArray.ApiDimension(Arr) Then
            SafeUBound = UBound(Arr, Dimension)
        Else
            SafeUBound = -1
        End If
    Else
        SafeUBound = -1
    End If
End Function

Private Sub MinSortStringBounds(ByRef Values As Variant, _
        ByVal MinBound As Long, ByVal MaxBound As Long, ByVal Descending As Boolean, _
        Optional ByVal comparer As IComparer)
    Dim MinIndex As Long
    Dim index As Long
    
    For MinBound = MinBound To MaxBound - 1
        'Mimimum suchen:
        MinIndex = MinBound
        
        For index = MinBound + 1 To MaxBound
            If comparer Is Nothing = False Then
                If Descending Then
                    If comparer.Compare(Values(index), Values(MinIndex)) > 0 Then
                        MinIndex = index
                    End If
                Else
                    If comparer.Compare(Values(index), Values(MinIndex)) < 0 Then
                        MinIndex = index
                    End If
                End If
            ElseIf Descending Then
                If Values(index) > Values(MinIndex) Then
                    MinIndex = index
                End If
            Else
                If Values(index) < Values(MinIndex) Then
                    MinIndex = index
                End If
            End If
        Next index
        
        'Ggf. nach vorne tauschen:
        If MinIndex <> MinBound Then
            Call SwapVar(Values(MinIndex), Values(MinBound))
        End If
    Next MinBound
End Sub

Private Sub MinSortStringBounds2Dim(ByRef Values As Variant, ByVal ArrayIndex As Long, _
        ByVal MinBound As Long, ByVal MaxBound As Long, Optional ByVal Descending As Boolean, Optional ByVal comparer As IComparer)
    Dim MinIndex As Long
    Dim index As Long
    
    For MinBound = MinBound To MaxBound - 1
        'Mimimum suchen:
        MinIndex = MinBound
        
        For index = MinBound + 1 To MaxBound
            If comparer Is Nothing = False Then
                If Descending Then
                    If comparer.Compare(Values(ArrayIndex, index), Values(ArrayIndex, MinIndex)) > 0 Then
                        MinIndex = index
                    End If
                Else
                    If comparer.Compare(Values(ArrayIndex, index), Values(ArrayIndex, MinIndex)) < 0 Then
                        MinIndex = index
                    End If
                End If
            ElseIf Descending Then
                If Values(ArrayIndex, index) > Values(ArrayIndex, MinIndex) Then
                    MinIndex = index
                End If
            Else
                If Values(ArrayIndex, index) < Values(ArrayIndex, MinIndex) Then
                    MinIndex = index
                End If
            End If
        Next index
        
        'Ggf. nach vorne tauschen:
        If MinIndex <> MinBound Then
            Call ApiSwapVar2Dim(Values, MinIndex, MinBound)
        End If
    Next MinBound
End Sub

Public Sub SwapVar(ByRef A As Variant, ByRef b As Variant)
    Dim X(0 To 15) As Byte

    Call RtlMoveMemory(X(0), A, 16)
    Call RtlMoveMemory(A, b, 16)
    Call RtlMoveMemory(b, X(0), 16)
End Sub

Public Sub ApiQuickSort2Dim( _
        ByRef Values As Variant, _
        Optional ByVal ArrayIndex As Long, _
        Optional ByVal MinBound As Long = -1, _
        Optional ByVal MaxBound As Long = -1, _
        Optional ByVal Descending As Boolean, _
        Optional ByVal comparer As IComparer _
        )

    Dim MinIndex As Long
    Dim MaxIndex As Long
    Dim Pivot As Variant
    Dim index As Long
    
    If MaxBound = -1 Then MaxBound = SafeUBound(Values, 2)
    
    If MaxBound = -1 Then
        Exit Sub
    End If
    
    If MinBound = -1 Then MinBound = LBound(Values, 2)
    
    If Abs(MaxBound) - MinBound < 8 Then
        'Bei wenigen Elementen ist MinSort besser:
        Call MinSortStringBounds2Dim(Values, ArrayIndex, MinBound, MaxBound, Descending, comparer)
    Else
        'Array bzgl. Pivot-Element in zwei Hlften aufteilen:
        MinIndex = MinBound
        MaxIndex = MaxBound
        Pivot = Values(ArrayIndex, (Abs(MinBound) + MaxBound) \ 2)
        
        Do
            If Descending Then
                Do While Values(ArrayIndex, MinIndex) > Pivot
                    MinIndex = MinIndex + 1
                Loop
                
                Do While Values(ArrayIndex, MaxIndex) < Pivot
                    MaxIndex = MaxIndex - 1
                Loop
            Else
                Do While Values(ArrayIndex, MinIndex) < Pivot
                    MinIndex = MinIndex + 1
                Loop
                
                Do While Values(ArrayIndex, MaxIndex) > Pivot
                    MaxIndex = MaxIndex - 1
                Loop
            End If

            If MinIndex < MaxIndex Then
                Call ApiSwapVar2Dim(Values, MinIndex, MaxIndex)
                
                MinIndex = MinIndex + 1
                MaxIndex = MaxIndex - 1
            Else
                Exit Do
            End If
        Loop
    
        'Beide Hlften rekursiv sortieren:
        Call ApiQuickSort2Dim(Values, ArrayIndex, MinBound, MaxIndex, Descending, comparer)
        Call ApiQuickSort2Dim(Values, ArrayIndex, MinIndex, MaxBound, Descending, comparer)
    End If
End Sub

Public Sub ApiSwapVar2Dim(ByRef Values As Variant, ByVal MinIndex As Long, ByVal MaxIndex As Long)
    Dim i As Long
    Dim X(15) As Byte
    
    For i = LBound(Values) To UBound(Values)
        Call RtlMoveMemory(X(0), Values(i, MinIndex), 16)
        Call RtlMoveMemory(Values(i, MinIndex), Values(i, MaxIndex), 16)
        Call RtlMoveMemory(Values(i, MaxIndex), X(0), 16)
    Next
End Sub

Public Sub ApiQuickSort( _
        ByRef Values As Variant, _
        Optional ByVal MinBound As Long = -1, _
        Optional ByVal MaxBound As Long = -1, _
        Optional ByVal Descending As Boolean, _
        Optional ByVal comparer As IComparer _
        )

    Dim MinIndex As Long
    Dim MaxIndex As Long
    Dim Pivot As Variant
    Dim index As Long
    
    If MaxBound = -1 Then MaxBound = SafeUBound(Values, 1)
    
    If MaxBound = -1 Then
        Exit Sub
    End If
    
    If MinBound = -1 Then MinBound = LBound(Values, 1)
    
    If Abs(MaxBound) - MinBound < 8 Then
        'Bei wenigen Elementen ist MinSort besser:
        Call MinSortStringBounds(Values, MinBound, MaxBound, Descending, comparer)
    Else
        'Array bzgl. Pivot-Element in zwei Hlften aufteilen:
        MinIndex = MinBound
        MaxIndex = MaxBound
        Pivot = Values((Abs(MinBound) + MaxBound) \ 2)
        
        Do
            If comparer Is Nothing = False Then
                If Descending Then
                    Do While comparer.Compare(Values(MinIndex), Pivot) < 0
                        MinIndex = MinIndex + 1
                    Loop
                    
                    Do While comparer.Compare(Values(MaxIndex), Pivot) > 0
                        MaxIndex = MaxIndex - 1
                    Loop
                Else
                    Do While comparer.Compare(Values(MinIndex), Pivot) > 0
                        MinIndex = MinIndex + 1
                    Loop
                    
                    Do While comparer.Compare(Values(MaxIndex), Pivot) < 0
                        MaxIndex = MaxIndex - 1
                    Loop
                End If
            ElseIf Descending Then
                Do While Values(MinIndex) > Pivot
                    MinIndex = MinIndex + 1
                Loop
                
                Do While Values(MaxIndex) < Pivot
                    MaxIndex = MaxIndex - 1
                Loop
            Else
                Do While Values(MinIndex) < Pivot
                    MinIndex = MinIndex + 1
                Loop
                
                Do While Values(MaxIndex) > Pivot
                    MaxIndex = MaxIndex - 1
                Loop
            End If

            If MinIndex < MaxIndex Then
                Call SwapVar(Values(MinIndex), Values(MaxIndex))
                
                MinIndex = MinIndex + 1
                MaxIndex = MaxIndex - 1
            Else
                Exit Do
            End If
        Loop
    
        'Beide Hlften rekursiv sortieren:
        Call ApiQuickSort(Values, MinBound, MaxIndex, Descending, comparer)
        Call ApiQuickSort(Values, MinIndex, MaxBound, Descending, comparer)
    End If
End Sub
