Attribute VB_Name = "mdlDecision"
Option Explicit

Public Property Get ApiUIf(ByRef TrueValue As Variant, Optional ByRef FalseValue As Variant) As Variant
    If SafeIsMissing(FalseValue) Then
        FalseValue = Empty
    End If
    
    Select Case VarType(TrueValue)
        Case vbVariant
            If IsNumeric(TrueValue) Then
                If TrueValue Then
                    ApiUIf = TrueValue
                Else
                    ApiUIf = FalseValue
                End If
            Else
                If Len(TrueValue) > 0 Then
                    ApiUIf = TrueValue
                Else
                    ApiUIf = FalseValue
                End If
            End If
        Case vbByte, vbDecimal, vbCurrency, vbLong, vbInteger, vbBoolean, vbSingle, vbDouble
            If TrueValue Then
                ApiUIf = TrueValue
            Else
                ApiUIf = FalseValue
            End If
        Case vbObject
            If TrueValue Is Nothing Then
                Set ApiUIf = FalseValue
            Else
                Set ApiUIf = TrueValue
            End If
        Case vbEmpty
            ApiUIf = FalseValue
        Case vbString
            If Len(TrueValue) Then
                ApiUIf = TrueValue
            Else
                ApiUIf = FalseValue
            End If
        Case vbDate
            If IsDate(TrueValue) Then
                If TrueValue <> Empty Then
                    ApiUIf = TrueValue
                Else
                    ApiUIf = FalseValue
                End If
            Else
                ApiUIf = FalseValue
            End If
        Case vbNull
            If IsNull(TrueValue) Then
                ApiUIf = FalseValue
            Else
                ApiUIf = TrueValue
            End If
    End Select
End Property
