Attribute VB_Name = "mdlFunctions"
' Send email using Outlook Express (IE4 or Higher)
' Developed by: Guillermo F. Zambianchi - gzambianchi@hotmail.com
' Based upon code and ideas from Bruno Paris
' Bruno's Code only sends a TXT as Attachs
' This code allows to attach any kind of file (zip/doc/xls/etc)

Option Explicit
' API declarations

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOWNORMAL = 1
'
Private Const bnd = "_NextPart_001_"     ' boundary
Private Const CharSet = "windows-1252"   'or "iso-8859-2"   or "windows-1250"

Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, _
    lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Private Declare Function FlushFileBuffers Lib "kernel32" ( _
    ByVal hFile As Long) As Long

Private Declare Function CreateFile Lib "kernel32" _
    Alias "CreateFileA" (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) _
    As Long

'##########
Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal _
        hwnd As Long, ByVal msg As Long, ByVal wParam As _
        Long, ByVal lParam As Long) As Long

'Lokale Dateinummer freigeben
Private Declare Function WriteFile Lib "kernel32.dll" (ByVal hFile As Long, ByRef lpBuffer As Byte, ByVal nNumberOfBytesToWrite As Long, ByRef lpNumberOfBytesWritten As Long, ByRef lpOverlapped As Any) As Long

'#######

'Private Declare Function SetThreadLocale Lib "kernel32.dll" ( _
'     ByVal Locale As Long) As Long
'
'Public Sub SetThreadLocaleApi(ByVal LcId As Long)
'    Const SORT_DEFAULT As Long = &H0
'    Const LANG_ENGLISH As Long = &H9
'
'    Call SetThreadLocale(LcId)
'
'    call SetThreadLocale(DWORD(Word(SORT_DEFAULT) shl 16) or DWORD(Word(LANG_ENGLISH)));
'End Sub

Public Function IsValidHandle(ByVal Handle As Long) As Boolean

    Const INVALID_HANDLE_VALUE = -1
    
    Select Case Handle
    Case 0, INVALID_HANDLE_VALUE
    Case Else
        IsValidHandle = True
    End Select
    
End Function

Public Function GetBitsByOrdinal( _
    ByRef Bits As Variant, _
    Optional ByVal StartBit As Byte = 0, _
    Optional ByVal EndBit As Byte = 0 _
    ) As Variant
    
    If StartBit > EndBit Then
        Call Err.Raise(vbObjectError + 1080, "GetBitsByOrdinal", "StartBit cannot be higher than EndBit")
    Else
        GetBitsByOrdinal = GetBits(Bits, StartBit + 1, EndBit - StartBit + 1)
    End If
End Function

Public Function GetBits( _
    ByRef Bits As Variant, _
    Optional ByVal StartBit As Byte = 1, _
    Optional ByVal BitCount As Byte = 0 _
    ) As Variant
    
    If Bits <= 0 Or StartBit = 0 Then
        Exit Function
    End If
    
    Select Case VarType(Bits)
        Case vbDecimal
        Case Else
            Bits = CDec(Bits)
    End Select
    
    If StartBit + BitCount - 1 > 96 Then
        Call Err.Raise(vbObjectError + 1, "GetBits", "More than 96 Bits are not supported.")
    End If
    
    If StartBit > 1 Then
        Bits = Int(Bits / PowOf2(StartBit - 1))
        
        If Bits > PowOf2(92) And AndEx(Bits, 1) = 1 Then
            Bits = Bits - 1
        End If
    End If
    
    If BitCount = 0 Then
        BitCount = 96 - (StartBit - 1)
    End If
    
    If Bits = 0 Then Exit Function
    
    If StartBit > 1 Or BitCount < 96 Then
        GetBits = AndEx(Bits, PowOf2(BitCount) - 1)
    Else
        GetBits = Bits
    End If
End Function

Public Function XorEx(ByVal Var1 As Variant, ByVal Var2 As Variant) As Variant
    Dim Lng1(1 To 4) As Long
    Dim Lng2(1 To 4) As Long
    Dim i As Long
    
    Select Case VarType(Var1)
        Case 17, 2, 3, 4, 5, 6, 11
            Var1 = CDec(Var1)
        Case 14
        Case Else
            Exit Function
    End Select
    
    Select Case VarType(Var2)
        Case 17, 2, 3, 4, 5, 6, 11
            Var2 = CDec(Var2)
        Case 14
        Case Else
            Exit Function
    End Select
        
    Call RtlMoveMemory(Lng1(1), Var1, 16)
    Call RtlMoveMemory(Lng2(1), Var2, 16)

    For i = 2 To 4
        Lng2(i) = Lng2(i) Xor Lng1(i)
    Next i
    
    XorEx = CDec(0)
    
    Call RtlMoveMemory(ByVal VarPtr(XorEx) + 4, Lng2(2), 12)
End Function

Public Function OrEx(ByVal Var1 As Variant, ByVal Var2 As Variant) As Variant
    Dim Lng1(1 To 4) As Long
    Dim Lng2(1 To 4) As Long
    Dim i As Long
    
    Select Case VarType(Var1)
        Case 17, 2, 3, 4, 5, 6, 11
            Var1 = CDec(Var1)
        Case 14
        Case Else
            Exit Function
    End Select
    
    Select Case VarType(Var2)
        Case 17, 2, 3, 4, 5, 6, 11
            Var2 = CDec(Var2)
        Case 14
        Case Else
            Exit Function
    End Select
        
    Call RtlMoveMemory(Lng1(1), Var1, 16)
    Call RtlMoveMemory(Lng2(1), Var2, 16)

    For i = 2 To 4
        Lng2(i) = Lng2(i) Or Lng1(i)
    Next i
    
    OrEx = CDec(0)
    
    Call RtlMoveMemory(ByVal VarPtr(OrEx) + 4, Lng2(2), 12)
End Function

Public Function AndEx(ByVal Var1 As Variant, ByVal Var2 As Variant) As Variant
    Dim Lng1(1 To 4) As Long
    Dim Lng2(1 To 4) As Long
    Dim i As Long
    
    Select Case VarType(Var1)
        Case 17, 2, 3, 4, 5, 6, 11
            Var1 = CDec(Var1)
        Case 14
        Case Else
            Exit Function
    End Select
    
    Select Case VarType(Var2)
        Case 17, 2, 3, 4, 5, 6, 11
            Var2 = CDec(Var2)
        Case 14
        Case Else
            Exit Function
    End Select
        
    Call RtlMoveMemory(Lng1(1), Var1, 16)
    Call RtlMoveMemory(Lng2(1), Var2, 16)

    For i = 2 To 4
        Lng2(i) = Lng2(i) And Lng1(i)
    Next i
    
    AndEx = CDec(0)
    
    Call RtlMoveMemory(ByVal VarPtr(AndEx) + 4, Lng2(2), 12)
End Function

'Public Function IsVarTypeCompatibility(ByRef Var1 As Variant, ByRef Var2 As Variant) As Boolean
'    Select Case VarType(Var1)
'        Case vbDecimal
'            Select Case VarType(Var2)
'                Case vbDecimal
'                    IsVarTypeCompatibility = True
'            End Select
'        Case vbByte, vbInteger, vbLong
'            Select Case VarType(Var2)
'                Case vbByte, vbInteger, vbLong
'                    IsVarTypeCompatibility = True
'            End Select
'        Case vbBoolean
'            Select Case VarType(Var2)
'                Case vbBoolean
'                    IsVarTypeCompatibility = True
'            End Select
'        Case vbSingle, vbDouble
'            Select Case VarType(Var2)
'                Case vbSingle, vbDouble
'                    IsVarTypeCompatibility = True
'            End Select
'        Case vbCurrency
'            Select Case VarType(Var2)
'                Case vbCurrency
'                    IsVarTypeCompatibility = True
'            End Select
'        Case vbDate
'            Select Case VarType(Var2)
'                Case vbDate
'                    IsVarTypeCompatibility = True
'            End Select
'        Case vbString
'            Select Case VarType(Var2)
'                Case vbString
'                    IsVarTypeCompatibility = True
'            End Select
'    End Select
'End Function

Public Function GetVarByteSize(ByVal VarType As VbVarType) As Long
    Select Case VarType And Not vbArray
        Case vbDecimal
            GetVarByteSize = 12
        Case vbByte
            GetVarByteSize = 1
        Case vbInteger, vbBoolean
            GetVarByteSize = 2
        Case vbObject, vbSingle, vbLong, vbDataObject, vbString
            GetVarByteSize = 4
        Case vbDouble, vbCurrency, vbDate
            GetVarByteSize = 8
    End Select
End Function

Public Function SizeOf(ByRef var As Variant) As Long
    Select Case VarType(var)
        Case vbString
            SizeOf = LenB(var)
        Case Else
            SizeOf = GetVarByteSize(VarType(var))
    End Select
End Function

Public Function NotEx(ByVal var As Variant) As Variant
    Dim Lng1(1 To 4) As Long
    Dim i As Long
    
    Select Case VarType(var)
        Case 17, 2, 3, 4, 5, 6, 11
            var = CDec(var)
        Case 14
        Case Else
            Exit Function
    End Select
        
    Call RtlMoveMemory(Lng1(1), var, 16)

    For i = 2 To 4
        Lng1(i) = Not Lng1(i)
    Next i
    
    NotEx = CDec(0)
    
    Call RtlMoveMemory(ByVal VarPtr(NotEx) + 4, Lng1(2), 12)
End Function

Public Function PowOf2(ByVal Power As Byte) As Variant
    Dim i As Long
    
    If Power > 49 Then
        If Power = 96 Then '2^96-1
            PowOf2 = CDec(0)
            i = -1
            
            Call RtlMoveMemory(ByVal VarPtr(PowOf2) + 4, i, 4)
            Call RtlMoveMemory(ByVal VarPtr(PowOf2) + 8, i, 4)
            Call RtlMoveMemory(ByVal VarPtr(PowOf2) + 12, i, 4)
        ElseIf Power > 96 Then
            Call Err.Raise(vbObjectError + 2, "PowOf2", "A power higher than 96 is not supported.")
        Else
            PowOf2 = CDec(2 ^ 49)
            
            For i = 50 To Power
                PowOf2 = PowOf2 * 2
            Next i
        End If
    Else
        PowOf2 = CDec(2 ^ Power)
    End If
End Function

Public Function GetBitMask( _
        Optional ByVal StartBit As Byte = 1, _
        Optional ByVal BitCount As Byte = 0 _
        ) As Variant
    Dim i As Long
    Dim Mask As Long
    
    If BitCount = 0 Then
        BitCount = 96 - (StartBit - 1)
    End If
    
    If BitCount = 96 Then
        GetBitMask = PowOf2(96)
    Else
        For i = StartBit - 1 To StartBit - 1 + (BitCount - 1)
            GetBitMask = OrEx(GetBitMask, PowOf2(i))
        Next i
    End If
End Function

Public Function GetNumberFromText( _
        ByVal Text As String, _
        Optional ByVal SpecialChars As String = " .,_", _
        Optional ByVal BitsPerChar As Byte = 5 _
        ) As Variant
    Dim i As Long
    Dim bar() As Byte
    Dim ret As Variant
    Dim j As Long
    
    If BitsPerChar < 5 Then
        Call Err.Raise(vbObjectError + 5, "GetNumberFromText", "Cannot use less than 5 bits per char.")
    ElseIf Len(SpecialChars) + 26 > 2 ^ BitsPerChar Then
        Call Err.Raise(vbObjectError + 5, "GetNumberFromText", "Too many special chars or too less bits per char.")
    End If
    
    ret = CDec(0)
    
    For i = 1 To Len(Text)
        For j = 1 To Len(SpecialChars)
            If InStr(1, Mid$(Text, i, 1), Mid$(SpecialChars, j, 1)) > 0 Then
                Mid$(Text, i, 1) = Chr$(90 + j)
                
                Exit For
            End If
    Next j, i
    
    bar = StrConv(Left$(Text, 19), vbFromUnicode)
    
    For i = UBound(bar) To 0 Step -1
        Select Case bar(i)
            Case Is < 64, Is > 64 + (2 ^ BitsPerChar)
                Call Err.Raise(vbObjectError + 3, "GetNumberFromText", "Invalid Character found that cannot be stored. You may update the SpecialChars list.")
        End Select
    
        ret = (ret * (2 ^ BitsPerChar)) + (bar(i) And ((2 ^ BitsPerChar) - 1))
    Next i

    GetNumberFromText = ret
End Function

Public Function GetTextFromNumber( _
        ByRef Number As Variant, _
        Optional ByVal SpecialChars As String = " .,_", _
        Optional ByVal BitsPerChar As Byte = 5 _
        ) As String
    Dim bar(18) As Byte
    Dim Ptr As Long
    Dim i As Long
    Dim j As Long
    Dim Temp As Variant
    
    If BitsPerChar < 5 Then
        Call Err.Raise(vbObjectError + 5, "GetNumberFromText", "Cannot use less than 5 bits per char.")
    ElseIf Len(SpecialChars) + 26 > 2 ^ BitsPerChar Then
        Call Err.Raise(vbObjectError + 5, "GetNumberFromText", "Too many special chars or too less bits per char.")
    End If
    
    Temp = CDec(Number)
    
    Do While Temp
        Call RtlMoveMemory(bar(Ptr), ByVal VarPtr(Temp) + 8, 1)
        
        bar(Ptr) = (bar(Ptr) And (2 ^ BitsPerChar) - 1) + 64
        Temp = Int(Temp / (2 ^ BitsPerChar))
        Ptr = Ptr + 1
    Loop

    GetTextFromNumber = Left$(StrConv(bar, vbUnicode), Ptr)
    
    For i = 1 To Ptr
        For j = 1 To Len(SpecialChars)
            If InStr(1, Mid$(GetTextFromNumber, i, 1), Chr$(90 + j)) > 0 Then
                Mid$(GetTextFromNumber, i, 1) = Mid$(SpecialChars, j, 1)
                
                Exit For
            End If
    Next j, i
End Function

Private Function ap_OpenFileReadOnly(ByVal sFilename As String) As Long
' Wrapper around Windows API fn to open a file for read only
' Returns INVALID_HANDLE_VALUE (-1) if it fails.
    Const INVALID_HANDLE_VALUE = -1
    Const GENERIC_WRITE = &H40000000
    Const GENERIC_READ = &H80000000
    Const FILE_ATTRIBUTE_NORMAL = &H80
    Const CREATE_NEW = 1
    Const CREATE_ALWAYS = 2
    Const OPEN_EXISTING = 3
    Const OPEN_ALWAYS = 4
    Const TRUNCATE_EXISTING = 5
    Const FILE_SHARE_READ As Long = &H1
    Const FILE_SHARE_WRITE As Long = &H2

    ap_OpenFileReadOnly = CreateFile(sFilename, GENERIC_READ, FILE_SHARE_WRITE Or FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
End Function

Public Function GetFileBytes(ByVal strDatei As String, Optional ByRef strInhalt As String, Optional ByVal NoString As Boolean) As Byte()
    Dim f As Long

    f = ap_OpenFileReadOnly(strDatei)
    
    If f <> -1 Then
        If ap_GetBytes(f, GetFileBytes, ApiGetFileSize(strDatei)) Then
            If Not NoString Then
                If ApiBound(GetFileBytes) > 0 Then
                    strInhalt = GetFileBytes
                    
                    If Not IsUniCode(strInhalt) Then
                        strInhalt = StrConv(GetFileBytes, vbUnicode)
                    End If
                End If
            End If
        End If
        
        If Not ap_CloseFile(f) Then
            Debug.Assert 0
        End If
    End If
End Function

Private Function ap_GetBytes(ByVal fHandle As Long, ByRef aBytes() As Byte, ByVal BytesToRead As Currency) As Boolean
' Reads n bytes from open file
    Dim fSuccess As Long
    Dim lBytesRead As Long
    Dim lBytesToRead As Long
    
    If BytesToRead = 0 Then: Exit Function
    
    If BytesToRead > &H7FFFFFF Then
        lBytesToRead = -(BytesToRead - &H7FFFFFFF)
    Else
        lBytesToRead = BytesToRead
    End If
    
    If SafeUBound(aBytes()) < BytesToRead - 1 Then
        ReDim aBytes(BytesToRead - 1)
    End If
    
    fSuccess = ReadFile(fHandle, aBytes(0), lBytesToRead, lBytesRead, 0)
    ap_GetBytes = (fSuccess <> 0)
End Function

Private Function ap_CloseFile(ByVal fHandle As Long) As Boolean
' Flush the file buffers to force writing of the data.
    Dim fSuccess As Long
    
    fSuccess = FlushFileBuffers(fHandle)
    fSuccess = CloseHandle(fHandle)
    ap_CloseFile = (fSuccess <> 0)
End Function

Public Function CreateShortcut(ByVal FileName As String, _
        ByVal ShortcutName As String, _
        Optional ByVal Folder As SpecialFolder = SpecialFolder.CSIDL_DESKTOP, _
        Optional ByVal Description As String, _
        Optional ByVal Hotkey As String, _
        Optional ByVal Overwrite As Boolean) As Boolean
    Dim strOrdner As String
    Dim cWScriptShortcut As Object
    Dim cWScript As Object
    Dim strPath As String
    
    On Error GoTo ErrHandler
    
    strPath = ApiGetDirectory(Folder)
    
    Set cWScript = CreateObject("WScript.Shell")

    If Not Overwrite And ApiFileExists(strPath & ShortcutName & ".lnk") Then
        CreateShortcut = True
    
        Exit Function
    End If

    Set cWScriptShortcut = cWScript.CreateShortcut(strPath & ShortcutName & ".lnk")

    cWScriptShortcut.Description = Description

    If Len(Hotkey) Then
        cWScriptShortcut.Hotkey = Hotkey
    End If

    cWScriptShortcut.WorkingDirectory = strPath
    cWScriptShortcut.TargetPath = FileName

    Call cWScriptShortcut.Save
    
    CreateShortcut = True
    
    Exit Function
ErrHandler:
    MsgBox Err.Description
    Resume Next
    Resume
End Function

