Attribute VB_Name = "mdlIO"
Option Explicit

Private Declare Function CopyFileEx Lib "kernel32.dll" Alias "CopyFileExA" ( _
     ByVal lpExistingFileName As String, _
     ByVal lpNewFileName As String, _
     ByVal lpProgressRoutine As Long, _
     ByRef lpData As Any, _
     ByRef pbCancel As Long, _
     ByVal dwCopyFlags As Long) As Long

Private Declare Function GetSystemDirectory Lib "kernel32" _
        Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, _
        ByVal nSize As Long) As Long

Private Declare Function GetTempPath Lib "kernel32" _
        Alias "GetTempPathA" (ByVal nBufferLength As Long, _
        ByVal lpBuffer As String) As Long

Private Declare Function GetWindowsDirectory Lib "kernel32" _
        Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, _
        ByVal nSize As Long) As Long

Private Const kLength As Long = 255&

Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" ( _
        ByVal pidl As Long, _
        ByVal pszPath As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" ( _
        ByVal hwndOwner As Long, _
        ByVal nFolder As Long, _
        pidl As SHITEMID) As Long
        
Private Type SHITEMID
    cb As Long
    abID As Byte
End Type

Private strGetSysDir As String
Private strGetTempDir As String
Private strGetWinDir As String

Private Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" ( _
    ByVal lpszFile As String, _
    ByVal lpszTitle As String, _
    ByVal cbBuf As Long _
) As Long

Private Declare Function lclose Lib "kernel32.dll" Alias "_lclose" ( _
     ByVal hFile As Long) As Long
Private Declare Function lopen Lib "kernel32.dll" Alias "_lopen" ( _
     ByVal lpPathname As String, _
     ByVal iReadWrite As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long

Private Const FILE_BEGIN As Long = 0

Private Const OPEN_EXISTING As Long = 3
Private Const OPEN_ALWAYS As Long = 4
Private Const OPEN_FORCE As Long = 1
Private Const OPEN_IF_EXISTS As Long = (&H1)
Private Const OPEN_TEST As Long = 0

Private Const INVALID_HANDLE_VALUE = -1

Private Const GENERIC_WRITE As Long = &H40000000
Private Const GENERIC_READ As Long = &H80000000
Private Const GENERIC_ALL As Long = &H10000000
Private Const GENERIC_EXECUTE As Long = &H20000000

Private Const FILE_SHARE_READ As Long = &H1
Private Const FILE_SHARE_WRITE As Long = &H2
Private Const FILE_SHARE_DELETE As Long = &H4

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long

Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, _
    ByVal lDistanceToMove As Long, _
    lpDistanceToMoveHigh As Long, _
    ByVal dwMoveMethod As Long) As Long
    
Private Declare Function SetEndOfFile Lib "kernel32" (ByVal hFile As Long) As Long

Private Type SHFILEOPTSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Long
    hNameMappings As Long
    lpszProgressTitle As Long
End Type

Private Declare Function SHFileOperation Lib "shell32.dll" _
  Alias "SHFileOperationA" (lpFileOp As SHFILEOPTSTRUCT) As Long
  
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40

''''

Private Declare Function OpenFile Lib "kernel32.dll" ( _
     ByVal lpFileName As String, _
     ByRef lpReOpenBuff As OFSTRUCT, _
     ByVal wStyle As Long) As Long
     
Private Const OFS_MAXPATHNAME As Long = 128
     
Private Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

''''

Public Function RecycleFile(ByRef FilePath As String) As Long
    Dim X As SHFILEOPTSTRUCT
    
    X.pFrom = FilePath
    X.wFunc = FO_DELETE
    X.fFlags = FOF_ALLOWUNDO
    
    RecycleFile = SHFileOperation(X)
    
    If RecycleFile <> 0 Then
        ' hier knnte man auf ErrHandler reagieren
    End If
End Function

Public Function SetEof(FileName As String, ByVal EOF As Currency) As Boolean
    Dim hFile As Long
    Dim lReturn As Long
    Dim DistanceToMoveHigh As Long
    Dim DistanceToMoveLow As Long
    
    If EOF > &HFFFFFFFF Then
        DistanceToMoveLow = &HFFFFFFFF
        DistanceToMoveHigh = EOF - &HFFFFFFFF
    ElseIf EOF > &H7FFFFFFF Then
        DistanceToMoveLow = -(EOF - &H7FFFFFFF)
    Else
        DistanceToMoveLow = EOF
    End If
    
    hFile = CreateFile(FileName, GENERIC_WRITE, 0&, ByVal 0&, OPEN_EXISTING, 0&, 0&)
    
    If hFile = INVALID_HANDLE_VALUE Then
        SetEof = False
    Else
        lReturn = SetFilePointer(hFile, DistanceToMoveLow, DistanceToMoveHigh, FILE_BEGIN)
        
        If lReturn = -1& Then
            SetEof = False
        Else
            SetEof = SetEndOfFile(hFile)
        End If
        
        Call CloseHandle(hFile)
    End If
End Function

Public Function CanGetExclusiveAccess(ByRef FilePath As String, Optional ByVal ReadAccess As Boolean, Optional ByVal CanDelete As Boolean) As Boolean
    Dim hFile  As Long
    Dim Mode As Long
    Dim ModeShare As Long
    
    On Error GoTo ErrHandler
    
    If CanDelete Then
        Mode = GENERIC_ALL
        ModeShare = FILE_SHARE_DELETE
    ElseIf ReadAccess Then
        Mode = GENERIC_READ
        ModeShare = FILE_SHARE_READ Or FILE_SHARE_WRITE
    Else
        Mode = GENERIC_WRITE
    End If
    
    hFile = CreateFile(FilePath, Mode, ModeShare, ByVal 0&, OPEN_EXISTING, 0, 0)
    
    If hFile <> INVALID_HANDLE_VALUE Then
        CanGetExclusiveAccess = True
        Call CloseHandle(hFile)
    End If
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    
    If Err.Number = 53 Then
        CanGetExclusiveAccess = True
    End If
    
    Exit Function
    Resume
End Function

Public Function GetShortPath(ByVal FilePath As String) As String
    Dim buffer As String
    Dim Lang As Long
    
    buffer = Space$(255)
    Lang = Len(buffer)
    
    Call GetShortPathName(FilePath, buffer, Lang)
    
    If InStr(1, buffer, vbNullChar) Then
        GetShortPath = Left$(buffer, InStr(1, buffer, vbNullChar) - 1)
    Else
        GetShortPath = FilePath
    End If
End Function
     
Public Function ApiKillDirectory(ByVal Path As String) As Boolean
    On Error GoTo ErrHandler

    Call RmDir(Path)
    
    ApiKillDirectory = True
ErrHandler:
End Function

Public Function ApiIsFileAlreadyOpen(ByVal FilePath As String) As Boolean
    Dim hFile As Long
    Dim LastErr As Long

    hFile = -1
    LastErr = 0

    hFile = lopen(FilePath, &H10)
    
    If hFile = -1 Then
        LastErr = Err.LastDllError
    Else
        Call lclose(hFile)
    End If
    
    If (hFile = -1) And (LastErr = 32) Then
        ApiIsFileAlreadyOpen = True
    End If
End Function

Public Function ApiCreateDirectoryPath(ByRef Path As String, _
        Optional RaiseError As Boolean = True) As Boolean
    Dim i As Long
    Dim strTempOrdner As String
    Dim arrStrPfade() As String
    Dim j As Long
    Dim u As Long
    Dim m As Long
    Dim boolNetwork As String
    
    If Not RaiseError Then
        On Error GoTo ErrHandler
    End If
    
    arrStrPfade() = Split(Path, ",")
    
    u = UBound(arrStrPfade(), 1)
    
    For j = 0 To u
        Call ApiAddSlash(arrStrPfade(j))
        
        If j = 0 Then
            If UBound(arrStrPfade(), 1) = 0 Then
                Path = arrStrPfade(j)
            End If
        End If
        
        strTempOrdner = arrStrPfade(j)
        
        m = ApiStrCount(arrStrPfade(j)) - 1
        
        boolNetwork = Left$(strTempOrdner, 2) = "\\"
        
        For i = m To 0 Step -1
            strTempOrdner = ApiAddSlash(ApiGetFilePath(arrStrPfade(j), , i + 1))
            
            If Len(strTempOrdner) > 2 And IIf(boolNetwork, i < m - 2, True) Then
                If Len(Dir$(strTempOrdner, vbDirectory)) = 0 Then
                    Call MkDir(strTempOrdner)
                End If
            End If
    Next i, j
    
    ApiCreateDirectoryPath = True
    
    Exit Function
ErrHandler:
End Function

Public Function ApiCopyFileEx( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal CopyTheseFileExtensions As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal IncludeSubDirs As Boolean, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean, _
        Optional ByVal OnlyMove As Boolean _
        ) As Boolean
    Dim arrStrDateiNamen() As String
    Dim i As Long
    Dim strNeueZielDatei As String
    Dim strNeueQuellDatei As String
    Dim u As Long
    Dim arrStrOrdner() As String
    
    If Not RaiseError Then
        On Error GoTo ErrHandler
    End If
    
    If Len(SourcePath) = 0 Then
        Exit Function
    ElseIf Len(ApiGetFilePath(SourcePath)) = 0 Then
        Exit Function
    End If
    
    Call ApiAddSlash(SourcePath)
    Call ApiAddSlash(TargetPath)
    Call ApiCreateDirectoryPath(TargetPath)
    
    If InStr(SourcePath, "*") > 0 Then
        arrStrDateiNamen() = ApiFindFilesOrFolders(SourcePath)
        
        u = SafeUBound(arrStrDateiNamen(), 1)
        
        If u > -1 Then
            Call ApiCreateDirectoryPath(TargetPath)
            
            Dim FileName As String
            
            For i = 0 To u
                FileName = ApiGetFileName(arrStrDateiNamen(i))
            
                If ApiGetFileBasename(SourcePath) <> ApiGetFileBasename(TargetPath) Then
                    If ApiIsFolder(TargetPath) = False Then
                        If InStr(ApiGetFileBasename(TargetPath), "*") > 0 Then
                            strNeueZielDatei = ApiAddSlash(ApiGetFilePath(TargetPath)) & ApiGetFileBasename(FileName) & ApiGetFileExtension(FileName, True)
                        Else
                            If InStr(TargetPath, ".") > 0 And InStr(TargetPath, "..") = 0 Then
                                strNeueZielDatei = ApiAddSlash(ApiGetFilePath(TargetPath)) & ApiGetFileBasename(TargetPath) & ApiGetFileExtension(FileName, True)
                            Else
                                strNeueZielDatei = ApiAddSlash(ApiGetFilePath(TargetPath)) & FileName
                            End If
                        End If
                    End If
                Else
                    strNeueZielDatei = ApiAddSlash(ApiGetFilePath(TargetPath)) & FileName
                End If
                
                strNeueQuellDatei = ApiAddSlash(ApiGetFilePath(SourcePath)) & FileName
            
'                DoEvents
            
                If Len(CopyTheseFileExtensions) > 0 Then
                    If ApiIsInstrEx(CopyTheseFileExtensions, ApiGetFileExtension(FileName)) Then
                        If InStr(strNeueZielDatei, ".") > 0 And InStr(strNeueZielDatei, "..") = 0 Then
                            ApiCopyFileEx = ApiCopyFile(strNeueQuellDatei, strNeueZielDatei, OverwriteFiles, OnlyIfNewer, RaiseError, OnlyMove)
                        Else
                            ApiCopyFileEx = ApiCopyFile(strNeueQuellDatei, TargetPath & FileName, OverwriteFiles, OnlyIfNewer, RaiseError, OnlyMove)
                        End If
                    End If
                Else
                    If Not ApiIsFolder(TargetPath) Then
                        ApiCopyFileEx = ApiCopyFile(strNeueQuellDatei, strNeueZielDatei, OverwriteFiles, OnlyIfNewer, RaiseError, OnlyMove)
                    Else
                        ApiCopyFileEx = ApiCopyFile(strNeueQuellDatei, TargetPath & FileName, OverwriteFiles, OnlyIfNewer, RaiseError, OnlyMove)
                    End If
                End If
            Next i
        End If
        
        If IncludeSubDirs Then
            arrStrOrdner() = ApiFindFilesOrFolders(SourcePath, , True)
        End If
        
        For i = 0 To SafeUBound(arrStrOrdner())
            ApiCopyFileEx = ApiCopyFileEx( _
                    ApiAddSlash(ApiGetFilePath(SourcePath)) & arrStrOrdner(i) & "\" & ApiGetFileName(SourcePath), _
                    ApiAddSlash(ApiGetFilePath(TargetPath)) & arrStrOrdner(i) & "\", _
                    CopyTheseFileExtensions, _
                    OverwriteFiles, _
                    IncludeSubDirs, _
                    OnlyIfNewer, _
                    RaiseError)
  
            If Not ApiCopyFileEx Then
                Debug.Assert 0
            
                Exit Function
            End If
        Next i
    Else
        Call ApiCreateDirectoryPath(TargetPath)
    
        If Not ApiIsFolder(TargetPath) Then
            ApiCopyFileEx = ApiCopyFile(SourcePath, TargetPath, OverwriteFiles, RaiseError, OnlyMove)
        Else
            strNeueZielDatei = ApiGetFileName(TargetPath)
            
            If Len(strNeueZielDatei) > 0 Then
                ApiCopyFileEx = ApiCopyFile(SourcePath, TargetPath, OverwriteFiles, OnlyIfNewer, RaiseError, OnlyMove)
            Else
                ApiCopyFileEx = ApiCopyFile(SourcePath, TargetPath & ApiGetFileName(SourcePath), OverwriteFiles, OnlyIfNewer, RaiseError, OnlyMove)
            End If
        End If
    End If
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Exit Function
    Resume
End Function

Public Function ApiCopyFile( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean, _
        Optional ByVal OnlyMove As Boolean _
        ) As Boolean
    Dim boolFileExists As Boolean
    
    If Not RaiseError Then
        On Error GoTo ErrHandler
    End If
    
    boolFileExists = ApiFileExists(TargetPath)
    
    If OverwriteFiles Or Not boolFileExists Then
'        Call ApiCreateDirectoryPath(TargetPath)
        
        If ApiFileExists(SourcePath) Then
            If OnlyIfNewer And boolFileExists Then
                If FileDateTime(SourcePath) < FileDateTime(TargetPath) Then
                    ApiCopyFile = True
                    
                    Exit Function
                End If
            End If
            
            If boolFileExists Then
'                If (GetAttr(TargetPath) And vbReadOnly) = vbReadOnly Then
'                    Call SetAttr(TargetPath, GetAttr(TargetPath) Xor vbReadOnly)
'                End If
                If CanGetExclusiveAccess(TargetPath, False) Then
                    Call Kill(TargetPath)
                Else
                    Call Err.Raise(vbObjectError, , "Cannot get exclusiv write access for target file '" & TargetPath & "'")
                End If
            End If
            
            If CanGetExclusiveAccess(SourcePath, True) Then
                If OnlyMove Then
                    Name SourcePath As TargetPath
                Else
                    Call FileCopy(SourcePath, TargetPath)
                End If
            ElseIf RaiseError Then
                Call Err.Raise(vbObjectError, , "Cannot get exclusiv read access for source file '" & SourcePath & "'")
            End If
            
            ApiCopyFile = True
        End If
    End If

    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Err.Source = SourcePath
    If Err.Number <> 70 Then
        Debug.Assert 0
    End If
    
    Exit Function
    Resume
End Function

Public Function ApiFileTitle(ByVal FilePath As String) As String
    Dim T As String
    Dim lngSizeNeeded As Long
    
    lngSizeNeeded = GetFileTitle(FilePath, vbNullString, 0&)
    T = Space$(lngSizeNeeded + 1)
    
    If GetFileTitle(FilePath, T, Len(T) - 1) = 0 Then
        ApiFileTitle = T
    End If
End Function

Public Function ApiGetSysDir() As String
    Dim nBuffer As String
    Dim nReturn As Long

    If Len(strGetSysDir) = 0 Then
        nBuffer = Space$(kLength)
        nReturn = GetSystemDirectory(nBuffer, kLength)
        
        If nReturn > 0 Then
            strGetSysDir = Left$(nBuffer, nReturn) & "\"
        End If
    End If
    
    ApiGetSysDir = strGetSysDir
End Function

Public Function ApiGetFileSize(ByVal FilePath As String) As Currency
    Dim hSearch As Long
    Dim wFD As WIN32_FIND_DATA
    
    On Error GoTo ErrHandler
    
    hSearch = FindFirstFile(FilePath, wFD)
    
    If hSearch <> INVALID_HANDLE_VALUE Then
        ApiGetFileSize = GetLargeSize(wFD.nFileSizeHigh, wFD.nFileSizeLow)
        
        Call FindClose(hSearch)
    End If
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    ApiGetFileSize = -1
    
    Exit Function
    Resume
    Resume Next
End Function

Private Function GetLargeSize(ByVal lHi As Long, ByVal lLo As Long) As Currency
    Dim lMask As Long
    Dim vResult As Variant
    Dim vMult As Variant
    Dim vHibitValue As Variant
    
    ' Multiplikator zum Bitschieben
    vMult = CDec(2 ^ 32)
    ' Bitmaske zum Ausblenden des HiBit
    lMask = &H7FFFFFFF
    ' Summand fuer das ausgeblendete Bit, das
    'spaeter wieder addiert werden muss
    vHibitValue = CDec(2 ^ 31)
    
    If lHi < 0 Then
        vResult = (CDec((lHi And lMask)) + vHibitValue) * vMult
    Else
        vResult = CDec(lHi) * vMult
    End If
    
    If lLo < 0 Then
        vResult = vResult + CDec((lLo And lMask)) + vHibitValue
    Else
        vResult = vResult + CDec(lLo)
    End If
    
    GetLargeSize = vResult
End Function

Public Function SafeFileExists(ByVal FilePath As String) As Boolean
    If LenB(FilePath) = 0 Then Exit Function

    On Error GoTo ErrHandler
    
    SafeFileExists = LenB(Dir(FilePath)) > 0
ErrHandler:
End Function

Public Function ApiGetDirectorySize(ByVal DirectoryPath As String, Optional ByVal Extensions As Variant) As Currency
    Dim arrStrFiles() As String
    Dim i As Long
    Dim strDirectoryPath As String
    
    On Error GoTo ErrHandler
    
    arrStrFiles() = ApiFindFilesOrFolders(DirectoryPath, Extensions)
    
    If InStr(1, DirectoryPath, ".") Or InStr(1, DirectoryPath, "*") Then
        strDirectoryPath = ApiAddSlash(ApiGetFilePath(DirectoryPath))
    Else
        strDirectoryPath = ApiAddSlash(DirectoryPath)
    End If
    
    For i = 0 To SafeUBound(arrStrFiles())
        ApiGetDirectorySize = ApiGetDirectorySize + ApiGetFileSize(strDirectoryPath & arrStrFiles(i))
    Next i
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    ApiGetDirectorySize = -1
    
    Exit Function
    Resume
    Resume Next
End Function

Public Function ApiGetDirectory(ByVal CSIDL As SpecialFolder) As String
    Dim R As Long
    Dim typItemIDList As SHITEMID
    Dim FilePath As String
    Dim strOrdner As String
    
    Select Case CSIDL
        Case SpecialFolder.CSIDL_QUICKLAUNCH
            ApiGetDirectory = Environ$("APPDATA") & "\Microsoft\Internet Explorer\Quick Launch\"
        Case CSIDL_SYSTEM
            ApiGetDirectory = ApiGetSysDir()
        Case SpecialFolder.CSIDL_WINDOWS
            ApiGetDirectory = ApiGetWinDir()
        Case Else
            If SHGetSpecialFolderLocation(100, CSIDL, typItemIDList) = 0 Then
                FilePath = Space$(512)
                
                R = SHGetPathFromIDList(ByVal typItemIDList.cb, ByVal FilePath)
                
                FilePath = Left$(FilePath, InStr(FilePath, vbNullChar) - 1)
                
                If Right$(FilePath, 1) <> "\" Then
                    FilePath = FilePath & "\"
                End If
                
                ApiGetDirectory = FilePath
            End If
    End Select
End Function

Public Function ApiGetTempDir() As String
    Dim nBuffer As String
    Dim nReturn As Long
    
    If Len(strGetTempDir) = 0 Then
        nBuffer = Space$(kLength)
        nReturn = GetTempPath(kLength, nBuffer)
        
        If nReturn > 0 Then
            strGetTempDir = Left$(nBuffer, nReturn)
        End If
    End If
    
    ApiGetTempDir = strGetTempDir
End Function

Public Function ApiGetWinDir() As String
    Dim nBuffer As String
    Dim nReturn As Long
    
    If Len(strGetWinDir) = 0 Then
        nBuffer = Space$(kLength)
        nReturn = GetWindowsDirectory(nBuffer, kLength)
        
        If nReturn > 0 Then
            strGetWinDir = Left$(nBuffer, nReturn) & "\"
        End If
    End If
    
    ApiGetWinDir = strGetWinDir
End Function

Public Function ApiFileExists(ByVal FilePath As String, Optional ByVal AllowedFileExtensions As String) As Boolean
    Dim arrFilepathen() As String
    Dim arrAllowedFileExtensions() As String
    Dim i As Long
    Dim u As Long
    
    If Len(FilePath) = 0 Then: Exit Function
    
    If Len(AllowedFileExtensions) > 0 Then
        arrAllowedFileExtensions() = Split(AllowedFileExtensions, ",")
    Else
        arrAllowedFileExtensions() = Split(ApiGetFileExtension(FilePath), ",")
    End If
    
    If ApiIsFolder(FilePath) Then
        If Right$(FilePath, 1) <> "*" Then
            If Right$(FilePath, 1) = "\" Then
                FilePath = FilePath & "*"
            Else
                FilePath = FilePath & "\*"
            End If
        End If
    End If

    u = SafeUBound(arrAllowedFileExtensions(), 1)

    For i = 0 To u
        If Right$(FilePath, 1) = "*" And Len(AllowedFileExtensions) = 0 Then
            arrFilepathen() = ApiFindFilesOrFolders(FilePath)
            
            If ApiBound(arrFilepathen()) > 0 Then
                ApiFileExists = True
                
                Exit For
            End If
        Else
            If Len(Dir(ApiAddSlash(ApiGetFilePath(FilePath)) & ApiGetFileBasename(FilePath) & "." & arrAllowedFileExtensions(i))) > 0 Then
                ApiFileExists = True

                Exit For
            End If
        End If
    Next i
End Function

Public Sub KillFiles( _
        ByVal FilePath As String, _
        Optional ByVal AllowedFileExtensions As String = "*", _
        Optional ByVal DontDeleteFilesWithTheseExtensions As String)
    Dim Elemente() As String
    Dim i As Long
    Dim u As Long
    
    Call ApiAddSlash(FilePath)
    
    AllowedFileExtensions = Replace(AllowedFileExtensions, ".", vbNullString)
    DontDeleteFilesWithTheseExtensions = Replace(DontDeleteFilesWithTheseExtensions, ".", vbNullString)

    If AllowedFileExtensions = "*" Then
        Elemente() = ApiFindFilesOrFolders(FilePath & AllowedFileExtensions)
    Else
        If ApiIsInstrEx(AllowedFileExtensions, ",") Then
            Elemente = ApiFindFilesOrFolders(FilePath, AllowedFileExtensions)
        Else
            Elemente = ApiFindFilesOrFolders(FilePath & "." & AllowedFileExtensions)
        End If
    End If
    
    u = SafeUBound(Elemente())
    
    If u > -1 Then
        For i = 0 To u
            If Len(DontDeleteFilesWithTheseExtensions) = 0 Then
                Call SetAttr(FilePath & Elemente(i), vbNormal)
                Call Kill(FilePath & Elemente(i))
            ElseIf Not ApiIsInstrEx(DontDeleteFilesWithTheseExtensions, ApiGetFileExtension(Elemente(i)), False) Then
                Call SetAttr(FilePath & Elemente(i), vbNormal)
                Call Kill(FilePath & Elemente(i))
            End If
        Next i
    End If
End Sub

