Attribute VB_Name = "mdlString"
Option Explicit

'Public Const vbOneString As String = " "

Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long

Private Const MAX_PATH = 260
Public Const INVALID_HANDLE_VALUE = -1

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Declare Function GetFileAttributes Lib "kernel32.dll" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long

Public Declare Function GetVersionEx Lib "kernel32.dll" Alias "GetVersionExA" ( _
     ByRef lpVersionInformation As OSVERSIONINFO) As Long

Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Declare Function IsBadStringPtrByLong Lib "kernel32" Alias "IsBadStringPtrA" (ByVal lpsz As Long, ByVal ucchMax As Long) As Long

Public Function StringArrayContains(Values() As String, ByRef Match As String) As Boolean '2012-12-28
    Dim i As Long
    
    For i = LBound(Values) To UBound(Values)
        If Values(i) = Match Then
            StringArrayContains = True
            
            Exit Function
        End If
    Next
End Function

Public Function IsNTSystem() As Boolean

  'returns True if running Windows 2000 or later
   Dim OSV As OSVERSIONINFO
   
   Const VER_PLATFORM_WIN32_NT As Long = 2

   OSV.dwOSVersionInfoSize = Len(OSV)

   If GetVersionEx(OSV) = 1 Then
   
      IsNTSystem = (OSV.dwPlatformId = VER_PLATFORM_WIN32_NT) And _
                      (OSV.dwMajorVersion >= 5 And OSV.dwMinorVersion >= 0)
  
   End If

End Function

Public Function StrPositions( _
        ByRef Text As String, _
        Optional ByRef Find As String = "\", _
        Optional ByVal Start As Long = 1, _
        Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
        ) As Long()
        
    Dim Count As Long
    Dim Positions() As Long
    Dim i As Long
    
    Count = ApiStrCount(Text, Find, Start, Compare)
    
    If Count > 0 Then
       ReDim Positions(Count - 1)
        
        For i = 1 To Count
            Positions(i - 1) = InStr(Start, Text, vbTab)
            
            Start = Positions(i - 1) + 1
        Next
    Else
        Call mdlArray.InitArray(Positions, True)
    End If

    StrPositions = Positions
End Function
        
'Public Function MaskPathFolders(ByVal Path As String, Optional ByVal Delimitter As String = "\", Optional ByVal StartAtDelimitterPosition As Long = 1) As String
'    Dim lngStartPosition As Long
'    Dim lngSlashPosition As Long
'    Dim lngAnzahlSlashes As Long
'    Dim lngErsterSlash As Long
'    Dim lngLetzterSlash As Long
'    Dim lngTempWert As Long
'
'    If StartAtDelimitterPosition = 0 Then
'        StartAtDelimitterPosition = 1
'    End If
'
'    lngStartPosition = StartAtDelimitterPosition
'
''    If StartAtDelimitterPosition > 1 Then
''        lngStartPosition = InStr(8, Path, Delimitter)
''    End If
'
'    Do
'        lngTempWert = lngSlashPosition
'
'        lngSlashPosition = InStr(lngStartPosition, Path, Delimitter)
'
'        If lngSlashPosition <> 0 Then
'            lngStartPosition = lngSlashPosition + 1
'            lngAnzahlSlashes = lngAnzahlSlashes + 1
'
'            If lngAnzahlSlashes = 2 Then
'                lngErsterSlash = lngSlashPosition
'            End If
'        Else
'            lngLetzterSlash = lngTempWert
'        End If
'    Loop Until lngSlashPosition = 0
'
'    If lngAnzahlSlashes > 2 Then
'        MaskPathFolders = Left$(Path, lngErsterSlash) & "..." & Mid$(Path, lngLetzterSlash, Len(Path) - lngLetzterSlash + 1)
'    Else
'        MaskPathFolders = Path
'    End If
'End Function

Public Function GetStringPos(ByRef Text As String, ByRef Character As String, Optional ByVal Position As Long = 1) As Long
    Dim i As Long
    Dim lngLastPos As Long
    
    If Position = 0 Then
        Position = Len(Text) \ 2
    End If
    
    Do
        i = InStr(i + 1, Text, Character, vbTextCompare)
        
        If i = Position Then
            GetStringPos = i
            
            Exit Function
        ElseIf i > Position Then
            GetStringPos = lngLastPos
            
            Exit Function
        End If
        
        lngLastPos = i
    Loop
End Function

Public Function SeparateString( _
        ByRef Text As String, _
        Optional ByRef SeparateBySeparator As String, _
        Optional ByVal SeparateInTheMiddle As Boolean _
        ) As String
    Dim lngTemp As Long
    Dim strTemp As String
    
    If SeparateBySeparator <> "-" Then
        strTemp = "- "
    Else
        strTemp = " "
    End If
    
    If Len(SeparateBySeparator) Then
        lngTemp = InStr(1, Text, SeparateBySeparator, vbTextCompare)
        
        If SeparateInTheMiddle And lngTemp > 0 Then
            lngTemp = GetStringPos(Text, SeparateBySeparator, Len(Text) \ 2)
            
            SeparateString = Left$(Text, lngTemp) & strTemp & Mid$(Text, lngTemp + 1)
        Else
            If lngTemp Then
                SeparateString = Left$(Text, lngTemp) & strTemp & Mid$(Text, lngTemp + 1)
            Else
                SeparateString = Text
            End If
        End If
    Else
        If SeparateInTheMiddle Then
            lngTemp = Len(Text) \ 2
        
            SeparateString = Left$(Text, lngTemp) & strTemp & Mid$(Text, lngTemp + 1)
        Else
            SeparateString = Text
        End If
    End If
End Function
        
Public Function ApiUrlHttpCheck(ByRef URL As String) As String
    If Len(URL) Then
        If Left$(URL, 7) <> "http://" And Left$(URL, 6) <> "ftp://" And Not ApiIsInstr(URL, ":") Then
            URL = "http://" & URL
        End If
        
        ApiUrlHttpCheck = URL
    End If
End Function

Public Function ApiGetFolderPathEx(ByVal Path As String, Optional ByVal Directories As Long = -1) As String
    Dim i As Long
    Dim lngStelle As Long
    Dim u As Long
    
    lngStelle = 3
    
    u = ApiStrCount(Path) - 1
    
    If Directories > -1 And (Directories < u) Then
        u = u - 2
        
        For i = 1 To u
            lngStelle = InStr(lngStelle + 1, Path, "\")
        Next i
    Else
        lngStelle = Len(Path)
    End If
    
    ApiGetFolderPathEx = Left$(Path, lngStelle)
End Function

Public Function ApiLeftEx( _
        ByRef Text As String, _
        Optional ByVal Character As String = ".", _
        Optional ByVal EmptyIfNoOccurrence As Boolean, _
        Optional ByVal IncludeDelimitter As Boolean) As String
    If InStr(1, Text, Character, vbTextCompare) > 0 Then
        ApiLeftEx = Left$(Text, InStr(1, Text, Character, vbTextCompare) - IIf(IncludeDelimitter, -1, 1))
    ElseIf EmptyIfNoOccurrence = False Then
        ApiLeftEx = Text
    End If
End Function

Public Function ApiRightEx( _
        ByRef Text As String, _
        Optional ByVal Character As String = ".", _
        Optional ByVal EmptyIfNoOccurrence As Boolean, _
        Optional ByVal IncludeDelimitter As Boolean _
        ) As String
    If InStr(1, Text, Character, vbTextCompare) > 0 Then
        ApiRightEx = Mid$(Text, InStrRev(Text, Character, , vbTextCompare) + IIf(IncludeDelimitter, 0, Len(Character)))
    ElseIf EmptyIfNoOccurrence = False Then
        ApiRightEx = Text
    End If
End Function

Public Function ApiGetFileBasename(ByVal FilePath As String) As String
    If InStrRev(FilePath, ".") > InStrRev(FilePath, "\") Then
        If InStr(FilePath, "\") > 0 Then
            ApiGetFileBasename = Mid$(FilePath, InStrRev(FilePath, "\") + 1, (InStrRev(FilePath, ".") - 1) - InStrRev(FilePath, "\"))
        Else
            ApiGetFileBasename = Mid$(FilePath, 1, InStrRev(FilePath, ".") - 1)
        End If
    Else
        If InStr(FilePath, "\") > 0 Then
            ApiGetFileBasename = Mid$(FilePath, InStrRev(FilePath, "\") + 1)
        Else
            ApiGetFileBasename = FilePath
        End If
    End If
End Function

Public Function ApiGetFileName( _
        ByVal FilePath As String, _
        Optional ByVal Character As String = "\", _
        Optional ByVal WithoutExtension As Boolean _
        ) As String
    
    If ApiIsInstr(FilePath, ".") Then
        If ApiIsInstr(FilePath, Character) Then
            If WithoutExtension Then
                ApiGetFileName = Mid$(FilePath, InStrRev(FilePath, Character) + 1, (InStrRev(FilePath, ".") - 1) - InStrRev(FilePath, Character))
            Else
                ApiGetFileName = Mid$(FilePath, InStrRev(FilePath, Character) + 1)
            End If
        Else
            If WithoutExtension Then
                ApiGetFileName = Mid$(FilePath, 1, InStrRev(FilePath, ".") - 1)
            Else
                ApiGetFileName = FilePath
            End If
        End If
    Else
        If ApiIsInstr(FilePath, Character) And Right$(FilePath, 1) <> "\" And Right$(FilePath, 1) <> "/" Then
            ApiGetFileName = Mid$(FilePath, InStr(1, FilePath, Character) + 1)
        End If
    End If
End Function

Public Function ApiGetFilePath(ByVal FilePath As String, Optional ByVal Character As String = "\", Optional ByVal CharacterAmountPos As Long = 1) As String
    Dim i As Long
    Dim lngStart As Long
    
    On Error GoTo ErrHandler
    
    lngStart = -1
    
    ApiGetFilePath = FilePath
    
    If Len(FilePath) = 0 Then: Exit Function
    
    If CharacterAmountPos = 1 And Not ApiIsFolder(FilePath) And InStr(FilePath, ".") > 0 And InStr(FilePath, "..") = 0 Then
        ApiGetFilePath = Mid$(FilePath, 1, InStrRev(FilePath, "\", Len(FilePath) - 1))
    Else
        If InStr(FilePath, Character) = 0 Then
            If InStr(FilePath, "/") > 0 Then
                Character = "/"
            End If
        End If
        
        If InStr(FilePath, Character) = 0 Then: Exit Function
    
        If Character = "/" Then
            For i = 0 To CharacterAmountPos - 2
                lngStart = InStrRev(FilePath, Character, IIf(i = 0, -1, lngStart - 1))
            Next i
            
            If lngStart = 0 Then
                lngStart = Len(FilePath) + 1
            End If
            
            ApiGetFilePath = Left$(FilePath, lngStart - 1)
        Else
            For i = 0 To CharacterAmountPos - 1
                lngStart = InStrRev(FilePath, Character, IIf(i = 0, lngStart, lngStart - 1))
            Next i
            
            ApiGetFilePath = Left$(FilePath, lngStart)
        End If
    End If
    
    ApiGetFilePath = RemoveSlash(ApiGetFilePath)
    
    Exit Function
ErrHandler:
    Debug.Print Err.Description
    Debug.Assert 0
    
    Exit Function
    Resume
End Function

Private Function RemoveSlash(ByVal FilePath As String) As String 'new
    If Right$(FilePath, 1) = "\" Then
        RemoveSlash = Left$(FilePath, InStrRev(FilePath, "\") - 1)
    Else
        RemoveSlash = FilePath
    End If
End Function

Public Function ApiIsInstr(ByVal str1 As String, ByVal str2 As String, Optional ByVal CompareMethod As VbCompareMethod = vbBinaryCompare) As Boolean
    If CompareMethod = vbBinaryCompare Then
        ApiIsInstr = InStr(1, str1, str2, CompareMethod) > 0
    Else
        ApiIsInstr = InStr(1, str1, str2, CompareMethod) > 0
    End If
End Function

Public Function ApiGetFileExtension(ByVal FilePath As String, Optional ByVal IncludeDot As Boolean, Optional ByVal MustBeOneOfTheseExtensions As String) As String
    If InStr(FilePath, ".") > 0 Then
        If InStr(FilePath, ".") <> InStr(FilePath, "..") Then
            ApiGetFileExtension = LCase$(Mid$(FilePath, InStrRev(FilePath, ".") + IIf(IncludeDot, 0, 1)))
        End If
    End If

    If Len(MustBeOneOfTheseExtensions) > 0 Then
        If Len(ApiGetFileExtension) > 0 Then
            If InStr(MustBeOneOfTheseExtensions, IIf(IncludeDot, Mid$(ApiGetFileExtension, 2), ApiGetFileExtension)) > 0 Then
                ApiGetFileExtension = "1"
            Else
                ApiGetFileExtension = "-1"
            End If
        Else
            ApiGetFileExtension = "-1"
        End If
    End If
End Function

Public Function ApiAddSlash(ByRef FilePath As String, Optional ByVal Character As String = "\", Optional ByVal TreatAlwaysAsAFolder As Boolean) As String
    If ApiIsFolder(FilePath) Or TreatAlwaysAsAFolder Then
        If Right$(FilePath, 1) <> Character And Right$(FilePath, 1) <> "*" Then
            FilePath = FilePath & Character
        End If
    End If
    
    ApiAddSlash = FilePath
End Function

Public Function ApiFindFilesOrFolders( _
        ByVal FilePath As String, _
        Optional ByVal Extensions As Variant, _
        Optional ByVal OnlyDirectories As Boolean _
        ) As String()
    Dim lngRueckgabeWert As Long
    Dim arrFilePath() As String
    Dim typFound As WIN32_FIND_DATA
    Dim hFile As Long
    Dim i As Long
    Dim strTempDateiName As String
    Dim boolUseExtensions As Boolean
    
    If SafeIsMissing(Extensions) = False Then
        If IsEmpty(Extensions) = False Then
            If IsArray(Extensions) = False Then
                If VarType(Extensions) = vbString Then
                    Extensions = Split(Extensions, ",")
                End If
            End If
        End If
    End If

    If InStr(FilePath, "*") = 0 Then
        If ApiGetFileExtension(FilePath, , "ace,zip,rar") = "-1" Then
            If ApiIsFolder(FilePath) Then
                Call ApiAddSlash(FilePath)
            
                FilePath = FilePath & "*"
            End If
        End If
    End If
    
    boolUseExtensions = SafeIsMissing(Extensions) = False
    
    hFile = FindFirstFile(FilePath, typFound)
    
    If hFile = INVALID_HANDLE_VALUE Then
        Call InitArray(ApiFindFilesOrFolders)
    
        Exit Function
    End If
    
    arrFilePath = Split(vbNullString)
    Dim BasePath As String
    BasePath = ApiGetFilePath(FilePath)
      
    If hFile <> -1 Then
        Do
            Select Case CBool(typFound.dwFileAttributes And vbDirectory)
                Case Not OnlyDirectories
                    GoTo GueltigeDatei
                Case Else
                    strTempDateiName = Left$(typFound.cFileName, InStr(1, typFound.cFileName, vbNullChar) - 1)
                    
                    If OnlyDirectories Then
                        Select Case strTempDateiName
                            Case "..", "."
                                GoTo GueltigeDatei
                        End Select
                    Else
                        If LCase$(strTempDateiName) = "thumbs.db" Then GoTo GueltigeDatei
                    
                        If boolUseExtensions Then
                            If UBound(Filter(Extensions, ApiGetFileExtension(strTempDateiName), , vbTextCompare)) = -1 Then
                                GoTo GueltigeDatei
                            End If
                        End If
                    End If
                    
                    ReDim Preserve arrFilePath(i) As String
                
                    arrFilePath(i) = PathCombine(Array(BasePath, strTempDateiName))
                    
                    i = i + 1
            End Select
            
GueltigeDatei:
                                             
            lngRueckgabeWert = FindNextFile(hFile, typFound)
            
'            DoEvents
        Loop Until lngRueckgabeWert = 0
    End If
     
    Call FindClose(hFile)
    
Ende:
    
    ApiFindFilesOrFolders = arrFilePath()
    
    Call InitArray(ApiFindFilesOrFolders)
End Function

Public Function ApiIsFolder(ByVal FilePath As String) As Boolean
    ApiIsFolder = (GetFileAttributes(FilePath) And vbDirectory) = vbDirectory And GetFileAttributes(FilePath) > -1
End Function

Public Function IsUniCode(ByVal Str As String) As Boolean
    If Len(Str) > 0 Then
        If AscB(MidB(Str, 2, 1)) = 0 Then
            IsUniCode = True
        End If
    End If
End Function

Public Function ApiIsInstrEx(ByVal StringToCheck As String, Optional ByVal StringToSearch As String = "\", _
        Optional ByVal CompareEachTermSeparately As Boolean, Optional ByRef FoundSearchTerm As String, _
        Optional ByVal CompareMethod As VbCompareMethod = vbTextCompare, Optional ByVal ReturnFalseIfEmptyString As Boolean = True) As Boolean
    Dim arrStringToSearche() As String
    Dim p As Long
    Dim arrStrEndungen() As String
    Dim u As Long
    
    If (Len(StringToCheck) = 0 And Not ReturnFalseIfEmptyString) Or Len(StringToSearch) = 0 Then
        ApiIsInstrEx = True
    
        Exit Function
    End If
    
    FoundSearchTerm = vbNullString

    If CompareEachTermSeparately Then
        arrStrEndungen() = Split(Trim$(Replace(StringToSearch, vbCrLf, "")), ",")
        
        u = UBound(arrStrEndungen(), 1)
        
        For p = 0 To u
            FoundSearchTerm = vbNullString
        
            If InStrRev(StringToCheck, arrStrEndungen(p), , CompareMethod) Then
                FoundSearchTerm = arrStrEndungen(p)
                
                ApiIsInstrEx = True
                
                Exit For
            End If
        Next p
    Else
        If InStrRev(StringToCheck, StringToSearch, , CompareMethod) Then
            ApiIsInstrEx = True
            
            FoundSearchTerm = StringToSearch
        End If
    End If
End Function

Public Function ApiStrRepeat(ByVal Count As Long, ByRef Text As String) As String
   Dim lLength As Long

   If Count > 0 Then
      lLength = Len(Text)
      
      If lLength > 1 Then
         If Count > 1 Then
            ApiStrRepeat = Space$(lLength * Count)
            
            Mid$(ApiStrRepeat, 1) = Text
            Mid$(ApiStrRepeat, lLength + 1) = ApiStrRepeat
         ElseIf Count = 1 Then
            ApiStrRepeat = Text
         End If
      ElseIf lLength = 1 Then
         ApiStrRepeat = String$(Count, Text)
      End If
   End If
End Function

Public Static Function ApiStrCount( _
    ByRef Text As String, _
    Optional ByRef Find As String = "\", _
    Optional ByVal Start As Long = 1, _
    Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
  ) As Long
' by Jost Schwider, jost@schwider.de, 20010912, rev 001 20011121
  Const MODEMARGIN = 8
  Dim TextAsc() As Integer
  Dim TextData As Long
  Dim TextPtr As Long
  Dim FindAsc(0 To MODEMARGIN) As Integer
  Dim FindLen As Long
  Dim FindChar1 As Integer
  Dim FindChar2 As Integer
  Dim i As Long

  If Compare = vbBinaryCompare Then
    FindLen = Len(Find)
    If FindLen Then
      'Ersten Treffer bestimmen:
      If Start < 2 Then
        Start = InStrB(1, Text, Find)
      Else
        Start = InStrB(Start + Start - 1, Text, Find)
      End If

      If Start Then
        ApiStrCount = 1
        If FindLen <= MODEMARGIN Then

          If TextPtr = 0 Then
            'TextAsc-Array vorbereiten:
            ReDim TextAsc(1 To 1)
            TextData = VarPtr(TextAsc(1))
            RtlMoveMemory TextPtr, ByVal VarPtrArray(TextAsc), 4
            TextPtr = TextPtr + 12
          End If

          'TextAsc-Array initialisieren:
          RtlMoveMemory ByVal TextPtr, ByVal VarPtr(Text), 4 'pvData
          RtlMoveMemory ByVal TextPtr + 4, Len(Text), 4      'nElements

          Select Case FindLen
          Case 1

            'Das Zeichen buffern:
            FindChar1 = AscW(Find)

            'Zhlen:
            For Start = Start \ 2 + 2 To Len(Text)
              If TextAsc(Start) = FindChar1 Then
                ApiStrCount = ApiStrCount + 1
            End If
            Next Start

          Case 2

            'Beide Zeichen buffern:
            FindChar1 = AscW(Find)
            FindChar2 = AscW(Right$(Find, 1))

            'Zhlen:
            For Start = Start \ 2 + 3 To Len(Text) - 1
              If TextAsc(Start) = FindChar1 Then
                If TextAsc(Start + 1) = FindChar2 Then
                  ApiStrCount = ApiStrCount + 1
                  Start = Start + 1
                End If
              End If
            Next Start

          Case Else

            'FindAsc-Array fllen:
            RtlMoveMemory ByVal VarPtr(FindAsc(0)), ByVal StrPtr(Find), FindLen + FindLen
            FindLen = FindLen - 1

            'Die ersten beiden Zeichen buffern:
            FindChar1 = FindAsc(0)
            FindChar2 = FindAsc(1)

            'Zhlen:
            For Start = Start \ 2 + 2 + FindLen To Len(Text) - FindLen
              If TextAsc(Start) = FindChar1 Then
                If TextAsc(Start + 1) = FindChar2 Then
                  For i = 2 To FindLen
                    If TextAsc(Start + i) <> FindAsc(i) Then Exit For
                  Next i
                  If i > FindLen Then
                    ApiStrCount = ApiStrCount + 1
                    Start = Start + FindLen
                  End If
                End If
              End If
            Next Start

          End Select

          'TextAsc-Array restaurieren:
          RtlMoveMemory ByVal TextPtr, TextData, 4 'pvData
          RtlMoveMemory ByVal TextPtr + 4, 1&, 4   'nElements

        Else

          'Konventionell Zhlen:
          FindLen = FindLen + FindLen
          Start = InStrB(Start + FindLen, Text, Find)
          Do While Start
            ApiStrCount = ApiStrCount + 1
            Start = InStrB(Start + FindLen, Text, Find)
          Loop

        End If 'FindLen <= MODEMARGIN
      End If 'Start
    End If 'FindLen
  Else
    'Gro-/Kleinschreibung ignorieren:
    ApiStrCount = ApiStrCount(LCase$(Text), LCase$(Find), Start)
  End If
End Function

Public Function ApiInStrLike( _
    ByVal Text As String, _
    ByVal Pattern As String, _
    Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
  ) As Long
  Dim MinPos As Long
  Dim MaxPos As Long
  Dim Pivot As Long

  If Len(Pattern) Then
  
    'Ggf. Gro-/Kleinschreibung ignorieren:
    If Compare = vbTextCompare Then
      Text = LCase$(Text)
      Pattern = LCase$(Pattern)
    End If
    
    'Suchpattern erweitern:
    Pattern = "*" & Pattern & "*"
    
    'Binre Suche durchfhren:
    MinPos = 1
    MaxPos = Len(Text)
    Do Until MinPos > MaxPos
      Pivot = (MinPos + MaxPos) \ 2
      If Mid$(Text, Pivot) Like Pattern Then
        'Treffer merken:
        ApiInStrLike = Pivot
        MinPos = Pivot + 1
      Else
        MaxPos = Pivot - 1
      End If
    Loop
  
  End If 'Len(Pattern)
End Function

Public Static Sub ReplaceBin0(ByRef Result As String, _
    ByRef Text As String, ByRef Search As String, _
    ByRef sOld As String, ByRef sNew As String, _
    ByVal Start As Long, ByVal Count As Long _
  )

  Dim TextLen As Long
  Dim OldLen As Long
  Dim NewLen As Long
  Dim ReadPos As Long
  Dim WritePos As Long
  Dim CopyLen As Long
  Dim buffer As String
  Dim BufferLen As Long
  Dim BufferPosNew As Long
  Dim BufferPosNext As Long

  'Ersten Treffer bestimmen:
  If Start < 2 Then
    Start = InStr(Search, sOld)
  Else
    Start = InStr(Start, Search, sOld)
  End If
  
  If Start Then
  
    OldLen = Len(sOld)
    NewLen = Len(sNew)
    Select Case NewLen
    Case OldLen 'einfaches berschreiben:
    
      Result = Text
      For Count = 1 To Count
        Mid$(Result, Start) = sNew
        Start = InStr(Start + OldLen, Search, sOld)
        If Start = 0 Then Exit Sub
      Next Count
      Exit Sub
    
    Case Is < OldLen 'Ergebnis wird krzer:
    
      'Buffer initialisieren:
      TextLen = Len(Text)
      If TextLen > BufferLen Then
        buffer = Text
        BufferLen = TextLen
      End If
      
      'Ersetzen:
      ReadPos = 1
      WritePos = 1
      If NewLen Then
      
        'Einzufgenden Text beachten:
        For Count = 1 To Count
          CopyLen = Start - ReadPos
          If CopyLen Then
            BufferPosNew = WritePos + CopyLen
            Mid$(buffer, WritePos) = Mid$(Text, ReadPos, CopyLen)
            Mid$(buffer, BufferPosNew) = sNew
            WritePos = BufferPosNew + NewLen
          Else
            Mid$(buffer, WritePos) = sNew
            WritePos = WritePos + NewLen
          End If
          ReadPos = Start + OldLen
          Start = InStr(ReadPos, Search, sOld)
          If Start = 0 Then Exit For
        Next Count
      
      Else
      
        'Einzufgenden Text ignorieren (weil leer):
        For Count = 1 To Count
          CopyLen = Start - ReadPos
          If CopyLen Then
            Mid$(buffer, WritePos) = Mid$(Text, ReadPos, CopyLen)
            WritePos = WritePos + CopyLen
          End If
          ReadPos = Start + OldLen
          Start = InStr(ReadPos, Search, sOld)
          If Start = 0 Then Exit For
        Next Count
      
      End If
      
      'Ergebnis zusammenbauen:
      If ReadPos > TextLen Then
        Result = Left$(buffer, WritePos - 1)
      Else
        Mid$(buffer, WritePos) = Mid$(Text, ReadPos)
        Result = Left$(buffer, WritePos + Len(Text) - ReadPos)
      End If
      Exit Sub
    
    Case Else 'Ergebnis wird lnger:
    
      'Buffer initialisieren:
      TextLen = Len(Text)
      BufferPosNew = TextLen + NewLen
      If BufferPosNew > BufferLen Then
        buffer = Space$(BufferPosNew)
        BufferLen = Len(buffer)
      End If
      
      'Ersetzung:
      ReadPos = 1
      WritePos = 1
      For Count = 1 To Count
        CopyLen = Start - ReadPos
        If CopyLen Then
          'Positionen berechnen:
          BufferPosNew = WritePos + CopyLen
          BufferPosNext = BufferPosNew + NewLen
          
          'Ggf. Buffer vergrern:
          If BufferPosNext > BufferLen Then
            buffer = buffer & Space$(BufferPosNext)
            BufferLen = Len(buffer)
          End If
          
          'String "patchen":
          Mid$(buffer, WritePos) = Mid$(Text, ReadPos, CopyLen)
          Mid$(buffer, BufferPosNew) = sNew
        Else
          'Position bestimmen:
          BufferPosNext = WritePos + NewLen
          
          'Ggf. Buffer vergrern:
          If BufferPosNext > BufferLen Then
            buffer = buffer & Space$(BufferPosNext)
            BufferLen = Len(buffer)
          End If
          
          'String "patchen":
          Mid$(buffer, WritePos) = sNew
        End If
        WritePos = BufferPosNext
        ReadPos = Start + OldLen
        Start = InStr(ReadPos, Search, sOld)
        If Start = 0 Then Exit For
      Next Count
      
      'Ergebnis zusammenbauen:
      If ReadPos > TextLen Then
        Result = Left$(buffer, WritePos - 1)
      Else
        BufferPosNext = WritePos + TextLen - ReadPos
        If BufferPosNext < BufferLen Then
          Mid$(buffer, WritePos) = Mid$(Text, ReadPos)
          Result = Left$(buffer, BufferPosNext)
        Else
          Result = Left$(buffer, WritePos - 1) & Mid$(Text, ReadPos)
        End If
      End If
      Exit Sub
    
    End Select
  
  Else 'Kein Treffer:
    Result = Text
  End If

End Sub

Public Static Sub ReplaceBin(ByRef Result As String, _
    ByRef Text As String, ByRef Search As String, _
    ByRef sOld As String, ByRef sNew As String, _
    ByVal Start As Long, ByVal Count As Long _
  )

  Dim TextLen As Long
  Dim OldLen As Long
  Dim NewLen As Long
  Dim ReadPos As Long
  Dim WritePos As Long
  Dim CopyLen As Long
  Dim buffer As String
  Dim BufferLen As Long
  Dim BufferPosNew As Long
  Dim BufferPosNext As Long

  'Ersten Treffer bestimmen:
  If Start < 2 Then
    Start = InStrB(Search, sOld)
  Else
    Start = InStrB(Start + Start - 1, Search, sOld)
  End If
  If Start Then
  
    OldLen = LenB(sOld)
    NewLen = LenB(sNew)
    Select Case NewLen
    Case OldLen 'einfaches berschreiben:
    
      Result = Text
      For Count = 1 To Count
        MidB$(Result, Start) = sNew
        Start = InStrB(Start + OldLen, Search, sOld)
        If Start = 0 Then Exit Sub
      Next Count
      Exit Sub
    
    Case Is < OldLen 'Ergebnis wird krzer:
    
      'Buffer initialisieren:
      TextLen = LenB(Text)
      If TextLen > BufferLen Then
        buffer = Text
        BufferLen = TextLen
      End If
      
      'Ersetzen:
      ReadPos = 1
      WritePos = 1
      If NewLen Then
      
        'Einzufgenden Text beachten:
        For Count = 1 To Count
          CopyLen = Start - ReadPos
          If CopyLen Then
            BufferPosNew = WritePos + CopyLen
            MidB$(buffer, WritePos) = MidB$(Text, ReadPos, CopyLen)
            MidB$(buffer, BufferPosNew) = sNew
            WritePos = BufferPosNew + NewLen
          Else
            MidB$(buffer, WritePos) = sNew
            WritePos = WritePos + NewLen
          End If
          ReadPos = Start + OldLen
          Start = InStrB(ReadPos, Search, sOld)
          If Start = 0 Then Exit For
        Next Count
      
      Else
      
        'Einzufgenden Text ignorieren (weil leer):
        For Count = 1 To Count
          CopyLen = Start - ReadPos
          If CopyLen Then
            MidB$(buffer, WritePos) = MidB$(Text, ReadPos, CopyLen)
            WritePos = WritePos + CopyLen
          End If
          ReadPos = Start + OldLen
          Start = InStrB(ReadPos, Search, sOld)
          If Start = 0 Then Exit For
        Next Count
      
      End If
      
      'Ergebnis zusammenbauen:
      If ReadPos > TextLen Then
        Result = LeftB$(buffer, WritePos - 1)
      Else
        MidB$(buffer, WritePos) = MidB$(Text, ReadPos)
        Result = LeftB$(buffer, WritePos + LenB(Text) - ReadPos)
      End If
      Exit Sub
    
    Case Else 'Ergebnis wird lnger:
    
      'Buffer initialisieren:
      TextLen = LenB(Text)
      BufferPosNew = TextLen + NewLen
      If BufferPosNew > BufferLen Then
        buffer = Space$(BufferPosNew)
        BufferLen = LenB(buffer)
      End If
      
      'Ersetzung:
      ReadPos = 1
      WritePos = 1
      For Count = 1 To Count
        CopyLen = Start - ReadPos
        If CopyLen <> 0 Then
          'Positionen berechnen:
          BufferPosNew = WritePos + CopyLen
          BufferPosNext = BufferPosNew + NewLen
          
          'Ggf. Buffer vergrern:
          If BufferPosNext > BufferLen Then
            buffer = buffer & Space$(BufferPosNext)
            BufferLen = LenB(buffer)
          End If
          
          'String "patchen":
          MidB$(buffer, WritePos) = MidB$(Text, ReadPos, CopyLen)
          MidB$(buffer, BufferPosNew) = sNew
        Else
          'Position bestimmen:
          BufferPosNext = WritePos + NewLen
          
          'Ggf. Buffer vergrern:
          If BufferPosNext > BufferLen Then
            buffer = buffer & Space$(BufferPosNext)
            BufferLen = LenB(buffer)
          End If
          
          'String "patchen":
          MidB$(buffer, WritePos) = sNew
        End If
        WritePos = BufferPosNext
        ReadPos = Start + OldLen
        Start = InStrB(ReadPos, Search, sOld)
        If Start = 0 Then Exit For
      Next Count
      
      'Ergebnis zusammenbauen:
      If ReadPos > TextLen Then
        Result = LeftB$(buffer, WritePos - 1)
      Else
        BufferPosNext = WritePos + TextLen - ReadPos
        If BufferPosNext < BufferLen Then
          MidB$(buffer, WritePos) = MidB$(Text, ReadPos)
          Result = LeftB$(buffer, BufferPosNext)
        Else
          Result = LeftB$(buffer, WritePos - 1) & MidB$(Text, ReadPos)
        End If
      End If
      Exit Sub
    
    End Select
  
  Else 'Kein Treffer:
    Result = Text
  End If

End Sub

