Attribute VB_Name = "mdlVersion"
Option Explicit

Public Const vbNoVersion As String = "0.0.0.0"

Private Declare Function GetFileVersionInfo Lib "Version.dll" Alias "GetFileVersionInfoA" ( _
        ByVal lptstrFilename As String, _
        ByVal dwhandle As Long, _
        ByVal dwlen As Long, _
        lpData As Any) As Long

Private Declare Function GetFileVersionInfoSize Lib "Version.dll" Alias "GetFileVersionInfoSizeA" ( _
        ByVal lptstrFilename As String, _
        lpdwHandle As Long) As Long

Private Declare Function VerQueryValue Lib "Version.dll" Alias "VerQueryValueA" ( _
        pBlock As Any, _
        ByVal lpSubBlock As String, _
        lplpBuffer As Long, _
        puLen As Long) As Long

Private Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" ( _
        ByVal lpStringToCheck As Any, _
        ByVal lpStringToSearch As Any) As Long

Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
        dest As Any, _
        ByVal Source As Long, _
        ByVal Length As Long)

Private Type VS_FIXEDFILEINFO
    dwSignature As Long
    dwStrucVersionl As Integer
    dwStrucVersionh As Integer
    dwFileVersionMSl As Integer
    dwFileVersionMSh As Integer
    dwFileVersionLSl As Integer
    dwFileVersionLSh As Integer
    dwProductVersionMSl As Integer
    dwProductVersionMSh As Integer
    dwProductVersionLSl As Integer
    dwProductVersionLSh As Integer
    dwFileFlagsMask As Long
    dwFileFlags As Long
    dwFileOS As Long
    dwFileType As Long
    dwFileSubtype As Long
    dwFileDateMS As Long
    dwFileDateLS As Long
End Type

Private Const VS_FFI_SIGNATURE = &HFEEF04BD
Private Const VS_FFI_STRUCVERSION = &H10000
Private Const VS_FFI_FILEFLAGSMASK = &H3F&

Private Const VS_FF_DEBUG = &H1
Private Const VS_FF_PRERELEASE = &H2
Private Const VS_FF_PATCHED = &H4
Private Const VS_FF_PRIVATEBUILD = &H8
Private Const VS_FF_INFOINFERRED = &H10
Private Const VS_FF_SPECIALBUILD = &H20

Private Const VOS_UNKNOWN = &H0
Private Const VOS_DOS = &H10000
Private Const VOS_OS216 = &H20000
Private Const VOS_OS232 = &H30000
Private Const VOS_NT = &H40000
Private Const VOS__BASE = &H0
Private Const VOS__WINDOWS16 = &H1
Private Const VOS__PM16 = &H2
Private Const VOS__PM32 = &H3
Private Const VOS__WINDOWS32 = &H4

Private Const VOS_DOS_WINDOWS16 = &H10001
Private Const VOS_DOS_WINDOWS32 = &H10004
Private Const VOS_OS216_PM16 = &H20002
Private Const VOS_OS232_PM32 = &H30003
Private Const VOS_NT_WINDOWS32 = &H40004

Private Const VFT_UNKNOWN = &H0
Private Const VFT_APP = &H1
Private Const VFT_DLL = &H2
Private Const VFT_DRV = &H3
Private Const VFT_FONT = &H4
Private Const VFT_VXD = &H5
Private Const VFT_STATIC_LIB = &H7

Private Const VFT2_UNKNOWN = &H0
Private Const VFT2_DRV_PRINTER = &H1
Private Const VFT2_DRV_KEYBOARD = &H2
Private Const VFT2_DRV_LANGUAGE = &H3
Private Const VFT2_DRV_DISPLAY = &H4
Private Const VFT2_DRV_MOUSE = &H5
Private Const VFT2_DRV_NETWORK = &H6
Private Const VFT2_DRV_SYSTEM = &H7
Private Const VFT2_DRV_INSTALLABLE = &H8
Private Const VFT2_DRV_SOUND = &H9
Private Const VFT2_DRV_COMM = &HA

Private Const VFT2_FONT_RASTER = &H1
Private Const VFT2_FONT_VECTOR = &H2
Private Const VFT2_FONT_TRUETYPE = &H3

Private Const MAX_PATH = 260

Private Const OF_READ As Long = &H0&
Private Const OF_WRITE As Long = &H1&
Private Const OFS_MAXPATHNAME As Long = 128&

Private Declare Function SetFileTime Lib "kernel32" (ByVal _
        hFile As Long, lpCreationTime As FILETIME, _
        lpLastAccessTime As FILETIME, lpLastWriteTime As _
        FILETIME) As Long
        
Private Declare Function FileTimeToSystemTime Lib "kernel32" _
        (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) _
        As Long

Private Declare Function SystemTimeToFileTime Lib "kernel32" _
        (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) _
        As Long

Private Declare Function LocalFileTimeToFileTime Lib "kernel32.dll" _
        (lpLocalFileTime As FILETIME, lpFileTime As FILETIME) As Long

Private Declare Function GetFileTime Lib "kernel32" _
        (ByVal hFile As Long, lpCreationTime As FILETIME, _
        lpLastAccessTime As FILETIME, lpLastWriteTime _
        As FILETIME) As Long

Private Declare Function OpenFile Lib "kernel32" (ByVal _
        lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal _
        wStyle As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" _
        (ByVal hObject As Long) As Long
        
Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" ( _
     ByVal lpFileName As String, _
     ByVal dwDesiredAccess As Long, _
     ByVal dwShareMode As Long, _
     ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, _
     ByVal dwCreationDisposition As Long, _
     ByVal dwFlagsAndAttributes As Long, _
     ByVal hTemplateFile As Long) As Long
     
Private Const FILE_FLAG_BACKUP_SEMANTICS As Long = &H2000000
     
Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Function GetVersionInfoStrings(ByVal FileName As String, InfoStrings As Variant) As String()
    Dim buffer As String
    Dim rc As Long
    Dim lBufferLen As Long
    Dim lDummy As Long
    Dim sBuffer() As Byte
    Dim varProps() As String
    Dim lVerPointer As Long
    
'    Filename = "D:\Kanzleimanager\System\MessageWindow.exe"
    
    lBufferLen = GetFileVersionInfoSize(FileName, lDummy)
    
    If lBufferLen < 1 Then
        Err.Raise vbObjectError, , "No Version Info available!"
    End If
    
    ReDim sBuffer(lBufferLen)
    
    rc = GetFileVersionInfo(FileName, 0&, lBufferLen, sBuffer(0))
    
    If rc = 0 Then
        Err.Raise vbObjectError, , "GetFileVersionInfo failed."
    End If
    
    rc = VerQueryValue(sBuffer(0), _
                      "\VarFileInfo\Translation", _
                      lVerPointer, _
                      lBufferLen)
    
    If rc = 0 Then
       Err.Raise vbObjectError, , "VerQueryValue failed."
    End If
    
    'lVerPointer is a pointer to four 4 bytes of Hex number,
    'first two bytes are language id, and last two bytes are code
    'page. However, Lang_Charset_String needs a  string of
    '4 hex digits, the first two characters correspond to the
    'language id and last two the last two character correspond
    'to the code page id.
    
    Dim bytebuffer(255) As Byte
    
    Call MoveMemory(bytebuffer(0), lVerPointer, lBufferLen)
    
    Dim Lang_Charset_String As String
    Dim HexNumber As Long
    
    HexNumber = bytebuffer(2) + (bytebuffer(3) * &H100) + (bytebuffer(0) * &H10000) + (bytebuffer(1) * &H1000000)
    Lang_Charset_String = Hex$(HexNumber)
    
    'now we change the order of the language id and code page
    'and convert it into a string representation.
    'For example, it may look like 040904E4
    'Or to pull it all apart:
    '04------        = SUBLANG_ENGLISH_USA
    '--09----        = LANG_ENGLISH
    ' ----04E4 = 1252 = Codepage for Windows:Multilingual
    
    Do While Len(Lang_Charset_String) < 8
       Lang_Charset_String = "0" & Lang_Charset_String
    Loop

    Dim i As Integer
    Dim strTemp As String
    
    ReDim varProps(UBound(InfoStrings))
    
    For i = 0 To UBound(InfoStrings)
        buffer = String$(255, 0)
        strTemp = "\StringFileInfo\" & Lang_Charset_String & "\" & InfoStrings(i)
        rc = VerQueryValue(sBuffer(0), strTemp, lVerPointer, lBufferLen)
    
        If rc <> 0 Then
            Call lstrcpy(buffer, lVerPointer)

            varProps(i) = Mid$(buffer, 1, InStr(buffer, Chr(0)) - 1)
        End If
    Next i
    
    GetVersionInfoStrings = varProps
    
'    Dim strVersionInfo(8) As String
'    strVersionInfo(0) = "CompanyName"
'    strVersionInfo(1) = "FileDescription"
'    strVersionInfo(2) = "FileVersion"
'    strVersionInfo(3) = "InternalName"
'    strVersionInfo(4) = "LegalCopyright"
'    strVersionInfo(5) = "OriginalFileName"
'    strVersionInfo(6) = "ProductName"
'    strVersionInfo(7) = "ProductVersion"
'    strVersionInfo(8) = "OLESelfRegister"
End Function

Public Function ApiGetFileDate(ByVal FilePath As String) As FILE_DATE
    Const DTformat As String = "dd.mm.yyyy hh:mm:ss"
    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME
    Dim lTime As FILETIME
    Dim lwTime As FILETIME
    Dim sTime As SYSTEMTIME
    Const GENERIC_READ As Long = &H80000000
    Const OPEN_EXISTING As Long = 3
    Const FILE_SHARE_READ As Long = &H1
    Dim T As SECURITY_ATTRIBUTES
    
    OFS.cBytes = Len(OFS)
'    hFile = OpenFile(FilePath, OFS, OF_READ)
    
    hFile = CreateFile( _
        FilePath, _
        GENERIC_READ, _
        FILE_SHARE_READ, _
        T, _
        OPEN_EXISTING, _
        FILE_FLAG_BACKUP_SEMANTICS, _
        0)

    If hFile > 0 Then
        Call GetFileTime(hFile, cTime, lTime, lwTime)
        
        Call FileTimeToSystemTime(cTime, sTime)
        ApiGetFileDate.DateCreated = Format$(CalcFTime(sTime), DTformat)
        
        Call FileTimeToSystemTime(lTime, sTime)
        ApiGetFileDate.DateLastAccess = Format$(CalcFTime(sTime), DTformat)
         
        Call FileTimeToSystemTime(lwTime, sTime)
        ApiGetFileDate.DateChanged = Format$(CalcFTime(sTime), DTformat)
         
        Call CloseHandle(hFile)
    Else
        Error 0
    End If
End Function

' VersionsInformationen auslesen
Public Function ApiGetFileVersionInformation(ByVal FilePath As String) As FILE_VERSION
    Dim PufferLnge As Long
    Dim Puffer() As Byte
    Dim Pointer As Long
    Dim PointerLnge As Long
    Dim VInfo As VS_FIXEDFILEINFO
    Dim SVer$, FVer$, PVer$, f$, Typ$, STyp$, OS$, Buff() As Byte
    Dim TFileDate As FILE_DATE
    
    If Dir(FilePath) = "" Then
        Error 0
    End If
    
    TFileDate = ApiGetFileDate(FilePath)
    
    ApiGetFileVersionInformation.DateChanged = TFileDate.DateChanged
    ApiGetFileVersionInformation.DateCreated = TFileDate.DateCreated
    
    ' Pfferlnge ermitteln
    PufferLnge = GetFileVersionInfoSize(FilePath, 0&)
    
    ' Keine Versions-Info?
    If PufferLnge < 1 Then: Exit Function
    
    ' Puffer gre ndern
    ReDim Puffer(PufferLnge - 1) As Byte
    
    ' Versions-Info ermitteln
    Call GetFileVersionInfo(FilePath, 0&, PufferLnge, Puffer(0))
    
    ' Pointer VersionsInfo
    Call VerQueryValue(Puffer(0), "\", Pointer, PointerLnge)
    
    ' VersionsInfo in Struktur VInfo kopieren
    Call MoveMemory(VInfo, Pointer, Len(VInfo))

Go_Out:
    
    With ApiGetFileVersionInformation
        With VInfo
            SVer = Format$(.dwStrucVersionh, "00") & "." & _
            Format$(.dwStrucVersionl, "00")
            
            FVer = Format$(.dwFileVersionMSh, "00") & "." & _
            Format$(.dwFileVersionMSl, "00") & "." & _
            Format$(.dwFileVersionLSh, "0000") & "." & Format$(.dwFileVersionLSl, "0000")

            PVer = Format$(.dwProductVersionMSh, "00") & "." & _
            Format$(.dwProductVersionMSl, "00") & "." & _
            Format$(.dwProductVersionLSh, "0000") & "." & Format$(.dwProductVersionLSl, "0000")

            If .dwFileFlags And VS_FF_DEBUG Then: f = "Debug "
            If .dwFileFlags And VS_FF_PRERELEASE Then: f = f & "PreRel "
            If .dwFileFlags And VS_FF_PATCHED Then: f = f & "Patched "
            If .dwFileFlags And VS_FF_PRIVATEBUILD Then: f = f & "Private "
            If .dwFileFlags And VS_FF_INFOINFERRED Then: f = f & "Info "
            If .dwFileFlags And VS_FF_SPECIALBUILD Then: f = f & "Special "
            If .dwFileFlags And VFT2_UNKNOWN Then: f = f & "Unknown "
        End With
        
        Select Case VInfo.dwFileOS
            Case VOS_DOS_WINDOWS16: OS = "DOS-Win16"
            Case VOS_DOS_WINDOWS32: OS = "DOS-Win32"
            Case VOS_OS216_PM16:    OS = "OS/2-16 PM-16"
            Case VOS_OS232_PM32:    OS = "OS/2-16 PM-32"
            Case VOS_NT_WINDOWS32:  OS = "NT-Win32"
            Case VOS_DOS:           OS = "DOS"
            Case VOS_OS216:         OS = "OS216"
            Case VOS_OS232:         OS = "OS232"
            Case VOS_NT:            OS = "NT"
            Case VOS__BASE:         OS = "Unbekannt"
            Case VOS__WINDOWS16:    OS = "WINDOWS16"
            Case VOS__PM16:         OS = "PM16"
            Case VOS__PM32:         OS = "PM32"
            Case VOS__WINDOWS32:    OS = "WINDOWS32"
        End Select
        
        Select Case VInfo.dwFileType
            Case VFT_APP:                       Typ = "Anwendung"
            Case VFT_DLL:                       Typ = "Dynamic Link Library (DLL)"
            Case VFT_DRV:                       Typ = "Gerte Treiber"
                Select Case VInfo.dwFileSubtype
                    Case VFT2_DRV_PRINTER:      STyp = "Printer drv"
                    Case VFT2_DRV_KEYBOARD:     STyp = "Keyboard drv"
                    Case VFT2_DRV_LANGUAGE:     STyp = "Language drv"
                    Case VFT2_DRV_DISPLAY:      STyp = "Display drv"
                    Case VFT2_DRV_MOUSE:        STyp = "Mouse drv"
                    Case VFT2_DRV_NETWORK:      STyp = "Network drv"
                    Case VFT2_DRV_SYSTEM:       STyp = "System drv"
                    Case VFT2_DRV_INSTALLABLE:  STyp = "Installable"
                    Case VFT2_DRV_SOUND:        STyp = "Sound drv"
                    Case VFT2_DRV_COMM:         STyp = "Comm drv"
                    Case VFT2_UNKNOWN:          STyp = "Unknown"
                End Select
            Case VFT_FONT:                      Typ = "Schriftart"
                Select Case VInfo.dwFileSubtype
                    Case VFT2_FONT_RASTER:      STyp = "Raster Font"
                    Case VFT2_FONT_VECTOR:      STyp = "Vector Font"
                    Case VFT2_FONT_TRUETYPE:    STyp = "TrueType Font"
                End Select
            Case VFT_VXD:                       Typ = "Virtueller Gerte Treiber"
            Case VFT_STATIC_LIB:                Typ = "Static Library"
            Case Else:                          Typ = "Unbekannt"
        End Select
          
        .ProductVersion = PVer
        .StructureVersion = SVer
        .Flags = f
        .FileVersion = FVer
        .WindowsVersion = OS
        .FilePath = FilePath
        .FileName = Right$(FilePath, Len(FilePath) - InStrRev(FilePath, "\"))
        
        If Len(STyp) Then
            .FileType = Typ & " " & STyp
        Else
            .FileType = Typ
        End If
    End With
    
    Exit Function
End Function

Private Function CalcFTime(ByRef FTime As SYSTEMTIME) As Date
    Dim Datum As String, Zeit As String, aa As String
    Dim mm As String, ss As String, DT As Date
    Dim Da As String, Mo As String, Ye As String

    With FTime
        Da = .wDay
        If Len(Da) < 2 Then Da = "0" & Da
    
        Mo = .wMonth
        If Len(Mo) < 2 Then Mo = "0" & Mo
    
        Ye = CStr(.wYear)
        Datum = Da & "." & Mo & "." & Ye
    
        mm = Trim$(CStr(.wMinute))
        If Len(mm) < 2 Then mm = "0" & mm
    
        ss = Trim$(CStr(.wSecond))
        If Len(ss) < 2 Then ss = "0" & ss
    
        Zeit = .wHour & ":" & mm & ":" & ss
        DT = CDate(Datum & " " & Zeit)
        CalcFTime = DT
    End With
End Function

Private Function CalcNewfTime(ByVal Datum As String) As FILETIME
    Dim SysT As SYSTEMTIME, FT As FILETIME
    Dim FTL As FILETIME
     
    With SysT
        .wDay = CInt(Left$(Datum, 2))
        .wMonth = CInt(Mid$(Datum, 4, 2))
        .wYear = CInt(Mid$(Datum, 7, 4))
        .wHour = CInt(Mid$(Datum, 12, 2))
        .wMinute = CInt(Mid$(Datum, 15, 2))
        .wSecond = CInt(Mid$(Datum, 18, 2))
    End With
    
    Call SystemTimeToFileTime(SysT, FT)
    
    'Update am  18 August 2003:
    'Nun sollten die ErrHandler mit der Zeitverschiebung verschwunden sein
    Call LocalFileTimeToFileTime(FT, FTL)
    CalcNewfTime = FTL
End Function

Private Function GetRandomDate(ByVal Base As Date) As Date
    Dim aa As String
    
    Do
        aa = ""
        aa = CStr(Int(28 * Rnd) + 1) & "." & _
           CStr(Int(12 * Rnd) + 1) & "." & _
           CStr(Int(10 * Rnd) + 1998) & " " & _
           CStr(Int(24 * Rnd)) & ":" & _
           CStr(Int(60 * Rnd)) & ":" & _
           CStr(Int(60 * Rnd))
    Loop While CDate(aa) < Base
    GetRandomDate = CDate(aa)
End Function


