VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Enumberable"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Function FirstInternal(Enumerable As Variant) As Variant '2015-01-18
    FirstInternal = Null
    
    If IsArray(Enumerable) = False And IsObject(Enumerable) = False Then
        Call Err.Raise(vbObjectError, , "Param must be an enumberable")
    Else
        Dim Item As Variant
        For Each Item In Enumerable
            Call SwapVar(FirstInternal, Item)

            Exit Function
        Next
    End If
End Function

'Public Function Concat(ByVal First As IEnumerable, ByVal Second As IEnumerable) As IEnumerable
'    set Concat = new
'End Function

Public Function Skip(Enumerable As Variant, ByVal Count As Long) As Variant   '2015-03-22
    Dim Result As Variant
    Dim i As Long
    Dim Item As Variant
    
    If IsArray(Enumerable) Then
        Dim SA As SAFE_ARRAY
        SA = GetSafeArrayStruct(Enumerable)
        ReDim Result(0)
        SA.Bounds(0).Count = SA.Bounds(0).Count - Count
    
        Call SetSafeArrayStruct(Result, SA)

        For i = LBound(Enumerable) To SafeUBound(Enumerable) - Count
            Result(i) = Enumerable(i + Count)
        Next
    ElseIf TypeOf Enumerable Is ICollection Then
        Dim ICollection As ICollection
        Set ICollection = Enumerable
    
        ReDim Result(ICollection.Count - 1 - Count)
    
        For Each Item In Enumerable
            If i >= Count Then
                Call SwapVar(Result(i - Count), Item)
            End If
        
            i = i + 1
        Next
    Else
        For Each Item In Enumerable
            If i >= Count Then
                ReDim Preserve Result(i - Count)
            
                Call SwapVar(Result(i - Count), Item)
            End If
        
            i = i + 1
        Next
    End If
    
    Call SwapVar(Skip, Result)
End Function

Public Function First(Enumerable As Variant) As Variant '2015-01-18
    Call SwapVar(First, FirstInternal(Enumerable))
    
    If IsNull(First) Then
        Call Err.Raise(vbObjectError, , "Enumerable must contain at least one element")
    End If
End Function

Public Function AnyElement(Enumerable As Variant) As Boolean '2015-03-23
    Dim First As Variant
    Call SwapVar(First, FirstInternal(Enumerable))
    
    AnyElement = IsNull(First) = False
End Function

Public Function FirstOrDefault(Enumerable As Variant) As Variant '2015-01-18
    Call SwapVar(FirstOrDefault, FirstInternal(Enumerable))
    
    If IsNull(FirstOrDefault) Then
        If IsObject(Enumerable) Then
            Set FirstOrDefault = Nothing
        ElseIf IsArray(Enumerable) Then
            If (VarType(Enumerable) And Not vbArray) = vbObject Then
                Set FirstOrDefault = Nothing
            End If
        End If
    End If
End Function

Public Function SingleOrDefault(Enumerable As Variant) As Variant
    Call SwapVar(SingleOrDefault, SingleElement(Enumerable))
    
    If IsNull(SingleOrDefault) Then
        If IsObject(Enumerable) Then
            Set SingleOrDefault = Nothing
        ElseIf IsArray(Enumerable) Then
            If (VarType(Enumerable) And Not vbArray) = vbObject Then
                Set SingleOrDefault = Nothing
            End If
        End If
    End If
End Function

Private Function SingleElementInternal(Enumerable As Variant) As Variant
    SingleElementInternal = Null

    If IsArray(Enumerable) = False And IsObject(Enumerable) = False Then
        Call Err.Raise(vbObjectError, , "Param must be an enumerable")
    Else
        Dim Item As Variant
        For Each Item In Enumerable
            If IsNull(SingleElementInternal) = False Then
                Call Err.Raise(vbObjectError, , "Enumerable contains more than one element")
            End If

            If IsObject(Item) Then
                Set SingleElementInternal = Item
            Else
                SingleElementInternal = Item
            End If

            Exit Function
        Next
    End If
End Function

Public Function SingleElement(Enumerable As Variant) As Variant
    Call SwapVar(SingleElement, SingleElementInternal(Enumerable))
    
    If IsNull(SingleElement) Then
        Call Err.Raise(vbObjectError, , "Enumerable must contain at least one element")
    End If
End Function
