VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Guid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IEquatable
Implements IComparable
Implements IFormattable

Private Declare Function RtlCompareMemory Lib "ntdll" (ByRef Source1 As Any, ByRef Source2 As Any, ByVal Length As Long) As Long

'Public Type UUID
'    Data1 As Long
'    Data2 As Integer
'    Data3 As Integer
'    Data4(0 To 7) As Byte
'End Type

Private m_EmptyGuid As UUID
Private m_Value As UUID

Public Function IsEmpty() As Boolean
    IsEmpty = RtlCompareMemory(m_Value, m_EmptyGuid, 16) = 16
End Function

Public Property Get Value() As String
Attribute Value.VB_UserMemId = 0
Attribute Value.VB_MemberFlags = "40"
    Value = ToString
End Property

Public Property Let Value(RHS As String)
   Call FromString(RHS)
End Property

'Public Function NewGuid() As Guid
'    Set NewGuid = New Guid
'    NewGuid.Value = CreateGuid
'End Function

'Public Property Get EmptyGuid() As Guid
'    Set EmptyGuid = New Guid
'End Property

Public Function Equals(ByVal g As Guid) As Boolean
    Equals = RtlCompareMemory(m_Value, g.Value, 16) = 16
End Function

Public Function ToString(Optional ByVal Format As String, Optional ByVal FormatProvider As IFormatProvider) As String
    If formatProvider Is Nothing = False Then
        Call Err.Raise(vbObjectError, , "formatProvider is not supported")
    End If

    ToString = ClsIdFromGuid(m_Value)
End Function

'Public Function Parse(ByVal InputString As String) As Guid
'    Call Err.Raise(vbObjectError, , "NotImplementedException")
'End Function
'
'Public Function TryParse(ByVal InputString As String, ByRef Result As Guid) As Boolean
'    Call Err.Raise(vbObjectError, , "NotImplementedException")
'End Function

Public Function ToByteArray() As Byte()
    Dim Bytes() As Byte

    Call MoveMemory(Bytes(0), m_Value, 16)
    
    ToByteArray = Bytes
End Function

Public Sub FromString(ByVal g As String)
    m_Value = GuidFromClsId(g)
End Sub

Public Sub FromArray(b() As Byte)
    If UBound(b) <> 15 Then Call Err.Raise(vbObjectError, , "Array must be of length 16")

    Call MoveMemory(m_Value, b(0), 16)
End Sub

Public Sub FromSegments(ByVal a As Long, ByVal b As Integer, ByVal c As Integer, d() As Byte)
    m_Value.Data1 = a
    m_Value.Data2 = b
    m_Value.Data3 = c
    Call RtlCompareMemory(m_Value.Data4(0), d(0), 8)
End Sub

'Public Sub FromSegments8(ByVal a As Long, ByVal b As Integer, ByVal c As Integer,_
'    ByVal d As Byte, ByVal e As Byte, ByVal f As Byte, ByVal g As Byte, _
'    ByVal h As Byte, ByVal i As Byte, ByVal j As Byte, ByVal k As Byte)
'    Dim Bytes(7) As Byte
'
'    Bytes(0) = d
'    Bytes(1) = e
'    Bytes(2) = f
'    Bytes(3) = g
'    Bytes(4) = h
'    Bytes(5) = i
'    Bytes(6) = j
'    Bytes(7) = k
'
'    Call FromSegments(a, b, c, Bytes)
'End Sub

Private Function CompareTo(ByVal Value As Guid) As Long
    Call Err.Raise(vbObjectError, , "NotSupportedException")
End Function

Private Function IComparable_CompareTo(ByVal Obj As Object) As Long
    IComparable_CompareTo = CompareTo(Obj)
End Function

Private Function IEquatable_Equals(ByVal Other As Object) As Boolean
    IEquatable_Equals = Me.Equals(Other)
End Function

Private Function IFormattable_ToString(ByVal Format As String, ByVal FormatProvider As IFormatProvider) As String
    IFormattable_ToString = ToString(Format, FormatProvider)
End Function
